
'Apertura_Functions.vbs v2

Option Explicit

Dim AFUNCTIONS, strSubDirList, strZipContentList, result, sUserName
Dim NHNProxy, sShareName, bDomain, bServer, sSharePath, sInstallPath, sOracleService, sOracleHost, sOracleClient, TEMP_DIR, OS_Bits
Dim sLDir, sRDir, Script_Name, Script_Path, Return_File, Result_File, Error_File
Dim bDebug, IEtimeOut, cancel

'If InStr(WScript.ScriptName, "AutoAll") = 0 Then Set_A_FUNCTIONS
Set_A_FUNCTIONS

'Inntil videre:
If sSharePath = ScriptPath Then
	If DomainName <> "APERTURA" Then
'		Msg2 "Apertura", "SharePath = ScriptPath. Avbryter.", "W", 10
'		WScript.Quit
	End If
End If

Function Version
	Version = "20.11.2017.1"
End Function

Function Set_A_FUNCTIONS
	On Error Resume Next
	If sUserName = UserName Then Exit Function
	If TypeName(AFUNCTIONS) = "Empty" Then AFUNCTIONS = "A_FUNCTIONS.vbs" 'use default include name if not set
	NHNProxy = "slb.flex-proxy.nhn.no:8080"
	sShareName = "AperturaInstall"
	If ShareProperty(sShareName, "path") <> "" Then sSharePath = "\\" & ComputerName & "\" & sShareName & "\"
	bDomain = IsDomain
	bServer = InStr(OSName(""), "Server") > 0
	SetOracleVariables
	sOracleService = GetEnvVar("USER", "Oracle_Service")
	sOracleHost = GetEnvVar("USER", "Oracle_Host")
	sOracleClient = GetEnvVar("USER", "Oracle_Client")
	If sSharePath = "" Then
		If bServer Then
			ShareCheck
			sSharePath = "\\" & ComputerName & "\" & sShareName & "\"
		ElseIf sOracleHost <> "" Then
			sSharePath = "\\" & sOracleHost & "\" & sShareName & "\"
			If Not DirExists(sSharePath) Then
				Set_A_FUNCTIONS = ExitWithError(True, sShareName & " finnes ikke p " & sOracleHost & ". Avbryter.")
			End If
		Else
			sSharePath = ScriptPath
			'nr oracle klient er installert med angitt server kan orginalt skript slettes og overtas av skript i delt mappe.
		End If
	End If
	sInstallPath = sSharePath & "Pilot_Klient\"
	If Not DirExists("C:\TEMP\") Then CreateDir "C:\TEMP\"
	TEMP_DIR = CreateObject("Scripting.FileSystemObject").GetSpecialFolder(2) & "\"
	OS_Bits = OSBits(".")
	AddTrustedSite sSharePath
	sUserName = UserName
	On Error Goto 0
End Function

'	OracleSetLang

'For Netop
sLDir = sSharePath										'Netop local directory
sRDir = "\\%COMPUTERNAME%\" & sShareName & "\Scripts\"	'Netop remote directory. NB: M settes til "c:\" ved ShareCheck
Script_Name = Split(WScript.ScriptName, "_")(0)
Script_Path = EnvVar("%AppData%\Danware Data\C\Program Files (x86)\Netop\Netop Remote Control\Guest\script\")
Return_File = EnvVar(sRDir & Script_Name & "_Return.txt")
Result_File = sLDir & Script_Name & "_Result.txt"
Error_File = EnvVar(sRDir & Script_Name & "_Error.log")
If DirExists(sRDir) Then TextToFile NHNIP & vbTab, Return_File
'---------

If TypeName(IEtimeOut) = "Empty" Then IEtimeOut = 20
If TypeName(cancel) = "Empty" Then cancel = False

On Error Resume Next
If UCase(WScript.ScriptName) = UCase(AFUNCTIONS) And WScript.Arguments.Count > 0 Then Execute_A_FUNCTIONS_Args
On Error Goto 0

Sub Execute_A_FUNCTIONS_Args
	Dim i, s
	For i = WScript.Arguments.Count To 2 Step - 1
		s = QParam(WScript.Arguments(i - 1)) & ", " & s 'quoted spaces and path
	Next
	If WScript.Arguments.Count > 1 Then s = Left(s, Len(s) - 2)	'fjern siste ", "
	ExecuteGlobal WScript.Arguments(0) & " " & s
End Sub

Function ScriptPath
	ScriptPath = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName, "\"))
End Function

Sub Include(sScriptFile)
	'Laster skript inn i global namespace dersom det ikke allerede er lastet
	Dim s
	If sScriptFile = WScript.ScriptFullName Then Exit Sub
	With CreateObject("Scripting.FileSystemObject")
		s = .GetBaseName(sScriptFile) & "_Loaded"
		If Not Eval(s) Then
			ExecuteGlobal "Dim " & s & ":" & s & " = True"
			With .OpenTextFile(sScriptFile)
				ExecuteGlobal .ReadAll
				.Close
			End With
		End If
	End With
End Sub

Sub Initialize
	Dim sPath
	If Not ShareExists Then ExitWithError True, "Delt mappe finnes ikke"
	CreateDir ShareProperty(sShareName, "path") & "\Scripts\"
	DeleteFile Return_File
End Sub

Sub OracleSetLang
	'Returnerer ProductCode for installert program med angitt DisplayName
	Dim sLang, aKey, aKeys, k, i
'	sLang = "NORWEGIAN_NORWAY.WE8MSWIN1252"
	sLang = "AMERICAN_AMERICA.WE8ISO8859P1"
	'TNS Ping Utility for 32-bit Windows
	'TNS Ping Utility for 64-bit Windows
	aKey = Array("HKLM\SOFTWARE\ORACLE", "HKLM\SOFTWARE\Wow6432Node\ORACLE")
	With CreateObject("WScript.Shell")
		For k = 0 To 1
			If RegKeyExists(aKey(k)) Then
				aKeys = RegSubKeys(aKey(k))
				For i = 0 To UBound(aKeys)
					If InStr(aKeys(i), "KEY_OraClient") Or InStr(aKeys(i), "KEY_Db") Then
						If .RegRead(aKey(k) & "\" & aKeys(i) & "\NLS_LANG") <> sLang Then
							.RegWrite aKey(k) & "\" & aKeys(i) & "\NLS_LANG", sLang
						End If
					End If
				Next
			End If
		Next
	End With
End Sub

Sub ShowMachineInfo
	Dim sCmd, oItem, s
	sCmd = "SELECT * FROM Win32_ComputerSystem"
	For Each oItem In GetObject("winmgmts:\\" & ComputerName & "\root\CIMV2").ExecQuery(sCmd)
		With oItem
			s = s & vbNewLine & "Computer Name: " & .Name
			s = s & vbNewLine & "Name Format: " & .NameFormat
			s = s & vbNewLine & "Domain: " & .Domain
			s = s & vbNewLine & "Part Of Domain: " & .PartOfDomain 'post-Windows 2000 only
			s = s & vbNewLine & "Workgroup: " & .Workgroup 'post-Windows 2000 only
			Select Case .DomainRole
				Case 0 : s = s & vbNewLine & "Domain Role: Standalone Workstation"
				Case 1 : s = s & vbNewLine & "Domain Role: Member Workstation"
				Case 2 : s = s & vbNewLine & "Domain Role: Standalone Server"
				Case 3 : s = s & vbNewLine & "Domain Role: Member Server"
				Case 4 : s = s & vbNewLine & "Domain Role: Backup Domain Controller"
				Case 5 : s = s & vbNewLine & "Domain Role: Primary Domain Controller"
			End Select
			s = s & vbNewLine & "Roles: " & Join(.Roles, ",")
			s = s & vbNewLine & "Network Server Mode Enabled: " & .NetworkServerModeEnabled
		End With
	Next
	MsgBox s : WScript.Quit
End Sub

Sub Pilot_Klient
	EyePrivatInstall
End Sub

Sub Pilot_Test
'	MSUInstall "KB2999226", EnvVar("%LOGONSERVER%\AperturaInstall\Pilot_Klient\MSU\")
	Dim sPath, b
'	WEQ Q(OSVersion(""))
'	sPath = EnvVar("%LOGONSERVER%\AperturaInstall\Pilot_Klient\")
'	WE DotNetInstall("4,5", sPath & "NDP462-KB3151800-x86-x64-AllOS-ENU.exe")
'	Dim sPath
'	sPath = EnvVar("%LOGONSERVER%\AperturaInstall\Pilot_Klient\")
'	With CreateObject("WScript.Shell")
'		.Popup "Starter installasjon av .Net", 5, "Pilot_Test", 64 'OK,info
'	End With
'	With CreateObject("Shell.Application")
'		.ShellExecute "NDP462-KB3151800-x86-x64-AllOS-ENU.exe", "", sPath, "runas", 1
'	End With
'	With CreateObject("WScript.Shell")
'		.Popup "Ferdig!", 60, "Pilot_Test", 64 'OK,info
'	End With
'	OracleSetLang
'	EyePrivatConfig
'	MsgBox OSName("") : WScript.Quit
'	MsgBox Assembly("Oracle.DataAccess", 32)(0) : WScript.Quit
'	ApServicesConfig : WScript.Quit
'	MsgBox OSVersion("") < 6.1 : wq

'	SyncPilotKlient: WScript.Quit
	
'	ShowMachineInfo : WScript.Quit
'	MsgBox EnvVar("%USERDNSDOMAIN%") : WScript.Quit
'	MsgBox Cmd("schtasks /Query /XML /TN SyncPilotKlient") : WScript.Quit

'	MsgBox Cmd("tnsping EYEDB12")
'	b = UAC("")
'	MsgBox "Brukerkontokontroll: " & b
'	If b Then UAC 0 Else UAC 5
'	MsgBox "Brukerkontokontroll: " & UAC("")
'	MsgBox "Administrator: " & IsADM
'	MergeHelsePersonell
'	CreateObject("WScript.Shell").Run """C:\Program Files (x86)\eResept Forskrivningsmodul\FM.Client.App.exe"" -admin"
	MsgBox NetEyeVersions
	MsgBox "Pilot_Test ferdig"
End Sub

Sub EyePrivatInstall
	'sjekker at temp-mappe finnes og oppdaterer EyePrivat
	Dim sFileName, oSh, bUAC, sProdCode, sProgPath, sRegPath
	If Not IsADM Then
		RunScriptElev32 WScript.ScriptFullName & " EyePrivatInstall", False
		WScript.Quit
	ElseIf OSVersion("") < 6.1 Then 
		EyePrivatInstall = ExitWithError(True, "EyePrivat krever Windows 6.1 eller hyere. Avbryter installasjon!")
	End If
	SetOracleVariables
	DotNetInstall "4,5", sInstallPath & "NDP462-KB3151800-x86-x64-AllOS-ENU.exe"
	Msg2 "Apertura", "Installerer EyePrivat...", "I", 0
	sFileName = sInstallPath & "EyePrivat\AperturaEye7.msi"
	If bServer Then
		CreateTestDb
	Else
		bUAC = UAC("") 'brukerkontokontroll
		If bUAC = True Then UAC 0
'		If Not bServer And OSVersion("") = 6.1 Then 'Windows 7
'			sFileName = sInstallPath & "EyePrivat_win7\AperturaEye7.msi"
'		Else
'			sFileName = sInstallPath & "EyePrivat\AperturaEye7.msi"
'		End If
'		WE "FileName: " & sFileName & vbTab & FileExists(sFileName)
		If FileExists(sFileName) Then
			If FileExists(TEMP_DIR & "AperturaEye7.msi") Then DeleteFile TEMP_DIR & "AperturaEye7.msi"
			CopyFile sFileName, TEMP_DIR & "AperturaEye7.msi"
			If Not FileExists(TEMP_DIR & "AperturaEye7.msi") Then
				MsgBox "Finner ikke " & Q(TEMP_DIR & "AperturaEye7.msi") & " Avbryter installasjon!"
				WScript.Quit
			End If
		Else
			MsgBox "Finner ikke " & sFileName & ". Avbryter installasjon!" : WScript.Quit
		End If
'		sRegPath = "\Theriak\eResept Forskrivningsmodul\Client\ServerAddressAndPort"
'		Cmd "reg add " & "\\.\HKLM\SOFTWARE" & sRegPath & " /t Reg_Dword /d " & sOracleHost & ":8903" & " /f"
'		If OS_Bits = 64 Then Cmd "reg add " & "\\.\HKLM\SOFTWARE\WOW6432Node" & sRegPath & " /t Reg_Dword /d " & sOracleHost & ":8903" & " /f"
	End If
	Set oSh = CreateObject("WScript.Shell")
	On Error Resume Next
	KillProc "Eye40.exe"
	sProdCode = ProductCode("EyePrivat")
	If sProdCode <> "" Then
		'Avinstaller EyePrivat
		Msg2 "Apertura", "Avinstallerer EyePrivat...", "I", 0
		If OS_Bits = 64 Then
			sProgPath = EnvVar("%ProgramFiles(x86)%\Apertura\")
		Else
			sProgPath = EnvVar("%ProgramFiles%\Apertura\")
		End If
		oSh.Run "msiexec /x " & sProdCode & " /q", 0, True
		If DirExists(sProgPath) Then
			'flytt EYE40.exe.config til overordnet mappe
			MoveFile sProgPath & "EyePrivat\EYE40.exe.config", UniqueName(sProgPath & "EYE40.exe.config")
			DeleteDir sProgPath & "EyePrivat"
		End If
		Msg2 "Apertura", "Avinstallerer EyePrivat...", "I", ""
	End If
	'Installer ny versjon av EyePrivat
	If bServer Then
		oSh.Run "msiexec /I " & Q(sInstallPath & "EyePrivat\AperturaEye7.msi") & " /q", 0, True
	ElseIf FileExists(TEMP_DIR & "AperturaEye7.msi") Then
		oSh.Run "msiexec /I " & Q(TEMP_DIR & "AperturaEye7.msi") & " /q", 0, True
	Else
		EyePrivatInstall = ExitWithError(True, "Finner ikke " & TEMP_DIR & "AperturaEye7.msi. Avbryter installasjon!")
	End If
	Set oSh = Nothing
	If Err.Number > 0 Then EyePrivatInstall = ExitWithError(True, "EyePrivatInstall: " & Err.Number & " " & Err.Description)
	EyePrivatConfig
'	MSUInstall  "KB2999226", sInstallPath & "MSU\"
	EyePrivatElevated
	If bUAC = True Then UAC 1
	Msg2 "Apertura", "Installerer EyePrivat...", "I", ""
End Sub

Sub EyePrivatElevated
	Dim sFolder, sPath
	If OS_Bits = 64 Then sFolder = "%programfiles(x86)%" Else sFolder = "%programfiles%"
	sPath = EnvVar(sFolder & "\Apertura\EyePrivat\")
	With CreateObject("Shell.Application")
		.ShellExecute "Eye40.exe", "", sPath, "runas", 1
	End With
End Sub

Sub MSUInstall(sKB, ByVal sMSUDir) 'NB: Todo: sjekk om KB er installert
'C:\Users\pc3>wmic qfe get hotfixid | find "KB2999226"
'KB2999226
'
'C:\Users\pc3>
	'Installerer oppdateringspakker med Windows Update Standalone Installer
	'According to http://support.microsoft.com/kb/2773898
	'"Installing an update using WUSA or the WUA APIs on a remote machine is not supported."
	Dim sBits, sMSUFile
	sBits = OS_Bits
	If Right(sMSUDir, 1) <> "\" Then sMSUDir = sMSUDir & "\"
	'Bygg navn p MSU-fil, f.eks: Windows6.1-KB2999226-x64.msu
	sMSUFile = "Windows" & Replace(OSVersion(""), ",", ".") & "-" & sKB & "-x" & Replace(sBits, 32, 86) & ".msu"
	If Not FileExists(sMSUDir & sMSUFile) Then ExitWithError False, "MSUInstall: Finner ikke filen " & sMSUFile & "."
	Msg2 "Apertura", "Installerer " & sKB & "...", "I", 0
	CreateObject("WScript.Shell").Run "wusa.exe " & Q(sMSUDir & sMSUFile) & " /quiet /norestart", 0, True
	Msg2 "Apertura", "Installerer " & sKB & "...", "I", ""
End Sub

Sub CreateTestDb
	Dim sFileName
	If sOracleService = "" Then sOracleService = GetEnvVar("USER", "Oracle_Service")
	If sOracleService = "" Then ExitWithError True, "CreateTestDb: Ingen Oracle_Service"
	On Error Resume Next
	If DirExists("C:\CreateTestDb") Then
		If DirCreated("c:\CreateTestDb") > _
		FileModified(sInstallPath & "Oracle\CreateTestDb.zip") Then
			Exit Sub
		Else
			DeleteDir "C:\CreateTestDb"
		End If
	End If
	sFileName = sInstallPath & "Oracle\CreateTestDb.zip"
	ZipExtract sFileName, "C:\"
	DeleteFile "C:\CreateTestDb\Script.log"
	CurDir "C:\CreateTestDb\"
	Msg2  "Apertura", "Oppdaterer database...", "I", 0
'	CreateObject("WScript.Shell").Run "C:\CreateTestDb\CreateTestDb.cmd", 5, True
	With CreateObject("WScript.Shell")
		.Run "%COMSPEC% /c echo exit|sqlplus sys/Repp3xxx@" & sOracleService & " as sysdba @GrantHl7.sql", 4, True
		.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @script.sql", 4, True
	End With
	Msg2  "Apertura", "Oppdaterer database...", "I", ""
	If Err.Number > 0 Then ExitWithError True, "CreateTestDb: " & Err.Number & " " & Err.Description
End Sub

Sub SetOracleVariables
	'Finn Oracle Service- og Server-navn og legg dem i miljvarabler for bruker: Oracle_Service, Oracle_Host
	'(Windows 10) maskiner m restartes etter installasjon av Oracle klient for tilgang til banen til tnsping i path
	Dim str, sService, sHost
	sOracleService = GetEnvVar("USER", "Oracle_Service")
	sOracleHost = GetEnvVar("USER", "Oracle_Host")
	sOracleClient = GetEnvVar("USER", "Oracle_Client")
	If sOracleService <> "" And sOracleHost <> "" And sOracleClient <> "" Then Exit Sub
	If Not OracleInstalled Then Exit Sub
	On Error Resume Next
	sService = "EYEDB11"
	str = Cmd("tnsping " & sService)
	If str = "" Or InStr(str, "TNS-03505:") Or InStr(str, "TNS-12154:") Or InStr(str, "TNS-12454:") Or InStr(str, "TNS-12545:") Then
		sService = "EYEDB12"
		str = Cmd("tnsping " & sService)
	End If
	If str = "" Or InStr(str, "TNS-03505:") Or InStr(str, "TNS-12154:") Or InStr(str, "TNS-12454:") Or InStr(str, "TNS-12545:") Then
		SetOracleVariables = ExitWithError(True, "SetOracleVariables: TNSPING Error. OracleInstalled=" & OracleInstalled)
	End If
	SetEnvVar "USER", "Oracle_Service" , sService
	sHost = Mid(str, InStr(str, "(HOST = ") + 8)
	sHost = UCase(Left(sHost, InStr(sHost, ")") - 1))
	SetEnvVar "USER", "Oracle_Host" , sHost
	str = Filter(Split(str, vbNewLine), "\network\admin\sqlnet.ora")(0)
	SetEnvVar "USER", "Oracle_Client" , Left(str, Len(str) - 25)	'ikke i bruk
	sOracleService = GetEnvVar("USER", "Oracle_Service")
	sOracleHost = GetEnvVar("USER", "Oracle_Host")
	sOracleClient = GetEnvVar("USER", "Oracle_Client")
	If Err.Number > 0 Then
		SetOracleVariables = ExitWithError(True, "SetOracleVariables: " & Err.Number & " " & Err.Description)
	End If
End Sub

Sub EyePrivatConfig
	Dim sFileName, oXml, elem, oNode, aAssembly, str, aStr, i
	'TODO: XYZXYZ: IPaddr=EYEDB12
	SetOracleVariables
	On Error Resume Next
	If OS_Bits = 32 Then
		sFileName = EnvVar("%ProgramFiles%\Apertura\EyePrivat\EYE40.exe.config")
	Else
		sFileName = EnvVar("%ProgramFiles(x86)%\Apertura\EyePrivat\EYE40.exe.config")
	End If
	Msg2 "Apertura", "Konfigurerer EyePrivat...", "I", 5
	Set oXml = CreateObject("msxml2.DOMDocument.6.0")
	If Not IsObject(oXml) Then Set oXml = CreateObject("Msxml2.DOMDocument")
	If Not IsObject(oXml) Then Set oXml = CreateObject("Microsoft.XMLDOM")
	With oXml
		.async = False
		.setProperty "SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'"
		.setProperty "SelectionLanguage", "XPath"
		.loadXML TextFromFile(sFileName)
'		MsgBox .xml
		'ER_ENABLED
		str = "No"
		If FileExists("C:\Program Files (x86)\eResept Forskrivningsmodul\FM.Client.App.exe") Then
			If MsgBox("Skal E-resept aktiveres?", vbYesNo, "Apertura") = 6 Then
				str = "Yes"
			End If
		End If
		With .documentElement.selectSingleNode("//configuration/appSettings")
			For Each elem In .getElementsByTagName("add")
				If elem.getAttribute("key") = "ER_ENABLED" Then
					elem.setAttribute "value", str
					Exit For
				End If
			Next
		End With
		'DATA SOURCE for EyeDB og Security
		With .documentElement.selectSingleNode("//configuration/connectionStrings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "EyeDB" Or elem.attributes.item(0).value = "Security" Then
					str = elem.getAttribute("connectionString")
					If str <> "" Then
						'DATA SOURCE=EYEDB11;PERSIST SECURITY INFO=True;USER ID=HL7;Password=HL7
						aStr = Split(str, ";")
						For i = 0 To UBound(aStr)
							If Left(aStr(i), 12) = "DATA SOURCE=" Then
								aStr(i) = "DATA SOURCE=" & sOracleService
								elem.setAttribute "connectionString", Join(aStr, ";")
							End If
						Next
					End If
				End If
			Next
		End With
		'ASSEMBLY
		aAssembly = Assembly("Oracle.DataAccess", 32)
'		If Not IsArray(aAssembly) Then aAssembly = Assembly("Oracle.DataAccess", 64)
		If Not IsArray(aAssembly) Then
			'Oracle_Client: D:\Oracle_Client\product\12.2.0\client_1
			'"INFO: oracle.dataaccess.dll is registered successfully in GAC."
			Cmd sOracleClient & "\ODP.NET\bin\2.x\oraprovcfg.exe /action:gac /providerpath:Oracle.DataAccess.dll"
			aAssembly = Assembly("Oracle.DataAccess", 32)
			If Not IsArray(aAssembly) Then
				'registrer mest vanlige
				aAssembly = Array("2.112.1.0")
			End If
		End If
		For Each oNode In .documentElement.selectSingleNode("//runtime").ChildNodes(0).ChildNodes
			If oNode.firstChild.getAttribute("name") = "Oracle.DataAccess" Then
				oNode.firstChild.NextSibling.setAttribute "newVersion", aAssembly(0)
			End If
		Next
		'SECURITY MODE
		With .documentElement.selectSingleNode("//system.serviceModel/bindings/netTcpBinding/binding/security")
			.setAttribute "mode", "None"
		End With
		'ENDPOINT ADDRESS
		With .documentElement.selectSingleNode("//system.serviceModel/client/endpoint")
			.setAttribute "address", "net.tcp://" & sOracleHost & ":8002/ApServices"
		End With
		'DNS VALUE
		With .documentElement.selectSingleNode("//system.serviceModel/client/endpoint/identity/dns")
			.setAttribute "value", sOracleHost
		End With
		.save sFileName
	End With
	Msg2 "Apertura", "Konfigurerer EyePrivat...", "I", ""
	If Err.Number > 0 Then ExitWithError False, "EyePrivatConfig: " & Err.Number & " " & Err.Description
End Sub


Function ApServicesInstall
	'Kalles opp fra Netop - Run
	Dim sName, aUsrPwd, sPath, oSh, aSQL, sInstaller, sProdCode, sRet
'	sName = "ApMessageServices_2017_08_30"
	sName = "ApMessageServices_2017_09_25"
'	If sOracleHost = "" Then ExitWithError True, "Apertura Services: Ingen Oracle_Host"
'	If sOracleService = "" Then ExitWithError True, "Apertura Services: Ingen Oracle_Service"
	aUsrPwd = ApServicesUsrPwd ' ta vare p brukernavn og passord i config-fil
	If sOracleHost <> NHNIP And Split(sOracleHost, ".")(0) <> ComputerName Then
		Msg2 "Apertura", "Kan ikke installere Apertura Services p denne maskinen!", "E", 10
	End If
	sPath = sInstallPath & sName & "\"
	'Kjr oppdatering av Oracle dersom mappe inneholder sql-fil.
	Set oSh = CreateObject("WScript.Shell")
	aSQL = FilesInFolder(sPath, "sql")
	If UBound(aSQL) > -1 Then
		Msg2  "Apertura", "Oppdaterer database...", "I", 0
		oSh.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & aSQL(0), 4, True '8 = current remains active
		Msg2  "Apertura", "Oppdaterer database...", "I", ""
	End If
	sInstaller = sPath & "SetupApServices.msi"
	sProdCode = ProductCode("AperturaServices")
	If sProdCode <> "" Then
		'Avinstaller Apertura Services
		Msg2 "Apertura", "Avinstallerer Apertura Services...", "I", 0
		oSh.Run "msiexec /x " & sProdCode & " /q", 0, True
		Msg2 "Apertura", "Avinstallerer Apertura Services...", "I", ""
	End If
	Msg2 "Apertura", "Installerer Apertura Services...", "I", 0
	oSh.Run "msiexec /I " & Q(sInstaller) & " /q", 0, True
	sRet = ApServicesConfig(aUsrPwd)
	If sRet = True Then
		ApServicesInstall = "Apertura Services installert " & Now
	Else
		ApServicesInstall = sRet
	End If
	Set oSh = Nothing
	Msg2 "Apertura", "Installerer Apertura Services...", "I", ""
End Function

Function ApServicesUsrPwd 'As Array
	'Returnerer matrise med brukernavn og passord fra ApServices.exe.config
	Dim str, oXml, elem, sUser, sPwd
	str = TextFromFile(EnvVar("%programfiles(x86)%\Apertura\AperturaServices\ApServices.exe.config"))
	If str <> "" Then
		With CreateObject("Msxml2.DOMDocument")
			.async = False
			.setProperty "SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'"
			.setProperty "SelectionLanguage", "XPath"
			.loadXML str
			For Each elem In .documentElement.selectSingleNode("//configuration/appSettings").getElementsByTagName("add")
				If elem.attributes.item(0).value = "username" Then
					sUser = elem.attributes.item(1).value
				ElseIf elem.attributes.item(0).value = "password" Then
					sPwd = elem.attributes.item(1).value
				End If
			Next
		End With
	End If
	ApServicesUsrPwd = Array(sUser, sPwd)
End Function

Sub ApServicesConfigMenu
	'Kalles opp fra Netop - Run
	Dim aUsrPwd
	aUsrPwd = ApServicesUsrPwd
	If aUsrPwd(0) = "" Then aUsrPwd(0) = InputBox("Oppgi brukernavn:", "Apertura Services", "")
	If aUsrPwd(1) = "" Then aUsrPwd(1) = InputBox("Oppgi passord:", "Apertura Services", "")
	ApServicesConfig aUsrPwd
End Sub

Function ApServicesConfig(aUsrPwd)
	Dim sFileName, oXml, sXml, elem, oNode, aAssembly, str, i
	If aUsrPwd(0) = "" Or aUsrPwd(1) = "" Then
		Msg2 "Apertura", "Brukernavn eller passord mangler for Apertura Services!", "W", 0
		WScript.Sleep 3000
	End If
	Msg2 "Apertura", "Konfigurer Apertura Services...", "I", 0
	On Error Resume Next
	If OS_Bits = 32 Then
		sFileName = EnvVar("%ProgramFiles%\Apertura\AperturaServices\ApServices.exe.config")
	Else
		sFileName = EnvVar("%ProgramFiles(x86)%\Apertura\AperturaServices\ApServices.exe.config")
	End If
'	If sOracleService = "" OR sOracleHost = "" Then
'		ExitWithError True, "ApServicesConfig: Oracle miljvariabler er ikke registrert."
'	END IF
'	Set oXml = CreateObject("msxml2.DOMDocument.6.0")
	Set oXml = CreateObject("Msxml2.DOMDocument")
'	Set oXml = CreateObject("Microsoft.XMLDOM")
	With oXml
		.async = False
		.setProperty "SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'"
		.setProperty "SelectionLanguage", "XPath"
		.loadXML TextFromFile(sFileName)
		sXml = .xml
'		MsgBox .xml : WScript.Quit
		'DATABASE
		With .documentElement.selectSingleNode("//configuration/appSettings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "username" Then
					elem.attributes.item(1).value = aUsrPwd(0)
				ElseIf elem.attributes.item(0).value = "password" Then
					elem.attributes.item(1).value = aUsrPwd(1)
				ElseIf elem.attributes.item(0).value = "filePath" Then
					elem.attributes.item(1).value = "C:\Apertura\EDI\INBOX"
				ElseIf elem.attributes.item(0).value = "outputDirectory" Then
					elem.attributes.item(1).value = "C:\Apertura\EDI\OUTBOX"
				ElseIf elem.attributes.item(0).value = "database" Then
					elem.attributes.item(1).value = sOracleService
				End If
			Next
		End With
		'DATA SOURCE for EyeDB og Security
		str = "DATA SOURCE=" & sOracleService & ";PERSIST SECURITY INFO=True;USER ID=HL7;Password=HL7"
		With .documentElement.selectSingleNode("//configuration/connectionStrings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "EyeDB" Or elem.attributes.item(0).value = "Security" Then
					elem.setAttribute "connectionString", str
				End If
			Next
		End With
		'ASSEMBLY
		aAssembly = Assembly("Oracle.DataAccess", 32)
		If Not IsArray(aAssembly) Then aAssembly = Array("2.112.1.0")
'		If Left(aAssembly(0), 1) = "2" Then aAssembly(0) = "4" & Mid(aAssembly(0), 2)	'Tving runtime 4
		For Each oNode In .documentElement.selectSingleNode("//runtime").ChildNodes(0).ChildNodes
			If oNode.firstChild.getAttribute("name") = "Oracle.DataAccess" Then
				oNode.firstChild.NextSibling.setAttribute "newVersion", aAssembly(0)
			End If
		Next
		'SECURITY MODE
		With .documentElement.selectSingleNode("//system.serviceModel/bindings/netTcpBinding/binding/security")
			.setAttribute "mode", "None"
		End With
		'Lagre dersom endringer
		If .xml <> sXml Then .save sFileName
	End With
	'"C:\Program Files (x86)\Apertura\AperturaServices\StopStartApServices.cmd"
	Msg2 "Apertura", "Stopper og starter Apertura Services...", "I", 0
	CreateObject("WScript.Shell").Run sInstallPath & "StopStart\StopStartAperturaServices.cmd", 1, True
	Msg2 "Apertura", "Stopper og starter Apertura Services...", "I", ""
	Msg2 "Apertura", "Konfigurer Apertura Services...", "I", ""
	If Err.Number > 0 Then
		ApServicesConfig = ExitWithError(False, "ApServicesConfig: " & Err.Number & " " & Err.Description)
	Else
		ApServicesConfig = True
	End If
End Function

Function SyncPilotKlient
	Dim sRet, sPath
	If ComputerName = "BREXIT" Then sPath = "D:\" Else sPath = ShareProperty("AperturaInstall", "Path")
	sRet = SyncDropboxFolder(sPath, "Pilot_Klient")
	If sRet = True Then
		SyncPilotKlient = "Pilot_Klient synkronisert " & Now
	Else
		SyncPilotKlient = sRet
	End If
End Function

Function SyncScripts
	Dim sRet, sPath
	If ComputerName = "BREXIT" Then sPath = "D:\" Else sPath = ParentDir(ScriptPath)
	sRet = SyncDropboxFolder(sPath, "Scripts")
	If sRet = True Then
		SyncScripts = "Scripts synkronisert " & Now
	Else
		SyncScripts = sRet
	End If
End Function

Function SyncDropboxFolder(ByVal sPath, ByVal sDbFolder)
	'Synkroniserer mapper i Dropbox til lokal mappe (enveis)
	Dim sListUrl, sLinkUrl, sAccessToken, aUserAgent, aAuth, aContentType, aHeaders, aEntries, str, i, sFiles, sFolders, aDN, aDL, aTmp, sMod, aFN, aFL
	sListUrl = "https://api.dropboxapi.com/2/files/list_folder"
	sLinkUrl = "https://api.dropboxapi.com/2/files/get_temporary_link"
	sAccessToken = "3le85-YhQpAAAAAAAAAATl0RYJ0qbBCBAt4UIlDQn383piqyvidX2xmz-BNM1wvX"
	aUserAgent = Array("User-Agent", "api-explorer-client")
	aAuth = Array("Authorization", "Bearer " & sAccessToken)
	aContentType = Array("Content-Type", "application/json")
	aHeaders = Array(aUserAgent, aAuth, aContentType)
	On Error Resume Next
	str = WinHttpPost("", sListUrl, "{""path"": ""/" & sDbFolder & """,""recursive"": true}", aHeaders)
	If str = "" Or Err.Number <> 0 Then SyncDropboxFolder = ExitWithError(True, "SyncDropboxFolder : WinHttpPost: " & str)
	aEntries = Split(str, "}, {")
	For i = 0 To UBound(aEntries)
		'kan ogs vre "cursor"
		str = JsonStr(aEntries(i), ".tag")
		If str = "file" Then
			sFiles = sFiles & vbTab & aEntries(i)
		ElseIf str = "folder" Then
			sFolders = sFolders & vbTab & aEntries(i)
		End if
	Next
	If Right(sPath, 1) = "\" Then sPath = Left(sPath, Len(sPath) - 1)
	'MAPPER
	If sFolders <> "" Then
		'Opprett mapper som ikke finnes lokalt
		aTmp = Split(Mid(sFolders, 2), vbTab)
		ReDim aDN(UBound(aTmp))
		On Error Resume Next
		For i = 1 To UBound(aTmp)
			'neste linje kan generere feil men blir uansett korrekt
			str = sPath & Replace(Unicode2Ansi(JsonStr(aTmp(i), "path_display")), "/", "\")
			aDN(i) = vbTab & str & vbTab
			If Not DirExists(str) Then CreateDir str
		Next
		On Error Goto 0
		'Slett mapper lokalt som ikke finnes i Dropbox
		aDL = Split(SubDirList(sPath & "\" & sDbFolder, True), vbNewLine)
		For i = 0 To UBound(aDL)
			If UBound(Filter(aDN, vbTab & aDL(i) & vbTab, True, 1)) < 0 Then
				DeleteDir aDL(i)
			End If
		Next
	End If
	'FILER
	If sFiles <> "" Then
		'Last ned filer fra dropbox som ikke finnes lokalt
		aTmp = Split(Mid(sFiles, 2), vbTab)
		ReDim aFN(UBound(aTmp))
		For i = 0 To UBound(aTmp)
			str = sPath & Replace(Unicode2Ansi(JsonStr(aTmp(i), "path_display")), "/", "\") 'Unicode2Ansi fr erstatt
			aFN(i) = vbTab & str & vbTab
			sMod = CStr(DateFromISO(JsonStr(aTmp(i), "client_modified")))
'			If Not FileExists(str) Or (JsonNum(aTmp(i), "size") <> FileSizeB(str) * 1) Or (CStr(FileModified(str)) <> sMod) Then
			If CStr(FileModified(str)) <> sMod Then
				HttpSave JsonStr(WinHttpPost("", sLinkUrl, "{""path"": """ & JsonStr(aTmp(i), "id") & """}", aHeaders), "link"), str
'				If Err.Number > 0 Then WEQ str & vbTab & FileExists(str)
				SetFileModified Left(str, InStrRev(str, "\")), Mid(str, InStrRev(str, "\") + 1), sMod
'			ElseIf CStr(FileModified(str)) <> CStr(sMod) Then
'				SetFileModified Left(str, InStrRev(str, "\")), Mid(str, InStrRev(str, "\") + 1), sMod
			End If
		Next
		'Slett filer lokalt som ikke finnes i dropbox
		aFL = Split(FileList(sPath & "\" & sDbFolder, True, ""), vbNewLine)
		For i = 0 To UBound(aFL)
			If InStr(aFL(i), ".dropbox.attr") = 0 Then
				If UBound(Filter(aFN, vbTab & aFL(i) & vbTab, True, 1)) < 0 Then
					DeleteFile aFL(i)
				End If
			End If
		Next
	End If
	SyncDropboxFolder = Err.Number = 0
End Function

Function xSyncDropboxFolder(ByVal sPath, ByVal sDbFolder)
	'Synkroniserer mapper i Dropbox til lokal mappe (enveis)
	Dim sListUrl, sLinkUrl, sAccessToken, aUserAgent, aAuth, aContentType, aHeaders, aEntries, str, i, sFiles, sFolders, aTmp, aFB, aFN, sData, aFL, iBytes
	sListUrl = "https://api.dropboxapi.com/2/files/list_folder"
	sLinkUrl = "https://api.dropboxapi.com/2/files/get_temporary_link"
	sAccessToken = "3le85-YhQpAAAAAAAAAATl0RYJ0qbBCBAt4UIlDQn383piqyvidX2xmz-BNM1wvX"
	aUserAgent = Array("User-Agent", "api-explorer-client")
	aAuth = Array("Authorization", "Bearer " & sAccessToken)
	aContentType = Array("Content-Type", "application/json")
	aHeaders = Array(aUserAgent, aAuth, aContentType)
'	On Error Resume Next
	str = WinHttpPost("", sListUrl, "{""path"": ""/" & sDbFolder & """}", aHeaders)
	If str = "" Or Err.Number <> 0 Then xSyncDropboxFolder = ExitWithError(True, "SyncDropboxFolder : WinHttpPost: " & str)
	aEntries = Split(str, "}, {")
	For i = 0 To UBound(aEntries)
		'kan ogs vre "cursor"
		str = JsonStr(aEntries(i), ".tag")
		If str = "file" Then
			sFiles = sFiles & vbTab & aEntries(i)
		ElseIf str = "folder" Then
			sFolders = sFolders & vbTab & aEntries(i)
		End if
	Next
	'FILER
	If sFiles <> "" Then sFiles = Mid(sFiles, 2)
	aTmp = Split(sFiles, vbTab)
	ReDim aFB(UBound(aTmp)) : ReDim aFN(UBound(aTmp))
	If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
	If Not DirExists(sPath) Then CreateDir sPath
	For i = 0 To UBound(aTmp)
		sData = WinHttpPost("", sLinkUrl, "{""path"": """ & JsonStr(aTmp(i), "id") & """}", aHeaders)
		str = Replace(Unicode2Ansi(JsonStr(sData, "path_display")), "/", "\") 'Unicode2Ansi fr erstatt
		str = Mid(Mid(str, 2), InStrRev(Mid(str, 2), "\") + 1) 'utelat bane
		aFB(i) = Array(sPath & str, DateFromISO(JsonStr(sData, "client_modified")), JsonNum(sData, "size"), JsonStr(sData, "link"))
		aFN(i) = vbTab & sPath & str & vbTab
	Next
	'Slett filer i lokal mappe som ikke finnes i dropbox
	aFL = FilesInFolder(sPath, "")
	For i = 0 To UBound(aFL)
		If InStr(aFL(i), ".dropbox.attr") = 0 Then
			If UBound(Filter(aFN, vbTab & aFL(i) & vbTab, True, 1)) < 0 Then
				DeleteFile aFL(i)
			Else
'				weq FileModified(aFL(i)) <> aFB(i)(1)
'				str = FileModified(aFL(i))
				If FileModified(aFL(i)) <> aFB(i)(1) Then SetFileModified sPath, Mid(aFL(i), Len(sPath) + 1), aFB(i)(1)
'				If Err.Number > 0 Then weq aFL(i) & vbNewLine & str & vbNewLine & aFB(i)(1)
			End If
		End If
		aFL(i) = vbTab & aFL(i) & vbTab
	Next
	'Last ned filer fra dropbox som ikke finnes i lokal mappe
	For i = 0 To UBound(aFN)
		aTmp = Filter(aFL, aFN(i))
		iBytes = -1
		If UBound(aTmp) = 0 Then iBytes = FileSizeB(Mid(aTmp(0), 2, Len(aTmp(0)) - 2))
		If iBytes <> aFB(i)(2) * 1 Then
			HttpSave aFB(i)(3), aFB(i)(0)
			SetFileModified sPath, Mid(aFB(i)(0), Len(sPath) + 1), aFB(i)(1)
		End If
	Next
	'MAPPER
	If sFolders <> "" Then sFolders = Mid(sFolders, 2)
	aTmp = Split(sFolders, vbTab)
	ReDim aFN(UBound(aTmp))
	For i = 0 To UBound(aTmp)
		aTmp(i) = Unicode2Ansi(JsonStr(aTmp(i), "path_display"))
		str = Mid(Replace(aTmp(i), "/", "\"), 2)
		aFN(i) = vbTab & sPath & Mid(str, InStrRev(str, "\") + 1) & vbTab
	Next
	'Slett lokale mapper som ikke er i Dropbox
	aFL = Split(SubDirList(sPath, False), vbNewLine)
	For i = 0 To UBound(aFL)
		If UBound(Filter(aFN, vbTab & aFL(i) & vbTab, True, 1)) < 0 Then
			DeleteDir aFL(i)
		End If
	Next
	'Synkroniser undermapper
	For i = 0 To UBound(aTmp)
		xSyncDropboxFolder Mid(aFN(i), 2, Len(aFN(i)) - 2), Mid(aTmp(i), 2)
	Next
	xSyncDropboxFolder = Err.Number = 0
End Function

Function xxSyncPilotKlient
	Dim sDropboxFolder, sRet
	sDropboxFolder = "https://www.dropbox.com/sh/5ewjkny8y486usa/AAAA-TKqUOwfxV4qO668pSSSa?dl=0"
	sRet = SyncDropboxFolder(sInstallPath, sDropboxFolder)
	If sRet = True Then
		xxSyncPilotKlient = "Pilot_Klient synkronisert " & Now
	Else
		xxSyncPilotKlient = sRet
	End If
End Function

Function xxSyncScripts
	Dim sDropboxFolder, sRet
	sDropboxFolder = "https://www.dropbox.com/sh/z1n3ru99bhjs5c0/AABCyymnAgadrTTjF-GGYSona?dl=0"
	sRet = SyncDropboxFolder(ScriptPath, sDropboxFolder)
	If sRet = True Then
		xxSyncScripts = "Skript synkronisert " & Now
	Else
		xxSyncScripts = sRet
	End If
End Function

Function xxSyncDropboxFolder(ByVal sPath, ByVal dbFolderUrl)
	'Synkroniserer mapper i Dropbox til lokal mappe (enveis)
	Dim str, i, sFiles, sFolders, aTmp, aFB, aFN, aFL, iBytes, aDIR
	If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
	If Not DirExists(sPath) Then CreateDir sPath
	str = HttpGet("", dbFolderUrl)
	WEQ str
	If str = "" Then xxSyncDropboxFolder = ExitWithError(True, "SyncDropboxFolder : HttpGet returnerte tom streng.")
'	str = Filter(Split(str, vbLf), "(mod,InitReact)")(0)
	str = Filter(Split(str, vbLf), "InitReact.mountComponent(mod,")(0)
	WEQ str
	str = Mid(str, InStr(str, "{""files"": ["))
	i = InStr(str, "], ""folders"": [")
	sFiles = Mid(str, 12, i - 12)
	sFolders = Mid(str, i + Len("], ""folders"": ["))
	sFolders = Left(sFolders, InStr(sFolders, "}],"))
	If Left(sFolders, 1) = "]" Then sFolders = ""
	aTmp = Split(sFiles, "}, {")
	ReDim aFB(UBound(aTmp)) : ReDim aFN(UBound(aTmp))
	For i = 0 To UBound(aTmp)
		aFB(i) = Array(Split(Split(aTmp(i), """href"": """)(1), Chr(34))(0), Split(Split(aTmp(i), """bytes"": ")(1), ",")(0))
		aFN(i) = vbTab & UrlDecode(Split(Mid(aFB(i)(0), InStrRev(aFB(i)(0), "/") + 1), "?")(0)) & vbTab
	Next
	WEQ aFN
	'Slett filer i lokal mappe som ikke finnes i dropbox
	aFL = FilesInDir(sPath)
	For i = 0 To UBound(aFL)
		If Left(aFL(i), 1) <> "." Then
			If UBound(Filter(aFN, vbTab & aFL(i) & vbTab)) < 0 Then
				DeleteFile sPath & aFL(i)
			End If
		End If
		aFL(i) = vbTab & aFL(i) & vbTab
	Next
	'Last ned filer fra dropbox som ikke finnes i lokal mappe
	For i = 0 To UBound(aFN)
		aTmp = Filter(aFL, aFN(i))
		iBytes = -1
		If UBound(aTmp) = 0 Then iBytes = FileSizeB(sPath & Mid(aTmp(0), 2, Len(aTmp(0)) - 2))
		If iBytes <> aFB(i)(1) * 1 Then
			HttpSave Left(aFB(i)(0), Len(aFB(i)(0)) -1) & 1, sPath & Mid(aFN(i), 2, Len(aFN(i)) - 2)
		End If
	Next
	aDIR = Split(sFolders, "}, {")
	ReDim aFN(UBound(aDIR))
	For i = 0 To UBound(aDIR)
		aFN(i) = vbTab & sPath & Split(Split(aDIR(i), """filename"": """)(1), Chr(34))(0) & vbTab
	Next
	'Slett lokale mapper som ikke er i Dropbox
	aFL = Split(SubDirList(sPath, False), vbNewLine)
	For i = 0 To UBound(aFL)
		If UBound(Filter(aFN, vbTab & aFL(i) & vbTab)) < 0 Then
			DeleteDir aFL(i)
		End If
	Next
	'Opprett mapper som ikke finnes lokalt
	
	'Synkroniser undermapper
	For i = 0 To UBound(aDIR)
		dbFolderUrl = Split(Split(aDIR(i), """href"": """)(1), Chr(34))(0)
		xxSyncDropboxFolder Mid(aFN(i), 2, Len(aFN(i)) - 2), dbFolderUrl
	Next
	xxSyncDropboxFolder = True
End Function

Function HttpTimeOslo
	Dim sUrl, html
	sUrl = "https://www.timeanddate.no/klokka/i/norge/oslo"
	SetHTML html, NHNHttpGet("", sUrl, "")
	HttpTimeOslo = html.getElementById("ct").innerText
End Function

Sub W32Time
	'Setter maskinen til  synkronisere mot tidsservere (no.pool.ntp.org)
	Dim sPools, str
	sPools = "0.no.pool.ntp.org 1.no.pool.ntp.org 2.no.pool.ntp.org 3.no.pool.ntp.org"
	If Not Service("W32Time", "stop", "") Then ExitWithError False, "Kunne ikke stoppe tjenesten 'W32Time'"
	str = str & Cmd("w32tm /config /syncfromflags:manual /manualpeerlist:" & Q(sPools)) & vbNewLine
	str = str & Cmd("w32tm /config /reliable:yes") & vbNewLine
	If Not Service("W32Time", "start", "") Then ExitWithError False, "Kunne ikke starte tjenesten 'W32Time'"
	AppendTextToFile EnvVar("%COMPUTERNAME%:") & vbNewLine & str, Return_File
End Sub

Sub SysReportNet
	Dim aComputers, i, strComputer, sText
	DeleteFile Return_File
	aComputers = NetComputers
	For i = 0 To UBound(aComputers)
		strComputer = Mid(aComputers(i), 3)
		sText = sText & ComputerIP(strComputer) & vbTab & strComputer
		If IsConnectable(strComputer) Then sText = sText & vbTab & Join(SysReport(strComputer), vbTab)
		sText = sText & vbNewLine
	Next
	If sText <> "" Then TextToFile Mid(sText, 2), Return_File
End Sub

Sub ServerDownloads
	DownloadToShare "http://updates.nhn.no/dips/communicator/siste/DipsCommunicator.zip"
	DownloadToShare "http://thula.is/ReleaseCandidates/eresept/eResept_3_6_4_13190.zip"
	DownloadToShare "http://download.microsoft.com/download/F/9/4/F942F07D-F26F-4F30-B4E3-EBD54FABA377/NDP462-KB3151800-x86-x64-AllOS-ENU.exe"
	DownloadToShare "https://download.microsoft.com/download/F/6/7/F673709C-D371-4A64-8BF9-C1DD73F60990/ENU/x64/SQLEXPRWT_x64_ENU.exe" 'Sql Server 2012 SP3
End Sub

Function SysReport(strComputer) 'As Array
	SysReport = Array(OSName(strComputer), OSVersionStr(strComputer), OSBits(strComputer), _
	MemoryTotalMB(strComputer), Join(CPUInfo(strComputer), ","))
End Function

Function IsConnectable(strComputer)
	On Error Resume Next
	GetObject "winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2"
	IsConnectable = Err.Description <> "The remote server machine does not exist or is unavailable"
End Function

Function FileArray(spec, bSubDirs)
	'Returnerer matrise over alle filer i mappe og evt. undermapper som oppfyller spec.
	'Spec kan foruten mappenavn ogs inneholde deler av filnavn inkl. jokertegn (? og *).
	'Se %windir%\hh.exe "%Dropbox%\E-bker\Command line\ntcmds.chm::/dir.htm", og for vrig FolderArray().
	Dim list, sPath
	If Right(spec, 1) = "\" Then spec = Left(spec, Len(spec) - 1) ' fjern evt. siste "\"
	If bSubDirs Then
		list = CmdNor("dir /a:-d /b /s " & Q(spec))
	Else
		list = CmdNor("dir /a:-d /b " & Q(spec))
	End If
	If list <> "" Then
		list = Left(list, Len(list) - 2)
		If Not bSubDirs Then
			If InStr(spec, "\") Then sPath = Left(spec, InStrRev(spec, "\")) Else sPath = CurDir("")
			list = sPath & Replace(list, vbNewLine, vbNewLine & sPath)
		End If
		FileArray = Split(list, vbNewLine)
	End If
End Function

Function FilesInDir(filespec) 'As Array
	'Returnerer matrise over filnavn ihht spesifikasjon. Ca 30% raskere enn FilesInFolder
	'filespec kan foruten mappenavn ogs inneholde deler av filnavn inkl. jokertegn (? og *)
	'Se %windir%\hh.exe "%Dropbox%\E-bker\Command line\ntcmds.chm::/dir.htm"
	'NB: dir /b is changing the em-dash to a hyphen (ascii 150 til 45)
	Dim list
	list = CmdNor("dir /a:-d /b " & Q(filespec))
	If list <> "" Then
		FilesInDir = Split(Left(list, Len(list) - 2), vbNewLine)
	Else
		FilesInDir = Array()
	End If
End Function

Function FoldersInDir(spec) 'As Array
	'Returnerer matrise over mappenavn ihht spesifikasjon.
	'Se %windir%\hh.exe "%Dropbox%\E-bker\Command line\ntcmds.chm::/dir.htm"
	Dim list
	list = CmdNor("dir /a:d /b " & Q(spec))
	If list <> "" Then
		FoldersInDir = Split(Left(list, Len(list) - 2), vbNewLine)
	Else
		FoldersInDir = Array()
	End If
End Function

Function FilesInFolder(sFolder, sExts) 'As Array
	'Returnerer matrise over navn p filer i mappen sFolder av typene angitt i den kommaseparerte listen sExt
	Dim file, list, e
	e = "," & LCase(sExts) & ","
	With CreateObject("Scripting.FileSystemObject")
		If .FolderExists(sFolder) Then
			For Each file In .GetFolder(sFolder).Files
				If sExts = "" Or InStr(e, "," & LCase(.GetExtensionName(file)) & ",") Then
					list = list & file.Path & vbNewLine
				End If
			Next
		End If
	End With
	If list <> "" Then
		FilesInFolder = Split(Left(list, Len(list) - 2), vbNewLine)
	Else
		FilesInFolder = Array()
	End If
End Function

Sub Text2File(sCharset, sText, sFileName)
	'Skriver tekst til tekstfil ihht tegnsett, f.eks charset = "utf-8"
	Const adTypeBinary = 1, adTypeText = 2, adSaveCreateNotExist = 1, adSaveCreateOverWrite = 2
	With CreateObject("ADODB.Stream")
		.Charset = sCharset
		.Type = adTypeText
		.Open
		.WriteText sText
		.SaveToFile sFileName, adSaveCreateOverWrite
		.Close
	End With
End Sub

Function TextFile(sCharset, sFileName)
	'Leser tekstfil ihht tegnsett, f.eks charset = "utf-8"
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(sFileName) Then
			If .GetFile(sFileName).Size > 0 Then
				Const adTypeBinary = 1, adTypeText = 2
				'Const adModeRead = 1, adModeWrite = 2, adModeReadWrite = 3
				With CreateObject("ADODB.Stream")
					.Charset = sCharset
					.Type = adTypeText
					.Open
					.LoadFromFile sFileName
					TextFile = .ReadText()
					.Close
				End With
			End If
		End If
	End With
End Function

Sub TextToFile(sText, sFileName)
	With CreateObject("Scripting.FileSystemObject").OpenTextFile(sFileName, 2, True)
		.Write sText
		.Close
	End With
End Sub

Function Item(str, itemNum)
	'Returnerer angitt del av streng
	Item = Split(str, ",")(itemNum - 1)
End Function

Function ItemIndex(item, list)
	ItemIndex = ChunkIndex(item, list, ",")
End Function

Function ChunkIndex(chunk, block, separator)
	'Returnerer hvilken plassering bit har i blokk om bit finnes, ellers 0
	If InStr(block, chunk) Then
		ChunkIndex = UBound(Split(Left(separator & block, InStr(separator & block, chunk) - 1), separator))
	Else
		ChunkIndex = 0
	End If
End Function

Function AppendTextToFile(sText, sFile)
	Const ForReading = 1, ForWriting = 2, ForAppending = 8
	With CreateObject("Scripting.FileSystemObject").OpenTextFile(sFile, ForAppending, True)
		.Write sText
		.close
	End With
End Function

Function RegMatch(sPattern, str)
	'Returnerer Sann dersom mnster for Regular Expression rommer streng, ellers Usann
	With New RegExp
		.Pattern = sPattern
		'.IgnoreCase = True
		'.Global = True
		With .Execute(str)
			RegMatch = .Count > 0
		End With
	End With
End Function

Function RegEx(pat, str) 'As Array
	'Sk med regulrt uttrykk
	'Returnerer nullbasert matrise med hvert treff av sk etter mnster i streng
	Dim i, aRet
	With New RegExp
		.Pattern = pat
		.IgnoreCase = True
		.Global = True
		With .Execute(str)
			ReDim aRet(.Count)
			For i = 0 To .Count - 1
				aRet(i) = .Item(i)
			Next
		End With
	End With
	RegEx = aRet
End Function

Function RegExSub(pattern, oldStr, newStr) 'As String
	'Erstatter streng i treff basert p mnster med regulrt uttrykk
	RegExSub = RegExRepl(pattern, RegEx(pattern, oldStr)(0), newStr)
End Function

Function RegExRepl(pattern, oldStr, newStr) 'As String
	'Erstatter streng ihht mnster med regulrt uttrykk
	With New RegExp
		.Pattern = pattern
		.IgnoreCase = True
		.Global = True
		RegExRepl = .Replace(oldStr, newStr)
	End With
End Function

Function RegExpTest(patrn, strng)
	'Sjekker for treff etter mnster (fra Microsoft Windows Script Technologies.chm)
	Dim regEx, Match, Matches, RetStr     ' Create variable.
	Set regEx = New RegExp         ' Create a regular expression.
	regEx.Pattern = patrn         ' Set pattern.
	regEx.IgnoreCase = True         ' Set case insensitivity.
	regEx.Global = True         ' Set global applicability.
	Set Matches = regEx.Execute(strng)   ' Execute search.
	For Each Match In Matches      ' Iterate Matches collection.
		RetStr = RetStr & "Match found at position "
		RetStr = RetStr & Match.FirstIndex & ". Match Value is '"
		RetStr = RetStr & Match.Value & "'." & vbCrLf
	Next
	RegExpTest = RetStr
End Function

Function FileList(ByVal sDir, bRecurs, sExts)
	'Lister alle filer i mappe og evt. undermapper evt. iht. filekstensjon(er)
	'NB: Benytter SubDirList som trenger global variabel strSubDirList
	FileList = Join(FilesInFolder(sDir, sExts), vbNewLine)
	If bRecurs Then
		Dim aDirs, i, sTmp, sFiles
		aDirs = Split(SubDirList(sDir, bRecurs), vbNewLine)
		For i = 0 To UBound(aDirs)
			sTmp = Join(FilesInFolder(aDirs(i), sExts), vbNewLine)
			If sTmp <> "" Then sFiles = sFiles & vbNewLine & sTmp
		Next
		If sFiles <> "" Then
			FileList = FileList & vbNewLine & Mid(sFiles, 3) 'fjern frste linjeskift
		End If
	End If
End Function

Function SubDirList(ByVal sPath, bRecurs)
	'Lister alle undermapper i angitt bane uten avsluttende "\", evt. rekursivt.
	'NB: Trenger global variabel strSubDirList
	Dim bFirstLevel, fSubFolder
	If strSubDirList = "" Then bFirstLevel = True 'tm den globale variabelen strSubDirList etter bruk
	If Right(sPath, 1) = "\" Then sPath = Left(sPath, Len(sPath) - 1) 'fjern evt. avsluttende "\" i bane
	If Right(sPath, 1) = ":" Then sPath = sPath & "\" ' rotmapper krever dobbel avsluttende "\"
	If Not DirExists(sPath) Then Exit Function 'unng feilmelding
	For Each fSubFolder In CreateObject("Scripting.FileSystemObject").GetFolder(sPath).SubFolders
		strSubDirList = strSubDirList & sPath & "\" & fSubFolder.Name & vbNewLine
		If bRecurs = True Then SubDirList sPath & "\" & fSubFolder.Name, bRecurs
	Next
	If strSubDirList <> "" Then SubDirList = Left(strSubDirList, Len(strSubDirList) - 2)
	If bFirstLevel = True Then strSubDirList = ""
End Function

Function TextFromFile(FileName)
	On Error Resume Next  'unng feilmelding dersom filen er tom
	With CreateObject("Scripting.FileSystemObject").OpenTextFile(FileName, 1, False)
		TextFromFile = .ReadAll
		.Close
	End With
End Function

Function Cap(str)
	'Returnerer streng med stor forbokstav
	Cap = UCase(Left(str, 1)) & LCase(Mid(str, 2))
End Function

Function CapW(ByVal str)
	'Returnerer streng med sm bokstaver og stor forbokstav i hvert ord
	'For  forst regEx se RegExpTest
	Dim regEx, match
	str = " " & LCase(str) 'legg til mellomrom foran for stor forbokstav i frste ord
	Set regEx = New RegExp
	With regEx
		.Pattern = "[-|\s]." 'bindestrek eller white space. \b for ord fungerer ikke med 
		.Global = True
		For Each match In .Execute(str)
			If match.Value <> " " Then
				str = Left(str, match.FirstIndex) & UCase(match.Value) & Mid(str, match.FirstIndex + 3)
			End If
		Next
	End With
	CapW = Mid(str, 2) 'fjern mellomrom foran
End Function

Function Q(val)
	'quoted
	Q = Chr(34) & val & Chr(34)
End Function

Function Q3(val)
	'trippel quoted
	Q3 = String(3, Chr(34)) & val & String(3, Chr(34))
End Function

Function UQ(str)
	'fjerner anfrselstegn dersom angitt fr og etter
	If InQ(str) Then
		UQ = Mid(str, 2, Len(str) - 2)
	Else
		UQ = str
	End If
End Function

Function InQ(str)
	'Returnerer Sann dersom streng er omsluttet av anfrselstegn, ellers Usann
	If Len(str) > 1 Then
		InQ = (str = Q(Mid(str, 2, Len(str) - 2)))
	Else
		InQ = False
	End If
End Function

Function QParam(s) 'quoted spaces and paths in params
	'dersom frste tegn i s er bindestrek fjernes dette og s settes i anfrselstegn
	If Left(s, 1) = "-" Then
		QParam = Q(Mid(s, 2))
	ElseIf Left(s, 3) = String(3, Chr(34)) Then
		
'	ElseIf (Not InQ(s)) And (InStr(s, " ") Or InStr(s, ":\") Or InStr(s, Chr(34))) Then
	ElseIf (InQ(s) = 0 And InStr(s, " ") > 0) Or InStr(s, ":\") Then
		QParam = Q(s)
	Else
		QParam = s
	End If
End Function

Function EnvVar(str)
	'Ekspanderer miljvariabler i str
	With CreateObject("WScript.Shell")
		EnvVar = .ExpandEnvironmentStrings(str)
	End With
End Function

Sub CopyEnvVar(sPath)
	'Legger bane til fil eller mappe i utklipp ihht ReplaceEnvVar
	If WScript.Arguments.Count = 0 Then
		MsgBox "Send filer til dette scriptet eller slipp de over for  lage snarvei!"
		WScript.Quit
	End If
	CopyText ReplaceEnvVar(sPath)
End Sub

Function ReplaceEnvVar(sPath)
	'Erstatter del av sPath med evt. tilsvarende miljvariabel
	Dim a, i, e
	a = Split("dropbox,Install,dev,AllUsersProfile,AppData,CmdCmdLine,CommonProgramFiles,ComputerName,ComSpec," & _
	"HomeDrive,HomePath,LocalAppData,LogonServer,ProgramFiles,ProgramFiles(x86),SystemDrive,SystemRoot,Temp,Tmp," & _
	"UserDnsDomain,UserDomain,UserProfile,WinDir", ",")
	For i = 0 To UBound(a)
		e = EnvVar("%" & a(i) & "%")
		If InStr(LCase(sPath), LCase(e)) Then
			ReplaceEnvVar = "%" & a(i) & "%" & Mid(sPath, Len(e) + 1)
			Exit Function
		End If
	Next
	ReplaceEnvVar = sPath
End Function

Function GetEnvVar(sType, sName)
	'Returnerer miljvariabelen sName av type sType (f.eks USER)
	With CreateObject("WScript.Shell").Environment(sType)
		GetEnvVar = .Item(sName)
	End With
End Function

Sub SetEnvVar(sType, sName, sValue)
	'Oppretter mijvariabelen sName av type sType (f.eks USER) med verdien sValue
	With CreateObject("WScript.Shell").Environment(sType)
		.Item(sName) = sValue
	End With
End Sub

Sub DelEnvVar(sType, sName)
	'Sletter miljvariabelen sName av type sType (f.eks USER)
	On Error Resume Next
	With CreateObject("WScript.Shell").Environment(sType)
		.Remove sName
	End With
End Sub

Function ShareExists
	ShareExists = InStr(ShareCheck, " kunne ikke ") = 0
End Function

Function ShareCheck
	Dim sPath
	sPath = ShareProperty(sShareName, "path")
	If Not DirExists(sPath) Then
		sPath = RootFolder(sShareName)
		If sPath = "" Then
			sPath = "C:\" & sShareName
			CreateDir sPath
		End If
		If Not DirExists(sPath) Then
			ShareCheck = sPath & " kunne ikke opprettes"
		ElseIf Not ShareCreate(sShareName, sPath) Then	
			ShareCheck = sShareName & " kunne ikke deles"
		Else
			ShareCheck = sPath & " er blitt delt som " & sShareName
		End If
	Else
		ShareCheck = sPath & " er allerede delt som " & sShareName
	End If
End Function

Function ShareProperty(ByVal sName, sProperty)
	'Returnerer angitt egenskap for deling
	'Properties: AccessMask, AllowMaximum, Caption, Description, InstallDate, MaximumAllowed, Name, Path, Status, Type
	Dim sComputer, aName, oItem, sCmd
	If Left(sName, 2) = "\\" Then
		If Right(sName, 1) = "\"  Then sName = Left(sName, Len(sName) - 1)
		aName = Split(sName, "\")
		If UBound(aName) > 3 Then Exit Function
		sComputer = aName(2)
		sName = Mid(sName, Len(sComputer) + 4)
	Else
		sComputer = "."
	End If
	sCmd = "Select * from Win32_Share Where Name = '" & sName & "'"
	For Each oItem in GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2").ExecQuery(sCmd,,48)
		ShareProperty = Eval("oItem." & sProperty)
		Exit For
	Next
End Function

Function ShareCreate(sName, sPath)
	Dim sRet
	If Not DirExists(sPath) Then CreateDir sPath
	sRet = Cmd("net share " & sName & "=" & Q(sPath) & " /grant:Administrators,FULL /grant:Everyone,CHANGE")
	ShareCreate = InStr(sRet, "was shared successfully") > 0
End Function

Function ShareDelete(sName)
	ShareDelete = InStr(Cmd("net share " & sName & "/delete"), "was deleted successfully") > 0
End Function

Sub DotNetVersionShow
	Popup ".Net versjon", DotNetVersion, 5
End Sub

Function DotNetVersion
	'Returnerer versjon av .Net
	DotNetVersion = DotNetVersion4
	If DotNetVersion = "" Then
		Dim sPath, aKeys, i
		sPath = "HKLM\SOFTWARE\Microsoft\NET Framework Setup\NDP"
		'Evaluer alle undernkler utenom "CDF" og "v4.0"
		aKeys = Filter(Filter(RegSubKeys(sPath), "CDF", False, 1), "v4.0", False, 1)
		For i = UBound(aKeys) To 0 Step -1
			If RegKey(sPath & "\" & aKeys(i) & "\Install") = 1 Then
				DotNetVersion = Left(RegKey(sPath & "\" & aKeys(i) & "\Version"), 3)
				Exit For
			End If
		Next
	End If
End Function

Function DotNetVersion4
	'Returnerer versjon av .Net 4 dersom installert
	Dim releaseKey
	releaseKey = RegKey("HKLM\SOFTWARE\Microsoft\NET Framework Setup\NDP\v4\Full\Release")
	If releaseKey >= 460798 Then
		DotNetVersion4 = "4.7"
	ElseIf releaseKey >= 394802 Then
		DotNetVersion4 = "4.6.2"
	ElseIf releaseKey >= 394254 Then
		DotNetVersion4 = "4.6.1"
	ElseIf releaseKey >= 393295 Then
		DotNetVersion4 = "4.6"
	ElseIf releaseKey >= 379893 Then
		DotNetVersion4 = "4.5.2"
	ElseIf releaseKey >= 378675 Then
		DotNetVersion4 = "4.5.1"
	ElseIf releaseKey >= 378389 Then
		DotNetVersion4 = "4.5"
	End If
End Function

Function DotNetInstall(iDotNetLimit, sDotNetFile)
	'Todo: dialogboks - sikkerhetssk
	'Installerer .Net installasjonsfilen dersom .Net-versjon er lavere enn grensen (f.eks "4,5")
	'Returnerer Sann dersom installasjon er vellykket og tom streng dersom allerede installert
	Dim sNetVersion
	If Replace(Left(DotNetVersion, 3), ".", ",") >= iDotNetLimit Then Exit Function
	If Not FileExists(sDotNetFile) Then
		ExitWithError False, "DotNetInstall: Finner ikke " & Q(sDotNetFile)
	Else
		Msg2 "Apertura", "Installerer .Net...", "I", 0
		'Finn versjon i egenskapene for filen: Filbeskrivelse: Microsoft .NET Framework 4.6.2 Setup
		sNetVersion = Split(Filter( Split(FilePropertiesAll(sDotNetFile), vbNewLine), "Framework")(0), " ")(4)
		With CreateObject("WScript.Shell")
			.Run Q(sDotNetFile) & " /q /norestart", 0, True
		End With
		DotNetInstall = DotNetVersion = sNetVersion
		Msg2 "Apertura", "Installerer .Net...", "I", ""
	End If
End Function

Function RemoteRPC(sComputer, bState)
	'Setter evt ny verdi og returnerer tillatelse for Remote Procedure Call (RPC) p angitt maskin.
	'Krever tjenesten "Remote Registry" satt til oppstartstype: Manuelt eller Automatisk.
	Dim sKey, sVal, sRet
	If sComputer = "" Then sComputer = "."
	sKey = """\\" & sComputer & "\HKLM\SYSTEM\CurrentControlSet\Control\Terminal Server"" /v AllowRemoteRPC"
	Select Case bState
		Case True
			sVal = "0x1"
			Cmd "reg add " & sKey & " /t Reg_Dword /d " & sVal & " /f"
			sRet = RemoteRPC(sComputer, "")
		Case False
			sVal = "0x0"
			Cmd "reg add " & sKey & " /t Reg_Dword /d " & sVal & " /f"
			sRet = RemoteRPC(sComputer, "")
		Case Else
			sRet = Cmd("reg query " & sKey)
			If sRet <> "" Then sRet = LTrim(Mid(sRet, InStrRev(sRet, " "), 4)) = "0x1"
	End Select
	RemoteRPC = sRet
End Function

Function RootFolder(sName)
	'Returnerer Sann dersom mappe med oppgitt navn finnes i rotmappe
	Dim fso, s, i, sPath
	Set fso = CreateObject("Scripting.FileSystemObject")
	s = "abcdefghijklmnopqrstuvwxyz"
	With fso
		For i = 1 To Len(s)
			If .FolderExists(Mid(s, i, 1) & ":\" & sName) Then
				sPath = .GetFolder(Mid(s, i, 1) & ":\" & sName).Path
			End If
		Next
	End With
	Set fso = Nothing
	RootFolder = sPath
End Function

Function CurDir(ByVal sDir)
	'Hvis mappe er angitt returneres Sann dersom mappe kunne settes som gjeldende, ellers usann
	'Dersom mappe er uniform naming convention (UNC) oversettes den til local file system (LFS)
	'Hvis mappe ikke er angitt returneres gjeldene mappe med avsluttende skrstrek
	Dim aDir, str, ret
	With CreateObject("WScript.Shell")
		If sDir <> "" Then
			If Right(sDir, 1) = "\" Then sDir = Left(sDir, Len(sDir) - 1)
			If Left(sDir, 2) = "\\" Then
				aDir = Split(sDir & "\", "\")
				If UCase(aDir(2)) = ComputerName Then 
					str = ShareProperty(aDir(3), "path")
					If str <> "" Then
						sDir = str & Mid(sDir, Len(aDir(2)) + Len(aDir(3)) + 4)
					Else
						sDir = DrivePath(sDir)
					End If
				End If
			End If
			If DirExists(sDir) Then
				.CurrentDirectory = sDir
				ret = .CurrentDirectory = sDir
			Else
				ret = False
			End If
		Else
			ret = .CurrentDirectory
			If Right(ret, 1) <> "\" Then ret = ret & "\"
		End If
	End With
	CurDir = ret
End Function

Function xCurDir(sDir)
	'Hvis mappe er angitt returneres Sann dersom mappe kunne settes som gjeldende, ellers usann
	'Hvis mappe ikke er angitt returneres gjeldene mappe med avsluttende skrstrek
	Dim ret
	With CreateObject("WScript.Shell")
		If sDir <> "" Then
			If DirExists(sDir) Then
				.CurrentDirectory = sDir
				ret = .CurrentDirectory = sDir
			Else
				ret = False
			End If
		Else
			ret = .CurrentDirectory
			If Right(ret, 1) <> "\" Then ret = ret & "\"
		End If
	End With
	xCurDir = ret
End Function

Function ParentDir(spec)
	ParentDir = CreateObject("Scripting.FileSystemObject").GetParentFolderName(spec)
	If Right(ParentDir, 1) <> "\" Then ParentDir = ParentDir & "\"
End Function

Function xParentDir(spec)
	With CreateObject("Scripting.FileSystemObject")
		If .FolderExists(spec) Then
			ParentDir = .GetParentFolderName(spec) & "\"
		ElseIf .FileExists(spec) Then
			ParentDir = .GetParentFolderName(spec) & "\"
			If Right(ParentDir, 1) <> "\" Then ParentDir = ParentDir & "\"
		End If
	End With
End Function

Sub CreateDir(ByVal sPath)
	'Oppretter mappen(ene) i bane
	Dim aTmp, aPath, level, p
	'Sjekk om bane er del av delt mappe, finn i sfall reell bane
	If InStr(sPath, ":") = 0 Then
		aTmp = Split(sPath, "\")
		sPath = ShareProperty(aTmp(3), "path") & Mid(sPath, Len(aTmp(2)) + Len(aTmp(3)) + 4)
	End If
	If Right(sPath, 1) = "\" Then sPath = Left(sPath, Len(sPath) - 1)
	aPath = Split(sPath, "\")
	p = aPath(0) & "\"
	With CreateObject("Scripting.FileSystemObject")
		For level = 1 To UBound(aPath)
			If Not .FolderExists(p & aPath(level)) Then
				.GetFolder(p).SubFolders.Add(aPath(level))
			End If
			p = p & aPath(level) & "\"
		Next
	End With
End Sub

Function DeleteDir(folderspec)
	'Sletter mappen folderspec
	With CreateObject("Scripting.FileSystemObject")
		If .FolderExists(folderspec) Then .GetFolder(folderspec).Delete True
	End With
End Function

Function DirExists(folderspec)
	DirExists = CreateObject("Scripting.FileSystemObject").FolderExists(folderspec)
End Function

Function DirCreated(sDir)
	With CreateObject("Scripting.FileSystemObject")
		If .FolderExists(sDir) Then DirCreated = .GetFolder(sDir).DateCreated
	End With
End Function

Function FileExists(filespec)
	FileExists = CreateObject("Scripting.FileSystemObject").FileExists(filespec)
End Function

Function FileSize(filespec)
	'Returnerer strrelse i kB
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(filespec) Then FileSize = CLng(.GetFile(filespec).Size / 1024)
	End With
End Function

Function FileSizeB(filespec)
	'Returnerer strrelse i bytes
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(filespec) Then FileSizeB = .GetFile(filespec).Size
	End With
End Function

Function FileModified(filespec)
	'Returnerer tidspunkt for sist endret
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(filespec) Then FileModified = .GetFile(filespec).DateLastModified
	End With
End Function

Sub SetFileModified(sDir, sFileName, dt)
	With CreateObject("Shell.Application").NameSpace(CStr(sDir))
		.ParseName(CStr(sFileName)).ModifyDate = CStr(CDate(dt))
	End With
End Sub

Function CopyFile(filespec, ByVal destination)
	'Kopierer fil til destinasjon og overskriver dersom filen finnes.
	'Destinasjon kan angis som mappe med avsluttende "\" eller filbane.
	If Right(destination, 1) = "\" Then
		destination = destination & Split(filespec, "\")(UBound(Split(filespec, "\")))
	End If
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(filespec) And .FolderExists(.GetParentFolderName(destination)) Then
			.GetFile(filespec).Copy destination, True
		End If
	End With
End Function

Function MoveFile(filespec, ByVal Destination)
	'Dersom destinasjon er en mappe overskrives evt. fil med samme navn i mappe,
	'ellers flyttes filen fil til destinasjon, og gir feilmelding dersom filen finnes.
	If Right(Destination, 1) = "\" Then
		Destination = Destination & Mid(filespec, InStrRev(filespec, "\") + 1)
		DeleteFile Destination
	End If
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(filespec) And .FolderExists(.GetParentFolderName(Destination)) Then
			.GetFile(filespec).Move Destination
		End If
	End With
End Function

Function RenameFile(oldFilespec, newFilespec)
	MoveFile oldFilespec, newFilespec
End Function

Function DeleteFile(filespec)
	With CreateObject("Scripting.FileSystemObject")
		If .FileExists(filespec) Then .DeleteFile(filespec)
	End With
End Function

Function ProcPath(proc)
	'Returnerer filbanen til prosessen proc
	Dim objProcess, sq, v, c
	If IsNumeric(proc) Then v = "ProcessId" Else v = "Name"
	sq = "select * from Win32_Process where " & v & " = '" & proc & "'"
	For Each objProcess In GetObject("winmgmts:").ExecQuery(sq)
		c = objProcess.ExecutablePath
	Next
	If InStr(c, ":") Then
		ProcPath = Left(c, InStrRev(c, "\"))
	ElseIf c <> "" Then
		ProcPath = EnvVar("%windir%") & "\System32\"
	End If
End Function

Function ProcCount(sProcName)
	'Returnerer antall prosesser med navn sProcName som kjrer
	'Se ogs ProcCmdLineCount
	Dim aP
	aP = ProcID(sProcName)
	If aP(0) = 0 Then
		ProcCount = 0
	Else
		ProcCount = UBound(aP) + 1
	End If
End Function

Function ProcName(pid)
	Dim oProc
	For Each oProc In GetObject("winmgmts:").ExecQuery("Select * From Win32_Process Where ProcessId = '" & pid & "'")
		ProcName = oProc.Name
	Next
End Function

Function ProcID(sProcName)
	'Returnerer array med PID for alle prosesser ved navn sProcName
	'NB: Returnerer 0 - Array(0) - for tom matrise og ikke -1 - Array() - som er standard
	Dim oProc, pid
	For Each oProc In GetObject("winmgmts:").ExecQuery("Select * From Win32_Process Where Name = '" & sProcName & "'")
		pid = pid & vbTab & oProc.ProcessID
	Next
	If pid <> "" Then
		ProcID = Split(Mid(pid, 2), vbTab)
	Else
		ProcID = Array(0)
	End If
End Function

Function ProcIsRunning(proc)
	'Returnerer Sann dersom brukeren kjrer prosessen proc (navn eller pid)
	Dim v, objProcess, strNameOfUser, strUserDomain
	With GetObject("winmgmts:")
		If IsNumeric(proc) Then
			v = .ExecQuery("select * from Win32_Process where ProcessId = '" & proc & "'").Count > 0
		Else
			For Each objProcess In .ExecQuery("select * from Win32_Process where Name = '" & proc & "'")
				objProcess.GetOwner strNameOfUser, strUserDomain
				If strNameOfUser = UserName Then
					v = True
					Exit For
				End If
			Next
		End If
	End With
	ProcIsRunning = (v = True)
End Function

Function ProcCreationDate(proc)
	'Returnerer opprettelsestidspunkt for prosess med navn eller id (PID) lik proc
	Dim oProc, v
	If IsNumeric(proc) Then v = "ProcessId" Else v = "Name"
	For Each oProc In GetObject("winmgmts:").ExecQuery("Select * from Win32_Process Where " & v & " = '" & proc & "'")
		'20110127102514.015625+060 -> 27.01.2011 10:25:14
		ProcCreationDate = DateFromWmi(oProc.CreationDate)
		Exit For
	Next
End Function

Function ParentProcID(proc)
	'Returnerer id for overordnet prosess
	Dim oProc, v
	If IsNumeric(proc) Then v = "ProcessId" Else v = "Name"
	For Each oProc In GetObject("winmgmts:").ExecQuery("Select * from Win32_Process Where " & v & " = '" & proc & "'")
		ParentProcID = oProc.ParentProcessId
		Exit For
	Next
End Function

Function ProcCmdLineCount(proc, sCmdLine)
	'Returnerer antall prosesser hvor str inngr i kommandolinjen
	'Siden Ubound(InProcCmdLine()) er 0 bde ved 0 og 1 treff kan ikke InProcCmdLine brukes
	'Se ogs ProcCount
	Dim aP
	aP = InProcCmdLine(proc, sCmdLine)
	If aP(0) = 0 Then
		ProcCmdLineCount = 0
	Else
		ProcCmdLineCount = UBound(aP) + 1
	End If
End Function

Function InProcCmdLine(proc, sCmdLine)
	'Returnerer array med PID for prosesser hvor sCmdLine inngr i kommandolinje
	'NB: Returnerer 0 - Array(0) - for tom matrise og ikke -1 - Array() - som er standard
	Dim v, oProc, pid
	If IsNumeric(proc) Then v = "ProcessId" Else v = "Name"
	For Each oProc In GetObject("winmgmts:").ExecQuery("Select * From Win32_Process Where " & v & " = '" & proc & "'")
		'WE UCase(ProcCmdLine(oProc.ProcessID)) & vbNewLine & UCase(sCmdLine) & _
		'vbNewLine & InStr(UCase(ProcCmdLine(oProc.ProcessID)), UCase(sCmdLine))
		If InStr(UCase(ProcCmdLine(oProc.ProcessID)), UCase(sCmdLine)) > 0 Then
			pid = pid & oProc.ProcessID & vbTab
		End If
	Next
	If pid <> "" Then
		InProcCmdLine = Split(Left(pid, Len(pid) - 1), vbTab)
	Else
		InProcCmdLine = Array(0)
	End If
End Function

Function ProcCmdLine(proc)
	'Returnerer kommandolinje for prosess med navn eller id (PID) lik proc
	Dim v, oProc
	If IsNumeric(proc) Then v = "ProcessId" Else v = "Name"
	For Each oProc In GetObject("winmgmts:").ExecQuery("Select * from Win32_Process Where " & v & " = '" & proc & "'")
		If VarType(oProc.CommandLine) > 1 Then ProcCmdLine = oProc.CommandLine 'ikke vbNull
		Exit For
	Next
End Function

Function TerminateProc(sCmdline, ByVal sExceptionList)
	'Avslutter alle prosesser hvor sCmdline inngr i kommandolinjen, untatt navn p prosesser i sExceptionList
	Dim objWMIService, colProcessList, objProcess, list, retVal
	sExceptionList = UCase(sExceptionList)
	Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
	Set colProcessList = objWMIService.ExecQuery _
	("Select * from Win32_Process Where CommandLine LIKE '%" & sCmdline & "%'")
	For Each objProcess In colProcessList
		If InStr(sExceptionList, UCase(objProcess.Name)) = 0 Then
			retVal = EndProcID(objProcess.ProcessID)
			list = list & retVal & vbTab & objProcess.Commandline & vbNewLine
		End If
	Next
	TerminateProc = list
End Function

Function KillProc(proc)
	'Avslutter alle prosesser med navn eller id (PID) lik proc og returnerer antall
	'Benytt om mulig heller CloseProcID
	Dim objWMIService, colProcessList, objProcess, v, c
	If IsNumeric(proc) Then v = "ProcessId" Else v = "Name"
	Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")
	Set colProcessList = objWMIService.ExecQuery _
	("Select * from Win32_Process Where " & v & " = '" & proc & "'")
	For Each objProcess In colProcessList
		objProcess.Terminate
		c = c + 1
	Next
	KillProc = c * 1
End Function

Function KillProcCmdline(sProcName, sCmdline)
	'Avslutter alle prosesser hvor sCmdline inngr i kommandolinjen
	Dim sCmd, objProcess, c
	sCmd = "Select * from Win32_Process Where Name = '" & sProcName & "' AND CommandLine LIKE '%" & sCmdline & "%'"
	For Each objProcess In GetObject("winmgmts:\\.\root\cimv2").ExecQuery(sCmd)
		objProcess.Terminate
		c = c + 1
	Next
	KillProcCmdline = c * 1
End Function

Function NumInBrackets(str)
	'Returnerer tall som str i (siste) parentes i streng
	NumInBrackets = RegExSub(".*\[(-*\d+)\].*", str, "$1")
End Function

Function NumInParens(str)
	'Returnerer tall som str i (siste) parentes i streng
	NumInParens = RegExSub(".*\((-*\d+)\).*", str, "$1")
End Function

Function NextNumInParens(str, intAdd)
	'Returnerer streng hvor tall i (siste) parentes tillegges tall
	NextNumInParens = RegExSub("(.*\()\d*\).*", str, "$1") & CInt("0" & _
	RegExSub(".*\((-*\d+)\).*", str, "$1")) + intAdd & RegExSub(".*\(\d*(\).*)", str, "$1")
End Function

Function EmptyOrZero(value)
	'Returnerer Sann dersom verdi er "", "0", 0, False eller vbNullChar, ellers Usann
	EmptyOrZero = Abs("0" + value) = 0
End Function

Function HexToDec(strHex)
	'Konverterer hexadesimal til desimal. For motsatt bruk Hex()
	Dim lngResult, intIndex, strDigit, intDigit, intValue
	lngResult = 0
	For intIndex = Len(strHex) To 1 Step -1
		strDigit = Mid(strHex, intIndex, 1)
		intDigit = InStr("0123456789ABCDEF", UCase(strDigit))-1
		If intDigit >= 0 Then
			intValue = intDigit * (16 ^ (Len(strHex)-intIndex))
			lngResult = lngResult + intValue
		Else
			lngResult = 0
			intIndex = 0 ' stop the loop
		End If
	Next
	HexToDec = lngResult
End Function

Function DrivePath(sUNC)
	'Dersom UNC-bane inneholder bane til nettverksstasjon returneres UNC-bane erstattet av denne
	'ellers returneres UNC-bane
	Dim i
	If Left(sUNC, 2) = "\\" Then
		With CreateObject("WScript.Network").EnumNetworkDrives
			For i = 0 To .length - 1
				If InStr(UCase(sUNC), UCase(.Item(i))) Then
					DrivePath = .Item(i - 1) & Mid(sUNC, Len(.Item(i)) + 1)
					Exit For
				End If
			Next
		End With
	End If
	If DrivePath = "" Then DrivePath = sUNC
End Function

Function UNCPath(sPath)
	'Returnerer UNC-bane for bane dersom stasjon for bane er nettverksstasjon
	'ellers returneres bane
	Dim p
	If Mid(sPath, 2, 1) = ":" Then p = NetDrivePath(sPath)
	If p <> "" Then
		UNCPath = p & Mid(sPath, 3)
	Else
		UNCPath = sPath
	End If
End Function

Function NetDrivePath(sDrive)
	'Returnerer bane for nettverksstasjon
	'Stasjon kan angis med eller uten kolon
	Dim i
	With CreateObject("WScript.Network").EnumNetworkDrives
		For i = 0 To .length - 1
			If Left(.Item(i), 1) = Left(UCase(sDrive), 1) Then
				NetDrivePath = .Item(i + 1)
				Exit For
			End If
		Next
	End With
End Function

Function NetDriveLetter(sUNC)
	'Returnerer stasjonsbokstav for UNC-bane
	Dim i
	With CreateObject("WScript.Network").EnumNetworkDrives
		For i = 0 To .length - 1
			If UCase(.Item(i)) = UCase(sUNC) Then
				NetDriveLetter = .Item(i - 1)
				Exit For
			End If
		Next
	End With
End Function

Function UserName
	UserName = CreateObject("Wscript.Network").UserName
End Function

Function ComputerName
	ComputerName = CreateObject("Wscript.Network").ComputerName
End Function

Function ComputerFullName
	With CreateObject("Wscript.Network")
		ComputerFullName = .UserDomain & "\" & .ComputerName
	End With
End Function

Function FQDN
	'Returnerer Fully Qualified Domain Name
	On Error Resume Next
	FQDN = CreateObject("AdSystemInfo").DomainDNSName 'feiler dersom ikke domene
	On Error Goto 0
	With CreateObject("WScript.Network")
		If FQDN = "" Then
			FQDN = .ComputerName
		Else
			FQDN = .ComputerName & "." & FQDN
		End If
	End With
End Function

Function DomainName
	DomainName = CreateObject("WScript.Network").UserDomain
End Function

Function IsDomain
	IsDomain = EnvVar("%USERDNSDOMAIN%") <> "%USERDNSDOMAIN%"
End Function

Function AddTrustedSite(sDomainName)
	'Legger domene til under Lokalt intranett (egenskaper for Internett)
	Dim sKey
	sKey = "HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ZoneMap\Domains\\"
	With CreateObject("Wscript.Shell")
		.RegWrite sKey & sDomainName & "", "", "REG_SZ"
		.RegWrite sKey & sDomainName & "file", "1", "REG_DWORD"
	End With
End Function

Function NetComputers 'As Array
	'Returnerer navn alle maskiner p nettverket ved net view
	Dim aRet, aARP, i, sComputer, sMac, aTmp, sIP, sDHCP, str
	On Error Resume Next
	aRet = Filter(Split(CmdNor("net view"), vbNewLine), "\\")
	aARP = Split(CmdNor("arp -a"), vbNewLine)
	For i = 0 To UBound(aRet)
		sComputer = Mid(Left(aRet(i), InStr(aRet(i), " ") - 1), 3)
		sIP = "" : sMac = "" : sDHCP = ""
		sMac = ComputerMac(sComputer)
		If sMac <> "" Then
			aTmp = Filter(aARP, sMac)
			If UBound(aTmp) = 0 Then
				sIP = Trim(Left(aTmp(0), 18))
			Else
				aTmp = Filter(Split(Cmd("ping " & sComputer & " -n 1 -4 "), vbNewLine), "[")
				If UBound(aTmp) = 0 Then sIP = Split(Split(aTmp(0), "]")(0), "[")(1)
			End If
		End If
		If sIP <> "" Then sDHCP = DHCPEnabled(sComputer, IPGateway(sIP))
		aRet(i) = sComputer & vbTab & sIP & vbTab & sMac & vbTab & sDHCP
	Next
	NetComputers = aRet
End Function

Function NetComputersList
	NetComputersList = Join(NetComputers, vbNewLine)
End Function

Function NetWinComputersList
	'Returnerer liste med datamaskinnavn og navn p operativsystem for
	'Windows-maskiner p nettverket utifra Net View
	Dim aRet, sComputer, sOSName, sList
	On Error Resume Next
	aRet = Filter(Split(CmdNor("net view"), vbNewLine), "\\")
	For i = 0 To UBound(aRet)
		sComputer = Mid(Left(aRet(i), InStr(aRet(i), " ") - 1), 3)
		sOSName = OSName(sComputer)
		If InStr(sOSName, " Windows ") Then
			sList = sList & vbNewLine & sComputer & vbTab & sOSName
		End If
	Next
	If sList <> "" Then NetWinComputersList = Mid(sList, 3)
End Function

Function NetWinComputers 'As Array
	'Returnerer matrise med datamaskinnavn og navn p operativsystem for
	'Windows-maskiner p nettverket utifra Net View
	Dim sList, aComputers, aWin, i
	sList = NetWinComputersList
	If sList <> "" Then
		aComputers = Split(sList, vbNewLine)
		ReDim aWin(UBound(aComputers), 1)
		For i = 0 To UBound(aComputers)
			aWin(i,0) = Split(aComputers(i), vbTab)(0)
			aWin(i,1) = Split(aComputers(i), vbTab)(1)
		Next
	End If
	NetWinComputers = aWin
End Function

Function PSInfoOSName(sMachine) 'As Array
	'Returnerer matrise med datamaskinnavn og navn p operativsystem for
	'Windows-maskiner p nettverket ved bruk av PSInfo. Maskin som * for alle i domene.
	Dim arr, aRet, i, aTmp
	arr = PSInfo(sMachine, "Kernel version")
	ReDim aRet(UBound(arr), 1)
	For i = 0 To UBound(arr)
		aTmp = Split(arr(i), ",")
		aRet(i,0) = aTmp(0)
		aRet(i,1) = aTmp(1)
	Next
	PSInfoOSName = aRet
End Function

Function PSInfoOSNameDomain
	PSInfoOSNameDomain = PSInfoOSName("*")
End Function

Function PSInfoOSNameDomainList
	Dim arr, i, aTmp, sList
	arr = PSInfo("*", "Kernel version")
	For i = 0 To UBound(arr)
		aTmp = Split(arr(i), ",")
		sList = sList & vbNewLine & aTmp(0) & vbTab & aTmp(1)
	Next
	If sList <> "" Then PSInfoOSNameDomainList = sList
End Function

Function PSInfo(sMachine, sFilter) 'As Array
	'Returnerer PSInfo iht. filter for maskin (* for domene)
	',Windows Server 2016 Standard, Multiprocessor Free,
	Dim str
	str = Cmd(sInstallPath & "psinfo -accepteula \\" & sMachine & " -c " & Q(sFilter))
	PSInfo = Filter(Split(str, vbNewLine), "Multiprocessor Free")
End Function

Function Ping(sTarget)
	'Returnerer Sann ved svar, ellers Usann
	Dim oPingResult, cPingResults, tmp
	Set cPingResults = _
	GetObject("winmgmts://./root/cimv2").ExecQuery("SELECT " & _
	"* FROM Win32_PingStatus WHERE Address = '" & sTarget & "'")
'	On Error Resume Next
	For Each oPingResult In cPingResults
		If Not IsObject(cPingResults) Then
			tmp = False
		ElseIf oPingResult.StatusCode = 0 Then
			tmp = True
		Else
			tmp = False
		End If
	Next
	Set cPingResults = Nothing
	Ping = tmp
End Function

Function NHNIP
	NHNIP = IPFiltered("172.31.")
	If NHNIP = "" Then NHNIP = IP
End Function

Function ValidIP(sIP)
	'Sjekker om IP-adresse er gyldig (ogs ihht foregende nuller)
	Dim aIP, i
	ValidIP = True
	On Error Resume Next
	If sIP <> "0.0.0.0" Then aIP = Split(sIP, ".")
	If UBound(aIP) = 3 Then
		For i = 0 To UBound(aIP)
			If Not (aIP(i) >= 0 And aIP(i) <= 255 And Len(aIP(i)) = Len(CInt(aIP(i)))) Or (Err.Number > 0) Then
				ValidIP = False
			End If
		Next
	Else
		ValidIP = False
	End If
End Function

Function PublicIP
	'Returnerer ytre IP-adresse
	Dim a
	a = Split(Cmd("nslookup myip.opendns.com resolver1.opendns.com"), " ")
	PublicIP = Split(a(UBound(a)), vbNewLine)(0)
End Function

Function PublicIP2
	'Eller: 'http://www.trackip.net/ip' istedenfor 'ipinfo.io/ip'
	PublicIP2 = Cmd("@powershell -NoProfile -Command ""(new-object net.webclient).DownloadString('http://www.trackip.net/ip')""")
End Function

Function IP 'As String
	Dim sArp
	'Returnerer intern IP-adresse fra frste oppfring i ARP-bufferen (Address Resolution Protocol)
	sArp = Cmd("arp -a | findstr :")
	If sArp = "" Then
		IP = "0.0.0.0"
	Else
		IP = Split(sArp, " ")(1)
	End If
End Function

Function IPGateway(sIP)
	'Returnerer gateway for IP-adresse
	Dim IPConfig
	For Each IPConfig In GetObject("winmgmts:\\.\root\cimv2").ExecQuery("Select * from Win32_NetworkAdapterConfiguration")
		If Not IsNull(IPConfig.IPAddress) Then
			If IPConfig.IPAddress(0) = sIP Then
				IPGateway = Join(IPConfig.DefaultIPGateway)
				Exit For
			End If
		End If
	Next
End Function

Function ComputerIP(ByVal sComputer) 'As String
	'Returnerer IP-adresse for datamaskinnavn
	Dim sMac, aRet, str
	sMac = ComputerMac(sComputer)
	If sMac <> "" Then ComputerIP = MacToIP(sMac)
	If ComputerIP = "" Then
		aRet = Filter(Split(Cmd("nslookup " & sComputer), vbNewLine), "Address:")
		If UBound(aRet) > 0 Then ComputerIP = LTrim(Split(aRet(1), ":")(1))
	End If
	If ComputerIP = "" Then
		str = CmdWait("ping " & sComputer & " -n 1 ")
		If InStr(str, "[") > 0 Then
			ComputerIP = Split(Split(str, "]")(0), "[")(1)
		End If
	End If
End Function

Function IPComputerName(strIP)
	'Returnererer datamaskinnavn fra IP-adresse
	Dim objWMIService, colItems, objItem
	Const wbemFlagReturnImmediately = &h10
	Const wbemFlagForwardOnly = &h20
	On Error Resume Next 'dersom ikke datamaskin
	Set objWMIService = GetObject("winmgmts:\\" & strIP & "\root\cimv2")
	Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
	For Each objItem In colItems
		IPComputerName = objItem.Name
	Next
End Function 

Function IPFiltered(strFilter)
	'Returnerer IP-adresse for grensesnitt som treffer filter
	'Filter kan vre frste oktetter av gateway - f.eks "10.0."
	Dim a
	a = Filter(Split(Cmd("arp -a"), "Interface"), ": " & strFilter)
	If UBound(a) > -1 Then IPFiltered = Split(a(0), " ")(1)
End Function

Function IPByGateway(strComputer, strGateway)
	IPByGateway  = AdapterProperty(strComputer, strGateway, "IPAddress")(0)
End Function

Function DHCPEnabled(strComputer, strGateway)
	DHCPEnabled  = AdapterProperty(strComputer, strGateway, "DHCPEnabled")
End Function

Function AdapterProperty(ByVal strComputer, strGateway, sProperty)
	'Returnerer egenskap for adapter med angitt gateway (hel eller delvis streng)
	Dim sCmd, IPConfigSet, IPConfig
	If strComputer = "" Then strComputer = "."
	sCmd = "Select * from Win32_NetworkAdapterConfiguration"
	Set IPConfigSet = GetObject("winmgmts:\\" & strComputer & "\root\cimv2").ExecQuery(sCmd)
	For Each IPConfig In IPConfigSet
		If Not IsNull(IPConfig.DefaultIPGateway) Then
			If InStr(IPConfig.DefaultIPGateway(0), strGateway) Then
				AdapterProperty = Eval("IPConfig." & sProperty)
				Exit For
			End If
		End If
	Next
End Function

Function PciNicIndexes 'As Array
	'Returnerer matrise med indeks for nettverksadaptere (NIC) av type PCI
	Dim sQ, a, s
	sQ = "Select * from Win32_NetworkAdapter Where PNPDeviceID Like 'PCI\\%'"
	For Each a In GetObject("winmgmts:\\.\root\cimv2").ExecQuery(sQ)
		s = s & vbTab & a.Index
	Next
	If s <> "" Then PciNicIndexes = Split(Mid(s, 2), vbTab)
End Function

Sub Comspec32(sPath)
	'pner kommandovindu - som 32-bit p 64-bit system
	With CreateObject("Shell.Application")
		If InStr(LCase(WScript.Path), "syswow64") = 0 Then
			.ShellExecute EnvVar("%WINDIR%\SysWoW64\cmd.exe"),, sPath, "OPEN", 5 '5 for  f fokus
		Else
			.ShellExecute EnvVar("%WINDIR%\System32\cmd.exe"),, sPath, "OPEN", 5 '5 for  f fokus
		End If
	End With
End Sub

Sub Comspec64(sPath)
	'pner kommandovindu - som 64-bit p 64-bit system
	With CreateObject("Shell.Application")
		If InStr(LCase(WScript.Path), "syswow64") > 0 Then
			.ShellExecute EnvVar("%WINDIR%\Sysnative\cmd.exe"),, sPath, "OPEN", 5 '5 for  f fokus
		Else
			.ShellExecute EnvVar("%WINDIR%\System32\cmd.exe"),, sPath, "OPEN", 5 '5 for  f fokus
		End If
	End With
End Sub

Sub Comspec(sPath)
	'pner kommandovindu - som 64-bit p 64-bit system
	'Som Comspec64 men peker alltid p "C:\WINDOWS\system32\cmd.exe"
	If sPath = "" Then sPath = CurDir("")
	If InStr(LCase(WScript.Path), "syswow64") > 0 Then
		RunScript64 WScript.ScriptFullName & " " & Q("Comspec") & " """ & sPath & "", False
		WScript.Quit
	End If
	CreateObject("Shell.Application").ShellExecute EnvVar("%COMSPEC%"),, sPath, "OPEN", 1 '1 for  f fokus
End Sub

Function ElevCmd(cmdline)
	'Returnerer resultatet av kommandolinje kjrt p administratorniv
	Dim oSh, fso, sCmd, fOut, OutF, tmp
	Set fso = CreateObject("Scripting.FileSystemObject")
	With CreateObject("WScript.Shell")
		sCmd = .ExpandEnvironmentStrings("%COMSPEC%")
		fOut = fso.GetSpecialFolder(2) & "\" & fso.GetTempName
	End With
	CreateObject("Shell.Application").ShellExecute sCmd, " /C " & cmdline & ">" & fOut, "", "runas", 1
	'vent p tilgang til temp-fil
	On Error Resume Next
	Do
		If fso.GetFile(fOut).Size > 0 Then
			If Err.Number = 0 Then
				Set OutF = fso.OpenTextFile(fOut)
				tmp = OutF.ReadAll
				OutF.Close
				fso.DeleteFile(fOut)
				Exit Do
			End If
		End If
		WScript.Sleep 50
		Err.Clear
	Loop
	On Error Goto 0
	Set OutF = Nothing
	Set fso = Nothing
	ElevCmd = tmp
End Function

Function Cmd(cmdline)
	Cmd = CmdBits(cmdline, 32)
End Function

Function Cmd64(cmdline)
	Cmd64 = CmdBits(cmdline, 64)
End Function

Function CmdBits(cmdline, bBits)
	' Wrapper for getting StdOut from a console command
	Dim fOut, tmp, comspec
	With CreateObject("Scripting.FileSystemObject")
		If bBits = "32" Then
			If OSBits("") = 64 Then
				comspec = "%WINDIR%\SysWOW64\cmd.exe"
			Else
				Comspec = "%COMSPEC%"
			End If
		ElseIf .FileExists(EnvVar("%WINDIR%\Sysnative\cmd.exe")) Then
			comspec = "%WINDIR%\Sysnative\cmd.exe"
		Else
			comspec = "%WINDIR%\system32\cmd.exe"
		End If
		fOut = .GetSpecialFolder(2) & "\" & .GetTempName
		CreateObject("WScript.Shell").Run comspec & " /C " & cmdline & ">" & fOut, 0, True
		If .FileExists(fOut) Then
			If .GetFile(fOut).Size > 0 Then
				With .OpenTextFile(fOut)
					tmp = .ReadAll
					.Close
				End With
			End If
			.DeleteFile(fOut)
		End If
	End With
	CmdBits = tmp
End Function

Function CmdNor(cmdline)
	' Som Cmd men setter Code Page til Nordic (DOS) (865) og leser midlertidig tekstfil med TextFile()
	Dim fOut, tmp
'	WE "CmdNor: " & cmdline
	With CreateObject("Scripting.FileSystemObject")
		fOut = .GetSpecialFolder(2) & "\" & .GetTempName
		CreateObject("WScript.Shell").Run "%COMSPEC% /C chcp 865 & " & cmdline & ">" & fOut, 0, True
		If .FileExists(fOut) Then
			tmp = TextFile("IBM865", fOut)
			.DeleteFile(fOut)
		End If
	End With
	CmdNor = tmp
End Function

Function CmdWait(cmdline)
	' Returnerer utdata fra konsoll-kommando etter at konsoll er avsluttet
	' Benyttes av ComputerMac (for nbtstat)
	Dim fOut, pid
	With CreateObject("Scripting.FileSystemObject")
		fOut = .GetSpecialFolder(2) & "\" & .GetTempName
	End With
	pid = RunHidden(EnvVar("%COMSPEC%") & " /C " & cmdline & ">" & fOut)
	Do While ProcIsRunning(pid)
		WScript.Sleep 100
	Loop
	CmdWait = TextFromFile(fOut)
	DeleteFile fOut
End Function

Function RunHidden(proc)
	'Starter prosess med skjult vindu og returnerer pid
	Dim objConfig, errRet, pid
	Const HIDDEN_WINDOW = 12 'var tidligere angitt som 0
	'Const HIDDEN_WINDOW = 1 'NB: viser vinduet
	With GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2").Get("Win32_ProcessStartup")
		Set objConfig = .SpawnInstance_
	End With
	objConfig.ShowWindow = HIDDEN_WINDOW
	errRet = GetObject("winmgmts:root\cimv2:Win32_Process").Create(proc, Null, objConfig, pid)
	Set objConfig = Nothing
	RunHidden = pid
End Function

Sub ShellRunElev(s)
	With CreateObject("Shell.Application")
		.ShellExecute s, "", "", "runas", 1
	End With
End Sub

Sub RunScript32(sScript, bWait)
	'Kjrer sScript som 32-bit p 64-bit operativsystem
	Dim sPath
	If OSBits(".") = 64 Then sPath = "%WINDIR%\SysWOW64\WScript.exe "
	With CreateObject("WScript.Shell")
		.Run sPath & sScript, 0, CBool(bWait)
	End With
End Sub

Sub RunScript64(sScript, bWait)
	'Kjrer sScript som 64-bit dersom 64-bit operativsystem
	'NB: fungerer ikke som oppgave
	Dim sPath
	If OSBits(".") = 64 And InStr(1, UCase(WScript.Path), "SYSWOW64", 1) Then
		sPath = EnvVar("%WINDIR%\Sysnative\WScript.exe ")
	End If
	With CreateObject("WScript.Shell")
		.Run sPath & sScript, 0, CBool(bWait)
	End With
End Sub

Sub RunScriptElev32(sScript, bWait)
	'Kjrer sScript elevert (admin) som 32-bit p 64-bit
	Dim sPath
	If OSBits(".") = 64 Then sPath = EnvVar("%WINDIR%\SysWOW64\")
	With CreateObject("Shell.Application")
		.ShellExecute sPath & "WScript.exe", sScript, ScriptPath, "runas", 1
	End With
	Do While CBool(bWait) And ScriptIsRunning(sScript)
		WScript.Sleep 100
	Loop
End Sub

Function ExitWithError(bExit, strErr)
	Dim sType
	If WScript.ScriptName = "Apertura.vbs" Then
		ExitWithError = strErr
	Else
		If bExit = True Then sType = "S" Else sType = "W"
		Msg2 "Apertura", strErr, sType, 10
		AppendTextToFile Now & vbTab & strErr & vbNewLine, Error_File
		ExitWithError = True
	End If
	If bExit = True Then
		WScript.Quit
	ElseIf Err.Number <> 0 Then
		Err.Clear
	End If
End Function

Function DownloadToShare(sUrl, sFolder)
	Dim sPath, retVal
	sPath = ShareProperty(sShareName, "path")
	If DirExists(sPath) Then 
		If sFolder <> "" Then
			sPath = sPath & "\" & sFolder
			CreateDir sPath
		End If
		retVal = DownloadFile(sUrl, sPath)
	Else
		retVal = False
	End If
End Function

Function DownloadFile(sUrl, sPath)
	Dim sFileName, sRet
	If sPath = "" Then
		DownloadFile = False
		Exit Function
	End If
	If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
	sFileName = sPath & Mid(sUrl, InStrRev(sUrl, "/") + 1)
	sFileName = UrlDecode(Split(sFileName, "?")(0))
	If FileExists(sFileName) Then
'		DownloadFile = 1
		DeleteFile sFileName
'	Else
	End If
		sRet = NHNHttpSave(sUrl, sFileName, "")
		If sRet <> True Then
			DownloadFile = sRet
		Else
			DownloadFile = FileExists(sFileName)
		End If
'	End If
	WScript.Echo DownloadFile & " " & sFileName
End Function

Function xDownloadFile(sUrl, sPath)
	Dim sFileName, fso
	If sPath = "" Then
		DownloadFile = False
		Exit Function
	ElseIf Right(sPath, 1) <> "\" Then
		sPath = sPath & "\"
	End If
	sFileName = sPath & "\" & Mid(sUrl, InStrRev(sUrl, "/") + 1)
	If FileExists(sFileName) Then
		DownloadFile = 1
		Exit Function
	End If
	NHNHttpSave sUrl, sFileName, ""
	DownloadFile = FileExists(sFileName)
End Function

Function WinHttpPost(charset, sUrl, sBody, aHeader)
	'Returnerer innhold i url
	Dim tmp
	If charset = "" Then charset = "utf-8"
	With CreateObject("Scripting.FileSystemObject")
		tmp = .BuildPath(.GetSpecialFolder(2), .GetTempName)
	End With
	If WinHttpPostSave(sUrl, tmp, sBody, aHeader) Then WinHttpPost = TextFile(charset, tmp)
	DeleteFile tmp
End Function

Function WinHttpPostSave(sUrl, sFileName, sBody, aHeader)
	Const WinHttpRequestOption_UserAgentString = 0
	Const WinHttpRequestOption_SslErrorIgnoreFlags = 4
	Const WinHttpRequestOption_PROXYSETTING_DEFAULT   = 0
	Const WinHttpRequestOption_PROXYSETTING_PRECONFIG = 0
	Const WinHttpRequestOption_PROXYSETTING_DIRECT    = 1
	Const WinHttpRequestOption_PROXYSETTING_PROXY     = 2
	Dim oHttp, oStream, i
	On Error Resume Next
	Set oHttp = CreateObject("WinHttp.WinHttpRequest.5.1")
'	Set oHttp = CreateObject("MSXML2.ServerXMLHTTP.6.0")
	With oHttp
		If DomainName <> "KMB-PC" And DomainName <> "APERTURA" Then .SetProxy WinHttpRequestOption_PROXYSETTING_PROXY, NHNProxy, ""
		Set oStream = CreateObject("ADODB.Stream")
		oStream.Type = 1 'binary
		oStream.Open
		.open "POST", sUrl, False
		If IsArray(aHeader) Then
			If Not IsArray(aHeader(0)) Then
				.SetRequestHeader aHeader(0), aHeader(1)
			Else
				For i = 0 To UBound(aHeader)
					.SetRequestHeader aHeader(i)(0), aHeader(i)(1)
				Next
			End If
		End If
		.Send sBody
		oStream.Write .ResponseBody
	End With
	oStream.SaveToFile sFileName, 2
	oStream.Close
	Set oStream = Nothing
	Set oHttp = Nothing
	If Err.Number > 0 Then WinHttpPostSave = ExitWithError(False, "WinHttpPostSave: " & Err.Description)
	WinHttpPostSave = Err.Number = 0
End Function

Function HttpGet(charset, sUrl)
	'Returnerer innhold i url
	Dim tmp
	On Error Resume Next
	If charset = "" Then charset = "utf-8"
	With CreateObject("Scripting.FileSystemObject")
		tmp = .BuildPath(.GetSpecialFolder(2), .GetTempName)
	End With
	HttpSave sUrl, tmp
	HttpGet = TextFile(charset, tmp)
	DeleteFile tmp
End Function

Function HttpSave(sUrl, sFileName)
	Const WinHttpRequestOption_PROXYSETTING_PROXY = 2
	Dim oHttp
	On Error Resume Next
	Set oHttp = CreateObject("WinHttp.WinHttpRequest.5.1")
'	Set oHttp = CreateObject("MSXML2.ServerXMLHTTP.6.0")
	With oHttp
		If DomainName <> "APERTURA" Then .SetProxy WinHttpRequestOption_PROXYSETTING_PROXY, NHNProxy, ""
		.open "GET", sUrl, False
		.setTimeouts 1000 * 60 * 1, 1000 * 60 * 1, 1000 * 60 * 1, 1000 * 60 * 7
		.send
	End With
'	If Err.Number <> 0 Then WEQ "HttpSave: " & Err.Number & " " & Err.Description
'	If Err.Number <> 0 Then Err.Clear
	With CreateObject("Adodb.Stream")
		.type = 1 '//binary
		.Open
		.write oHttp.ResponseBody
		.Position = 0
		.SaveToFile sFileName, 2 '//overwrite
	End With
	Set oHttp = Nothing
	'Sjekk for feil 3001: "Argumentene er av feil type, utenfor lovlig omrde, eller i konflikt med hverandre."
	HttpSave = Err.Number = 0
End Function

Function NHNHttpGet(charset, sUrl, aHeader)
	'Returnerer innhold i url
	Dim tmp
	If charset = "" Then charset = "utf-8"
	With CreateObject("Scripting.FileSystemObject")
		tmp = .BuildPath(.GetSpecialFolder(2), .GetTempName)
	End With
	If NHNHttpSave(sUrl, tmp, aHeader) Then
		NHNHttpGet = TextFile(charset, tmp)
	End If
	DeleteFile tmp
End Function

Function NHNHttpSave(sUrl, sFileName, aHeader)
	'Som HttpSave men her tenkes flere optioner lagt inn. NB: Benyttes av ExpandRemote().
	'f.eks: NHNHttpSave sUrl, "C:\Nirsoft.zip", Array("Referer", "http://launcher.nirsoft.net/download.html")
'	WinHTTPRequest options:
'	Const WinHttpRequestOption_UserAgentString = 0
'	Const WinHttpRequestOption_URL = 1
'	Const WinHttpRequestOption_URLCodePage = 2
'	Const WinHttpRequestOption_EscapePercentInURL = 3
	Const WinHttpRequestOption_SslErrorIgnoreFlags = 4
'	Const WinHttpRequestOption_SelectCertificate = 5
'	Const WinHttpRequestOption_EnableRedirects = 6
'	Const WinHttpRequestOption_UrlEscapeDisable = 7
'	Const WinHttpRequestOption_UrlEscapeDisableQuery = 8
'	Const WinHttpRequestOption_SecureProtocols = 9
'	Const WinHttpRequestOption_EnableTracing = 10
'	Const WinHttpRequestOption_RevertImpersonationOverSsl = 11
'	Const WinHttpRequestOption_EnableHttpsToHttpRedirects = 12
'	Const WinHttpRequestOption_EnablePassportAuthentication = 13
'	Const WinHttpRequestOption_MaxAutomaticRedirects = 14
'	Const WinHttpRequestOption_MaxResponseHeaderSize = 15
'	Const WinHttpRequestOption_MaxResponseDrainSize = 16
'	Const WinHttpRequestOption_EnableHttp1_1 = 17
'	Const WinHttpRequestOption_EnableCertificateRevocationCheck = 18
	Const WinHttpRequestOption_PROXYSETTING_DEFAULT   = 0
	Const WinHttpRequestOption_PROXYSETTING_PRECONFIG = 0
	Const WinHttpRequestOption_PROXYSETTING_DIRECT    = 1
	Const WinHttpRequestOption_PROXYSETTING_PROXY     = 2
	Dim oHttp, i, chunksize, oStream, first, last
	On Error Resume Next
	Set oHttp = CreateObject("WinHttp.WinHttpRequest.5.1")
	With oHttp
'		.SetProxy WinHttpRequestOption_PROXYSETTING_PROXY, "proxy_server:80", "*.microsoft.com"
		If DomainName <> "APERTURA" Then .SetProxy WinHttpRequestOption_PROXYSETTING_PROXY, NHNProxy
'		.Open "GET", sUrl, False 'method, url, async
'		.Option(WinHttpRequestOption_SslErrorIgnoreFlags) = 13056
'		.Option(WinHttpRequestOption_EnableRedirects) = False
'		.Option(WinHttpRequestOption_MaxAutomaticRedirects) = 0
'		.Option(WinHttpRequestOption_EnableHttp1_1) = True
'		.Send
'		chunksize = 524288000 	'Max MB (1024*1024*500)
'		chunksize = 268435456	'256 MB (1024*1024*256)
		chunksize = 67108864	' 64 MB (1024*1024*64)
		Set oStream = CreateObject("ADODB.Stream")
		oStream.Type = 1 'binary
		oStream.Open
		i = 0
		Do
			first = i * chunksize
			last  = first + chunksize - 1
			.open "GET", sUrl, False
			.setTimeouts 1000 * 60 * 1, 1000 * 60 * 1, 1000 * 60 * 1, 1000 * 60 * 7
			.setRequestHeader "Range", "bytes=" & first & "-" & last
'			.SetRequestHeader "Cookie", "string"
'			.SetRequestHeader "Accept", "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8"
'			.SetRequestHeader "Accept", "*/*"
'			.SetRequestHeader "Referer", "http://launcher.nirsoft.net/download.html"
'			.SetRequestHeader "User-Agent", "Mozilla/4.0 (compatible; MSIE 5.00; Windows 98)"
'			.setRequestHeader "pragma", "no-cache"
'			.setRequestHeader "Cache-Control", "no-cache, no-store" 'ikke denne
'			.setRequestHeader "Cache-Control", "no-cache"
'			.SetAutoLogonPolicy(2)
			If IsArray(aHeader) Then
				If Not IsArray(aHeader(0)) Then
					.SetRequestHeader aHeader(0), aHeader(1)
				Else
					For i = 0 To UBound(aHeader)
						.SetRequestHeader aHeader(i)(0), aHeader(i)(1)
					Next
				End If
			End If
			.Send
			If .Status = 200 Or .Status = 206 Then
'				MsgBox .ResponseBody
				oStream.Write .ResponseBody
			End If
			i = i + 1
		Loop Until CLng(.getResponseHeader("Content-Length")) <> chunksize
	End With
	oStream.SaveToFile sFileName, 2
	oStream.Close
	Set oStream = Nothing
	Set oHttp = Nothing
	NHNHttpSave = Err.Number = 0
End Function

Function ComputerMac(sComputer)
	' Returnerer MAC-adresse for datamaskinnavn
	ComputerMac = LCase(Mid(CmdWait("NBTSTAT -a " & sComputer & " | FIND ""MAC Address"""), 19, 17))
End Function

Function IPToMac(sIP) 'As Array
	'Returnerer Mac-adresse for en IP-adresse
	Dim a
	a = Filter(Split(Cmd("arp -a " & sIP), vbNewLine), sIP)
	If UBound(a) = 0 Then IPToMac = RTrim(Mid(a(0), 25, 17))
End Function

Function MacToIP(strMac)
	'Returnerer IP-adresse for en Mac-adresse
	Dim s, sBMac, sTmp
	s = Cmd("arp -a")
	If InStr(s, strMac) Then
		If UBound(Split(s, strMac)) > 1 Then
			'flere forekomster av strMac - finn broadcast adressen og ping den for  oppdatere Arp
			sBMac = "ff-ff-ff-ff-ff-ff" 'broadcast MAC-adresse
			sTmp = Mid(s, InStr(s, strMac))
			Ping Trim(Left(Line(sTmp, ChunkIndex(sBMac, sTmp, vbNewLine)), 17))
			MacToIP = Trim(Left(InLine(strMac, Cmd("arp -a")), 17))
		Else
			MacToIP = Trim(Left(InLine(strMac, s), 17))
		End If
	End If
End Function

Function OSVersion(sComputer)
	'XP: 5,1	Server 2003, XP Pro x64: 5,2	Server2008, Vista: 6,0	Server 2008 R2, Windows 7: 6,1	Windows 8: 6,2
	Dim str
	str = OSVersionStr(sComputer)
	If str <> "" Then OSVersion = CDbl(Left(Replace(str, ".", ","), 3))
End Function

Function OSVersionStr(ByVal sComputer)
	'XP Home/Pro: 5.1.2600	Vista: Windows Vista 6.0.6000	Windows 7: 6.1.7601
	Dim str, colSettings, objOperatingSystem, v
	If sComputer = "" Then sComputer = "."
	str = "winmgmts:{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2"
	On Error Resume Next
	Set colSettings = GetObject(str).ExecQuery("Select * from Win32_OperatingSystem")
	If Err.Number = 462 Then Exit Function 'Feil: Den eksterne serveren finnes ikke eller er ikke tilgjengelig
	For Each objOperatingSystem In colSettings 
		v = objOperatingSystem.Version
		Exit For
	Next
	Set colSettings = Nothing
	Set objWMIService = Nothing
	OSVersionStr = v
End Function

Function OSName(ByVal sComputer)
	'Windows7: 6.1.7601
	Dim str, colSettings, oOS, v
	If sComputer = "" Then sComputer = "."
	str = "winmgmts:{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2"
	On Error Resume Next
	Set colSettings = GetObject(str).ExecQuery("Select * from Win32_OperatingSystem")
	If Err.Number = 462 Then Exit Function 'Feil: Den eksterne serveren finnes ikke eller er ikke tilgjengelig
	For Each oOS In colSettings 
		v = oOS.Name
		Exit For
	Next
	Set colSettings = Nothing
	Set objWMIService = Nothing
	OSName = RTrim(Left(v, InStr(v, "|") - 1))
End Function

Function OSBits(ByVal sComputer)
	'Returnerer 32 eller 64
	'Se for vrig: http://csi-windows.com/toolkit/csi-getosbits (31.08.2011)
	Dim str
	If sComputer = "" Then sComputer = "."
	str = "winmgmts:{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2:Win32_Processor='cpu0'"
	On Error Resume Next
	OSBits = GetObject(str).AddressWidth
End Function

Function MachineGuid
	' Unik nkkel for Windows-installasjon. F.eks: c75dc251-a2c6-4df5-a469-4428b8c0bbcf
	MachineGuid = RegKey64("HKLM\SOFTWARE\Microsoft\Cryptography\MachineGuid")
End Function

Function ReadBinaryKey(ByVal strKeyPath, strValueName) 'As Array
	Dim oReg, sType, aValue
	Const HKCR = &H80000000 'HKEY_CLASSES_ROOT
	Const HKCU = &H80000001 'HKEY_CURRENT_USER
	Const HKLM = &H80000002 'HKEY_LOCAL_MACHINE
	Const HKUS = &H80000003 'HKEY_USERS
	Const HKCC = &H80000005 'HKEY_CURRENT_CONFIG
	Set oReg = GetObject("Winmgmts:root\default:StdRegProv")
	sType = Left(strKeyPath, InStr(strKeyPath, "\") - 1)
	strKeyPath = Mid(strKeyPath, InStr(strKeyPath, "\") + 1)
	If Right(strKeyPath, 1) = "\" Then strKeyPath = Left(strKeyPath, Len(strKeyPath) - 1)
	Select Case sType
		Case "HKEY_CLASSES_ROOT",	"HKCR"
		oReg.GetBinaryValue HKCR, strKeyPath, strValueName, aValue
		Case "HKEY_CURRENT_USER",	"HKCU"
		oReg.GetBinaryValue HKCU, strKeyPath, strValueName, aValue
		Case "HKEY_LOCAL_MACHINE",	"HKLM"
		oReg.GetBinaryValue HKLM, strKeyPath, strValueName, aValue
		Case "HKEY_USERS", 			"HKUS"
		oReg.GetBinaryValue HKUS, strKeyPath, strValueName, aValue
		Case "HKEY_CURRENT_CONFIG", "HKCC"
		oReg.GetBinaryValue HKCC, strKeyPath, strValueName, aValue
	End Select
	Set oReg = Nothing
	ReadBinaryKey = aValue
End Function

Function WriteBinaryKey(ByVal strKeyPath, strValueName, aBinaryData)
	Dim oReg, sType
	Const HKCR = &H80000000 'HKEY_CLASSES_ROOT
	Const HKCU = &H80000001 'HKEY_CURRENT_USER
	Const HKLM = &H80000002 'HKEY_LOCAL_MACHINE
	Const HKUS = &H80000003 'HKEY_USERS
	Const HKCC = &H80000005 'HKEY_CURRENT_CONFIG
	Set oReg = GetObject("Winmgmts:root\default:StdRegProv")
	sType = Left(strKeyPath, InStr(strKeyPath, "\") - 1)
	strKeyPath = Mid(strKeyPath, InStr(strKeyPath, "\") + 1)
	If Right(strKeyPath, 1) = "\" Then strKeyPath = Left(strKeyPath, Len(strKeyPath) - 1)
	Select Case sType
		Case "HKEY_CLASSES_ROOT",	"HKCR"
		oReg.SetBinaryValue HKCR, strKeyPath, strValueName, aBinaryData
		Case "HKEY_CURRENT_USER",	"HKCU"
		oReg.SetBinaryValue HKCU, strKeyPath, strValueName, aBinaryData
		Case "HKEY_LOCAL_MACHINE",	"HKLM"
		oReg.SetBinaryValue HKLM, strKeyPath, strValueName, aBinaryData
		Case "HKEY_USERS", 			"HKUS"
		oReg.SetBinaryValue HKUS, strKeyPath, strValueName, aBinaryData
		Case "HKEY_CURRENT_CONFIG", "HKCC"
		oReg.SetBinaryValue HKCC, strKeyPath, strValueName, aBinaryData
	End Select
	Set oReg = Nothing
End Function

Function RegSearch(sPath, sValue)
	'Sker i registret for sValue under banen sPath og returerer antall treff.
	Dim aHits
	aHits = Split(Cmd("reg query " & sPath & " /s /f " & sValue), vbNewLine)
	RegSearch = Split(LTrim(Split(aHits(UBound(aHits) - 1), ":")(1)), " ")(0)
End Function

Function RegKey(sKey)
	'Returnerer verdien for sKey om dersom den finnes
	With CreateObject("WScript.Shell")
		On Error Resume Next
		RegKey = .RegRead(sKey)
		If IsNumeric(RegKey) Then RegKey = HexToDec(Hex(RegKey))
	End With
End Function

Function RegKey64(sKeyVal)
	Dim str, sKey, sVal, aVal
	On Error Resume Next
	str = String(4, " ")
	sKey = Left(sKeyVal, InStrRev(sKeyVal, "\"))
	sVal = Mid(sKeyVal, InStrRev(sKeyVal, "\") + 1)
	aVal = Split(Cmd64("reg query " & sKey & " /v " & sVal), vbNewLine)
	aVal = Split(Filter(aVal, str & sVal & str)(0), str)
	RegKey64 = aVal(UBound(aVal))
End Function

Function RegKeyExists(ByVal sKey)
	'Sjekker om nkkel eksisterer ved  lese den.
	'Eksisterer den ikke genereres feil og returneres usann, ellers sann.
	Dim oSh
	If Right(sKey, 1) <> "\" Then sKey = sKey & "\"
	On Error Resume Next
	With CreateObject("WScript.Shell")
		.RegRead(sKey)
	End With
	RegKeyExists = Err.Number = 0
End Function

Function RegSubKeys64(ByVal strKeyPath) 'As Array
	'Returnerer matrise med full bane til undernkler til angitt nkkel i 64-bit register
	RegSubKeys64 = Filter(Split(Cmd64("reg query " & strKeyPath), vbNewLine), strKeyPath, True, 1)
End Function

Function RegSubKeys(ByVal strKeyPath) 'As Array
	'Returnerer matrise med navn p undernkler til angitt nkkel i registeret.
	Dim oReg, sType, aSubKeys
	Const HKCR = &H80000000 'HKEY_CLASSES_ROOT
	Const HKCU = &H80000001 'HKEY_CURRENT_USER
	Const HKLM = &H80000002 'HKEY_LOCAL_MACHINE
	Const HKUS = &H80000003 'HKEY_USERS
	Const HKCC = &H80000005 'HKEY_CURRENT_CONFIG
	Set oReg = GetObject("Winmgmts:root\default:StdRegProv")
	sType = Left(strKeyPath, InStr(strKeyPath, "\") - 1)
	strKeyPath = Mid(strKeyPath, InStr(strKeyPath, "\") + 1)
	If Right(strKeyPath, 1) = "\" Then strKeyPath = Left(strKeyPath, Len(strKeyPath) - 1)
	Select Case sType
		Case "HKEY_CLASSES_ROOT",	"HKCR"
		oReg.EnumKey HKCR, strKeyPath, aSubKeys
		Case "HKEY_CURRENT_USER",	"HKCU"
		oReg.EnumKey HKCU, strKeyPath, aSubKeys
		Case "HKEY_LOCAL_MACHINE",	"HKLM"
		oReg.EnumKey HKLM, strKeyPath, aSubKeys
		Case "HKEY_USERS", 			"HKUS"
		oReg.EnumKey HKUS, strKeyPath, aSubKeys
		Case "HKEY_CURRENT_CONFIG", "HKCC"
		oReg.EnumKey HKCC, strKeyPath, aSubKeys
	End Select
	Set oReg = Nothing
	RegSubKeys = aSubKeys
End Function

Function IsADM
	'Returnerer Sann dersom admin eller Elevated, ellers Usann
	If OSVersion("") < 6.1 Then
		IsADM = CreateObject( "WScript.Shell" ).Run("CMD /C FSUTIL dirty query >nul", 0, True) = 0
	Else
		'Win7 og over
		IsADM = InStr(Cmd("whoami /groups"), "S-1-16-12288") > 0
	End If
End Function

Function FilePropertiesAll(filespec)
	'Returnerer alle filegenskaper som er angitt for filen ved bruk av Shell.Application
	'Antall egenskaper varierer mellom ulike versjoner av windows - hyeste verdi funnet 288
	Dim sPath, fn, oFolder, i, arrHeaders(300), s, sFileName, v
	With CreateObject("Scripting.FileSystemObject")
		sPath = .GetParentFolderName(filespec)
		fn = HideFileExt(.GetFileName(filespec))
	End With
	With CreateObject("Shell.Application").Namespace(sPath)
		For i = 0 To 299
			arrHeaders(i) = .GetDetailsOf(.Items, i)
		Next
		For Each sFileName In .Items
			If sFileName = fn Then
				For i = 0 To 299
					v = .GetDetailsOf(sFileName, i)
					If arrHeaders(i) <> "" And v <> "" Then s = s & vbNewLine & arrHeaders(i) & ": " & v
				Next
				Exit For
			End If
		Next
	End With
	FilePropertiesAll = Mid(s, 3)
End Function

Function UniqueName(ByVal sName)
	'Legger unikt nr i parentes etter navn dersom navn finnes (fil eller mappe - adskilt med mellomrom for mappe)
	Dim intEnd, sPath, sBase, sExt
	intEnd = 2
	With CreateObject("Scripting.FileSystemObject")
		If Not .FileExists(sName) And Not .FolderExists(sName) Then
			UniqueName = sName
		ElseIf .FileExists(sName) Then
			If RegExSub(".*\((-*\d+)\)\..*", sName, "$1") <> "" Then '>=0
				'k tall i parentes med 1
				Do While .FileExists(sName)
					sName = NextNumInParens(sName, 1)
				Loop
				UniqueName = sName
			Else
				sPath = .GetParentFolderName(sName)
				If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
				sBase = .GetBaseName(sName)
				sExt = .GetExtensionName(sName)
				Do While .FileExists(sPath & sBase & "(" & intEnd & ")." & sExt)
					intEnd = intEnd + 1
				Loop
				UniqueName = sPath & sBase & "(" & intEnd & ")." & sExt
			End If
		ElseIf .FolderExists(sName) Then
			sPath = .GetFolder(sName).Path
			Do While .FolderExists(sPath & " (" & intEnd & ")")
				intEnd = intEnd + 1
			Loop
			UniqueName = sPath & " (" & intEnd & ")"
			If Right(sName, 1) = "\" Then UniqueName = UniqueName & "\"
		End If
	End With
End Function

Function TmpFile(ByVal sFolder)
	'Oppretter tmp-fil med unikt navn i valgte mappe, eller i temp-mappe hvis ikke angitt
	Dim fso, oSh, sCurDir, tmp
	Set fso = CreateObject("Scripting.FileSystemObject")
	If sFolder <> "" Then
		sFolder = EnvVar(sFolder)
		If Right(sFolder, 1) <> "\" Then sFolder = sFolder & "\"
	Else
		sFolder = fso.GetSpecialFolder(2)
	End If
	With CreateObject("WScript.Shell")
		sCurDir = .CurrentDirectory
		.CurrentDirectory = sFolder
		tmp = fso.BuildPath(.CurrentDirectory, fso.GetTempName)
		.CurrentDirectory = sCurDir
	End With
	Set fso = Nothing
	TmpFile = UniqueName(tmp)
End Function

Function CopyText(sText)
	'Kopierer tekst til utklippstavla
	With CreateObject("AutoItX3.Control")
		CopyText = .ClipPut(sText)
	End With
End Function

Function Clipboard
	'Returnerer tekst fra utklippstavla
	With CreateObject("AutoItX3.Control")
		Clipboard = .ClipGet
		result = .error
	End With
End Function

Sub WEF(sParams)
	'Wscript.Echo.Function. Benyttes for  kalle opp funksjoner fra HoeKey. Frste parameter angir tittel.
	'Bindestrek foran et argument setter det i anfrselstegn. Resultatet evalueres og vises med WE().
	'Hvis det kun er ett argument - alts navn p funksjon - m dette st i anfrselstegn med bindestrek foran.
	Dim aP, i, s
		aP = Split(sParams, " ")
		For i = UBound(aP) To 1 Step - 1
			s = QParam(aP(i)) & ", " & s
		Next
		If UBound(aP) > 0 Then s = Left(s, Len(s) - 2)	'fjern siste ", "
		SetWindowTitle "Windows Script Host", aP(0), 30
		WE Eval(aP(0) & "(" & s & ")")
End Sub

Sub WE(ByVal sText)
	Dim sTmp, s
	On Error Resume Next
	If IsArray(sText) Then sText = Join(sText, vbNewLine)
	sTmp = Clipboard
	CopyText Replace(sText, vbLf, vbNewLine)
	WScript.Echo sText
	If sTmp <> "" Then CopyText sTmp
End Sub

Sub WEQ(sText)
	WE sText
	WScript.Quit
End Sub

Sub WQ
	MsgBox "Done"
	WScript.Quit
End Sub

Function Popup(sTitle, sMsg, intSecs)
	'Viser popup-dialogboks med tittel og tekst for angitt sekunder
	If sTitle = "" Then sTitle = WScript.ScriptName & " - Melding"
	If sMsg = "" Then sMsg = "Hva velger du?"
	If EmptyOrZero(intSecs) Then intSecs = 3
	With CreateObject("WScript.Shell")
		Popup = .Popup(sMsg, intSecs, sTitle, 35) 'sprsml
	End With
End Function

Function msg(sText, ByVal sTitle, waitSec)
	'Viser meldig i egen prosess for ikke  forsinke skript
	If sTitle = "" Then sTitle = Mid(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName, "\") + 1)
	RunScript32 ScriptPath & "msg.vbs " & Q(sText) & " " & Q(sTitle) & " " & Q(waitSec), False
End Function

Sub Msg2(sTitle, sText, sType, waitSec)
	'Viser melding i antall angitte sekunder. Dersom waitSec er 0 vises melding helt til Msg2 kalles opp med
	'waitSec som tom streng. Hvis tekst heller ikke er angitt avsluttes alle meldinger som kjres av denne
	'rutinen iht. flgende skestreng i kommadolinjen: |Msg2|<tittel>|<tekst>
	'Meldingen vises iht. oppgitt symbol som vist under.
	'Dersom en feilmelding vises avsluttes skriptet.
	Dim sTmpFile, bType, str
	If waitSec = "" Then
		KillProcCmdline "wscript.exe", "|Msg2|" & sTitle & "|" & sText
	Else
		Select Case UCase(Left(sType, 1))
			Case "", "I"		: bType = 64	'Info
			Case "Q"			: bType = 32	'Question
			Case "S", "E", "X"	: bType = 16	'Stop
			Case "W"			: bType = 48	'Warning	
		End Select
		sTmpFile = CreateObject("Scripting.FileSystemObject").GetSpecialFolder(2) & "\" & CDbl(Now) & ".vbs"
		If sTitle = "" Then str = Mid(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName, "\")) Else str = sTitle
		str = "CreateObject(""WScript.Shell"").Popup " & Q(sText) & "," & waitSec & "," & Q(str) & "," & bType
		TextToFile str, sTmpFile
		CreateObject("WScript.Shell").Run sTmpFile & " " & Q("|Msg2|" & sTitle & "|" & sText), 0, False
		WScript.Sleep 1000
		DeleteFile sTmpFile
		If bType = 16 Then WScript.Quit 'Error - Avslutt skript
	End If
End Sub

Function SQLServerDownload
	Dim sPath, sUrl
	sPath = ShareProperty("AperturaInstall", "path")
	If Not DirExists(sPath) Then WScript.Quit
	'sUrl = "https://download.microsoft.com/download/E/4/1/E4173890-A24A-4936-9FC9-AF930FE3FA40/NDP461-KB3102436-x86-x64-AllOS-ENU.exe"
	'WScript.Echo DownloadFile(sUrl, sPath)
	sUrl = "http://download.netop.com/latest_rc1220/NetopRemoteControlPacknDeploy.msi"
	WScript.Echo DownloadFile(sUrl, sPath)
End Function

Function MemoryTotalMB(strComputer)
	'Returnerer totalt minne i MB
	Dim sCmd, objItem, intCapacity
	If strComputer = "" Then strComputer = "."
	sCmd = "Select * from Win32_PhysicalMemory"
	On Error Resume Next
	For Each objItem in GetObject("winmgmts:\\" & strComputer & "\root\cimv2").ExecQuery(sCmd,,48)
	    intCapacity = intCapacity + CDbl(objItem.Capacity)
	Next
	MemoryTotalMB = intCapacity / 1024 / 1024
End Function

Function CPUInfo(strComputer) 'As Array
	'Returnerer matrise med antall kjerner for hver cpu
	'Ubound(CPUInfo("")) + 1 angir antall prosessorer
	Dim sCmd, objItem, aInfo, iCount, sCores, i
	If strComputer = "" then strComputer = "."
	sCmd = "Select * from Win32_Processor"
	On Error Resume Next
	For Each objItem in GetObject("winmgmts:\\" & strComputer & "\root\cimv2").ExecQuery(sCmd,,48)
		iCount = iCount + 1
		sCores = sCores & objItem.NumberOfCores & vbTab
	Next
	ReDim aInfo(iCount - 1)
	For i = 0 To iCount - 1
		aInfo(i) = Split(sCores, vbTab)(i)
	Next
	CPUInfo = aInfo
End Function

Function Service(name, action, strComputer)
	'Hvis action er start/stop returneres tilstand nr denne endres (venter opptil 30 sek).
	'Hvis action ikke er angitt returneres nvrende tilstand for tjenesten.
	'Hvis det er feil p tjenesten returneres ExitCode (se Windows/System Error Codes)
	'Funksjonen kaller seg selv for  la GetObject fange opp evt ny tilstand.
	Dim a, objItem, s, n
	a = LCase(action)
	If strComputer = "" Then strComputer = "."
	If a <> "" Then DeleteFile ScriptPath & "services.txt"
	On Error Resume Next
	For Each objItem In GetObject("winmgmts:{impersonationLevel=Impersonate}!\\" & strComputer & "\root\cimv2").ExecQuery _
		("Select * from Win32_Service Where Name = '" & name & "'",,48)
'		objItem.ErrorControl = "Ignore"
		s = objItem.ExitCode
		If s <> 0 Then Exit For
		s = objItem.State
		If a = "" Then
			Exit For
		ElseIf a = "start" Then
			objItem.StartService
		ElseIf a = "stop" Then
			objItem.StopService
		End If
		n = Now + TimeSerial(0, 0, 30)
		Do While (Now < n) And (Err.Number = 0)
			If (a = "start" And s = "Running") Or (a = "stop" And s = "Stopped") Then
				s = True
				Exit For
			End If
			WScript.Sleep 500
			s = Service(name, "", strComputer)
		Loop
		Exit For
	Next
	If Err.Number > 0 Then
		Service = Err.Number & ": " & Err.Description
	Else
		Service = s
	End If
End Function

Function ServiceExists(sName, sComputer) 'As Array
	'Returnerer matrise med fullt navn p tjeneste(r) dersom treff p angitt navnestreng
	'Bruk % som wildchar foran, bak og/eller midt i navnestreng.
	Dim sCmd, oItem, str
	If sComputer = "" Then sComputer = "."
	sCmd = "Select * from Win32_Service Where Name Like '" & sName & "'"
	On Error Resume Next
	For Each oItem In GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2").ExecQuery(sCmd,,48)
		str = str & vbTab & oItem.Name
	Next
	If Err.Number = 462 Then Exit Function 'Feil: Den eksterne serveren finnes ikke eller er ikke tilgjengelig
	If str <> "" Then
		ServiceExists = Split(Mid(str, 2), vbTab)
	Else
		ServiceExists = Array()
	End If
End Function

Function ScriptIsRunning(ByVal strFileName)
	'Returnerer Sann dersom skriptet strFileName kjrer fra fr
	'strFileName kan utelates dersom strFileName er navn p skriptet som kjrer
	'Eks: ScriptIsRunning(ScriptPath & "fma - test.vbs") '07.09.2008 07:17
	Dim sq, objProcess, isRunning, isRunning1, v
	sq = "Select * From Win32_Process Where Name = 'wscript.exe'"
	If strFileName = "" Then strFileName = WScript.ScriptFullName
	If Len(strFileName) < 2 Then WScript.Quit 'Len(VBNull) = 1
	strFileName = LCase(strFileName)
	If InStr(strFileName, Chr(34)) Then strFileName = Replace(strFileName, Chr(34), "")
	ScriptIsRunning = False
	For Each objProcess In GetObject("winmgmts:").ExecQuery(sq)
		v = LCase(objProcess.CommandLine)
		If InStr(v, Chr(34)) Then v = Replace(v, Chr(34), "")
		'Kommandolinje inneholder ikke alltid anfrselstegn
		If v <> "" And InStr(v, strFileName) Then
			If strFileName <> LCase(WScript.ScriptFullName) Or isRunning1 Then
				ScriptIsRunning = True
				Exit For
			End If
			isRunning1 = True
		End If
	Next
End Function

Function ScriptArgsToCmdLine
	'Returnerer fullstendig kommandolinje for skript.
	'NB: Etter navnet p hndterer settes pflgende parametre i anfrselstegn med bindestrek foran.
	'Benyttes av ScriptWithHold (som igjen benyttes av Execute_SKYPE_Args).
	Dim s, i
	With WScript.Arguments
		If .Count > 0 Then
			s = " " & .Item(0)
			For i = 1 To .Count - 1
				s = s & " -" & QParam(.Item(i))
			Next
			If ProcCmdLineCount("WScript.exe", Q(WScript.FullName) & " " & Q(WScript.ScriptFullName) & s) > 0 Then
				ScriptArgsToCmdLine = Q(WScript.FullName) & " " & Q(WScript.ScriptFullName) & s
			Else
				ScriptArgsToCmdLine = "wscript " & Q(WScript.ScriptFullName) & s ' kalt opp fra HoeKey
			End If
		Else
			'ScriptArgsToCmdLine = Q(WScript.FullName) & " " & Q(WScript.ScriptFullName)
			ScriptArgsToCmdLine = ProcCmdLine(InProcCmdLine("WScript.exe", WScript.ScriptFullName)(0))
		End If
	End With
End Function

Function ZipAdd(ByVal sZipFile, sFolder, timeout)
	'Oppretter Zip-fil for angitt mappe og viser evt. dialogboks: Komprimerer...
	'sZipFile kan angis med avsluttende "\" for bane og navn p mappen som zip-navn
	'eller tom for zip med samme navn p samme sted. Timeout = 0 timer ut etter 1 time.
	Dim n
	If timeout = "" Then timeout = 0
	If Right(sFolder, 1) <> "\" Then sFolder = sFolder & "\"
	If sZipFile = "" Then
		sZipFile = Left(sFolder, InStrRev(sFolder, "\")) & ".zip"
	ElseIf Right(sZipFile, 1) = "\" Then
		sZipFile = sZipFile & Split(sFolder, "\")(UBound(Split(sFolder, "\")) - 1) & ".zip"
	ElseIf LCase(Right(sZipFile, 4)) <> ".zip" Then
		sZipFile = sZipFile & ".zip"
	End If
	CreateDir Left(sZipFile, InStrRev(sZipFile, "\"))
    On Error Resume Next
    TextToFile Chr(80) & Chr(75) & Chr(5) & Chr(6) & String(18, 0), sZipFile
    n = Now + TimeSerial(Abs(timeout = 0), timeout, 0)
    With CreateObject("Shell.Application")
    	.Namespace(sZipFile).CopyHere .Namespace(sFolder).Items, 20 ' 4 + 16 no progress bar, yes to all dialogs
		'Vent til alle filer er kopiert
	    Do While (.Namespace(sZipFile).items.Count <> .Namespace(sFolder).items.Count) And Now < n
	    	WScript.Sleep 200
	    Loop
	    ZipAdd = Err.Number = 0 And .Namespace(sZipFile).items.Count = .Namespace(sFolder).items.Count
    End With
End Function

Function ZipContent(ByVal oZip)
	'Returnerer innhold i zip-fil som liste
	Dim oSa, item
	Set oSa = CreateObject("Shell.Application")
	If Not IsObject(oZip) Then
		Set oZip = oSa.NameSpace(oZip).Items
	End If
	For Each item In oZip
		If item.IsFolder Then
			strZipContentList = strZipContentList & item.Path & "/" & vbNewLine
			ZipContent oSa.NameSpace(item.GetFolder).Items
		Else
			strZipContentList = strZipContentList & item.Path & vbNewLine
		End If
	Next
	Set oZip = Nothing
	Set oSa = Nothing
	ZipContent = strZipContentList
End Function

Function ZipExtract(sZipFile, sDest)
	'Ekstraherer filer i zip til destinasjon
	Dim FilesInZip
	CreateDir sDest
	With CreateObject("Shell.Application")
		set FilesInZip = .NameSpace(sZipFile).items
'		weq FilesInZip.item(0).path 'OK
'		weq FilesInZip.item(1).path 'OK
		.NameSpace(sDest).CopyHere(FilesInZip)
	End With
End Function

Function UAC(sState)
	' User Account Control / Brukerkontokontroll. M kjres som administrator. Tilstand = 0 slr UAC av, ellers p.
	' Dersom tilstand er angitt returneres hvorvidt denne kunne settes, ellers Sann eller Usann for UAC.
	Dim sKey, iVal
	sKey = "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System"
	If sState <> "" Then
		Select Case sState
			Case 0		: iVal = 0
			Case Else	: iVal = 5
		End Select
		If IsADM Then
			Cmd "%windir%\System32\reg.exe ADD " & sKey & " /v ConsentPromptBehaviorAdmin /t REG_DWORD /d " & iVal & " /f"
			Cmd "%windir%\System32\reg.exe ADD " & sKey & " /v PromptOnSecureDesktop /t REG_DWORD /d " & Abs(iVal = 5) & " /f"
		End If
	Else
		iVal = 5
	End If
	UAC = RegKey(sKey & "\ConsentPromptBehaviorAdmin") = iVal
End Function

Function InstalledProgs(strComputer, aProps, aNameFilter)
	'Returnerer liste over navn[{tab}egenskap1{tab}egenskap2] p installerte programmer iht. filter
	' og ? dersom feil oppstr.
	Dim sCmd, obj, i, sProg, sList
	If strComputer = "" Then strComputer = "."
	If Not IsArray(aProps) Then aProps = Split(aProps, ",")
	aProps = Filter(aProps, "Name", False, 1)
	If Not IsArray(aNameFilter) Then aNameFilter = Split(aNameFilter, ",")
	sCmd = "SELECT * FROM Win32_Product"
	If UBound(aNameFilter) > -1 Then
		sCmd = sCmd & " where "
		For i = 0 To UBound(aNameFilter)
			sCmd = sCmd & "Name Like '%" & aNameFilter(i) & "%' Or "
		Next
		sCmd = Left(sCmd, Len(sCmd) - 3)
	End If
	On Error Resume Next
	With GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
		For Each obj in .ExecQuery(sCmd)
			sProg = obj.Name & vbTab
			For i = 0 To UBound(aProps)
				sProg = sProg & Eval("obj." & aProps(i)) & vbTab
			Next
			sList = sList & vbNewLine & Left(sProg, Len(sProg) - 1)
		Next
	End With
	If Err.Number > 0 Then
		InstalledProgs = "Error: " & Err.Number
	ElseIf sList <> "" Then
		InstalledProgs = Mid(sList, 3)
	End If
End Function

Function UrlEncode(ByVal str)
	With CreateObject("MSScriptControl.ScriptControl")
		.Language = "JScript"
	    str = .CodeObject.encodeURIComponent(str)
	    str = Replace(str, "'", "%27")
	    UrlEncode = Replace(str, """", "%22")
    End With
End Function

Function UrlDecode(ByVal str)
	With CreateObject("MSScriptControl.ScriptControl")
		.Language = "JScript"
	    str = Replace(str, "+", " ")
	    UrlDecode = .CodeObject.decodeURIComponent(str)
    End With
End Function

Function URLDecode2(str)
	'ok med 
	Dim list, strLen, i, sT, depth, by, val, sR 
    set list = CreateObject("System.Collections.ArrayList")
    strLen = Len(str)
    for i = 1 to strLen
        sT = mid(str, i, 1)
        if sT = "%" then
            if i + 2 <= strLen then
                list.Add cbyte("&H" & mid(str, i + 1, 2))
                i = i + 2
            end if
        else
            list.Add asc(sT)
        end if
    next
    depth = 0
    for each by in list.ToArray()
        if by and &h80 then
            if (by and &h40) = 0 then
                if depth = 0 then Err.Raise 5
                val = val * 2 ^ 6 + (by and &h3f)
                depth = depth - 1
                if depth = 0 then
                    sR = sR & chrw(val)
                    val = 0
                end if
            elseif (by and &h20) = 0 then
                if depth > 0 then Err.Raise 5
                val = by and &h1f
                depth = 1
            elseif (by and &h10) = 0 then
                if depth > 0 then Err.Raise 5
                val = by and &h0f
                depth = 2
            else
                Err.Raise 5
            end if
        else
            if depth > 0 then Err.Raise 5
            sR = sR & chrw(by)
        end if
    next
    if depth > 0 then Err.Raise 5
    URLDecode2 = sR
End Function

Function URLDecode3(ByVal str)
'URL decode Function
'2001 Antonin Foller, PSTRUH Software, http://www.motobit.com
  Dim Pos, pPos, Stream
  'replace + To Space
  str = Replace(str, "+", " ")
  on error resume Next
  Set Stream = CreateObject("ADODB.Stream")
  If Err.Number = 0 Then 'URLDecode using ADODB.Stream, If possible
    on error goto 0
    Stream.Type = 2 'String
    Stream.Open
    'replace all %XX To character
    Pos = InStr(1, str, "%")
    pPos = 1
    Do While Pos > 0
      Stream.WriteText Mid(str, pPos, Pos - pPos) + _
        Chr(CLng("&H" & Mid(str, Pos + 1, 2)))
      pPos = Pos + 3
      Pos = InStr(pPos, str, "%")
    Loop
    Stream.WriteText Mid(str, pPos)
    'Read the text stream
    Stream.Position = 0
    URLDecode3 = Stream.ReadText
    'Free resources
    Stream.Close
  Else 'URL decode using string concentation
    on error goto 0
    'UfUf, this is a little slow method. 
    'Do Not use it For data length over 100k
    Pos = InStr(1, str, "%")
    Do While Pos > 0 
      str = Left(str, Pos-1) + _
        Chr(Clng("&H" & Mid(str, Pos+1, 2))) + _
        Mid(str, Pos+3)
      Pos = InStr(Pos+1, str, "%")
    Loop
    URLDecode3 = str
  End If
End Function

Function Unicode2Ansi(ByVal str)
	' Erstatter unicode med ANSI (Windows-1252), f.eks:
	'\u00e6\u00c6\u00f8\u00d8\u00e5\u00c5 -> 
	'For Code Page 1252 Windows Latin 1 (ANSI) se https://msdn.microsoft.com/en-us/library/cc195054.aspx
	'For "\u2013" og "\u2014" se https://stackoverflow.com/questions/4000392/how-to-parse-word-created-special-chars-in-java
	Dim arr, i
	str = Replace(str, "\u2013", "\u0096") '"" lang bindestrek
	str = Replace(str, "\u2014", "\u0097") '"" ekstra lang bindestrek
	arr = RegEx("\\u00[a-fA-F0-9][a-fA-F0-9]", str)
	For i = 0 To UBound(arr)
		str = Replace(str, arr(i), Chr(HexToDec(Mid(RegEx("\\u00[a-fA-F0-9][a-fA-F0-9]", str)(0), 4))))
	Next
	Unicode2Ansi = str
End Function

Sub SetHTML(objHtml, strHtml)
	'For bruk:	object.documentElement.document
	'			object.documentElement.outerHtml
	'			object.body.innerHTML
	Set objHtml = CreateObject("HTMLFile")
	With objHtml
		.open
		.write strHtml
		WScript.Sleep 1 'M vre der i Win10
		.close
	End With
End Sub

Function Locate(sFile)
	'Kjrer Where i kommandolinje for  lokalisere filen
	Locate = Split(Cmd("Where " & sFile), vbNewLine)(0)
End Function

Function CurrentTimeZone
	'returnerer gjeldende tidssone i timer inkl sommertid
	Dim LocalTimeZone
	'Use Win32_ComputerSystem CurrentTimeZone property, because it automatically adjusts the
	'Time Zone bias for daylight saving time. Win32_Time Zone Bias property does not.
	'Get the machines current time zone offset
	For Each LocalTimeZone In GetObject("winmgmts:").InstancesOf("Win32_ComputerSystem")
		CurrentTimeZone = LocalTimeZone.CurrentTimeZone / 60
	Next
End Function

Function LocalDateTime(UTCDt)
	Dim dt
	dt = CDate(UTCDt) - TimeSerial(CurrentTimeZone, 0, 0)
	LocalDateTime = FormatDateTime(dt, 0) & " " & FormatDateTime(dt, 3)
End Function

Function UTCDate(dt)
	' Returnerer UTC for dato og tid
	With CreateObject("WbemScripting.SWbemDateTime")
		.SetVarDate(dt)
		UTCDate = .GetVarDate(False)
	End With
End Function

Function WmiDate(dateTime)
	'Konverterer fra dato til CIM_DATETIME (f.eks: 20140119050753.000000+060)
	'(Common Information Model): yyyymmddHHMMSS.mmmmmmsUUU
	'alternatively 'yyyy-mm-dd HH:MM:SS:mmm' only when used in WMI Query Language queries
	With CreateObject("WbemScripting.SWbemDateTime")
		.SetVarDate(dateTime)
		WmiDate = .Value
	End With
End Function

Function SqlDate(dt)
	'Returnerer dato i format 2013-09-14 00:07:59
	SqlDate = Year(dt) & "-" & Right("0" & Month(dt), 2) & "-" & Right("0" & Day(dt), 2) & " " & CStr(TimeValue(dt))
End Function

Function DateFromISO(sISODate)
	'ISO 8601 "2016-10-06T17:24:37Z" -> dato (06.10.2016 17.24.37)
	DateFromISO = DateAdd("h", CurrentTimeZone, CDate(Replace(Replace(sISODate, "T", " "), "Z", "")))
End Function

Function DateToISO(dt)
	'Dato og tid -> "2016-10-06T17:24:37Z" (UTC) ISO 8601 
	DateToISO = Replace(Replace(SqlDate(UTCDate(dt)), ".", ":"), " ", "T") & "Z"
End Function

Sub NetworkState(sComputer, sIP, bStatic)
	'Bytter mellom dynamisk og statisk IP iht. forvalg for statisk
	'Benytter forvalgt IP dersom satt, ellers nvrende.
	Dim sCmd, adapter, aIP, aSubnet, aGateway, aDNS, str, sRet
	If sComputer = "" Then sComputer = "."
	sCmd = "Select * from Win32_NetworkAdapterConfiguration where IPEnabled=TRUE"
	For Each adapter In GetObject("winmgmts:\\" & sComputer & "\root\cimv2").ExecQuery(sCmd)
		With adapter
			If sIP <> "" Then aIP = Array(sIP) Else aIP = .IPAddress
			aSubnet = .IPSubnet
			aGateway = .DefaultIPGateway
			aDNS = .DNSServerSearchOrder
			If sComputer = "." Then str = ComputerName Else str = sComputer
			str = "Nettverkskonfigurasjon for " & str & vbNewLine
			str = str & Join(Array("IP-adresse: " & aIP(0), "Subnett: " & aSubnet(0), "Gateway: " & aGateway(0)), vbNewLine)
			str = str & vbNewLine & "Foretrukket DNS-server: " & aDNS(0) & vbNewLine & "Alternativ DNS-server:" & aDNS(1)
			If .DHCPEnabled And bStatic <> False Then
				If MsgBox(str, vbYesNo, "Endre til statisk IP-adresse?") <> 6 Then Exit Sub
				sRet = .EnableStatic(Array(aIP(0)), Array(aSubnet(0)))
				sRet = .SetDNSServerSearchOrder(aDNS)
'				sRet = .SetGateways(Array(aGateway(0)), Array(1)) 'med metric 1
				sRet = .SetGateways(Array(aGateway(0)))
			ElseIf Not .DHCPEnabled And bStatic <> True Then
				If MsgBox(str, vbYesNo, "Endre til dynamisk IP-adresse?") <> 6 Then Exit Sub
				sRet = .EnableDHCP
				sRet = .SetDNSServerSearchOrder
			End If
		End With
		Exit For
	Next
End Sub

Sub SetNHNComputerTimeNO
	Dim sDateTime
'	sDateTime = IEDateTimeNO
	sDateTime = HttpDateTimeNO
	If sDateTime <> "" Then
		SetComputerTime ".", sDateTime + TimeSerial(0,0,1)
	End If
End Sub

Function HttpDateTimeNO
	Dim sUrl, html, str, sDate
	sUrl = "https://www.timeanddate.no/klokka/i/norge/oslo"
	str = HttpGet("", sUrl)
	If str = "" Then Exit Function
	SetHTML html, str
	sDate = html.getElementById("ctdat").innerText
	If sDate <> "" Then
		sDate = LTrim(Mid(sDate, InStr(sDate, " "))) 'fjern ukedag
		HttpDateTimeNO = CDate(sDate & " " & html.getElementById("ct").innerText)
	End If
End Function

Function IEDateTimeNO
	'Returnerer klokka i format "dd:mm:yyyy tt:mm:ss" fra timeanddate.no
	Dim sUrl, oIE, sDate
	bDebug = True 'IE kan uansett ikke skjules. Fungerer ikke ved False
	sUrl = "https://www.timeanddate.no/klokka/i/norge/oslo"
	If Not SetObjIE(sUrl, oIE) Then Exit Function
	sDate = oIE.document.getElementById("ctdat").innerText
	If sDate <> "" Then
		sDate = LTrim(Mid(sDate, InStr(sDate, " ")))
		IEDateTimeNO = CDate(sDate & " " & oIE.document.getElementById("ct").innerText)
	End If
	QuitObjIE oIE
End Function

Sub SetComputerTime(sComputer, ByVal sDateTime)
	Dim sCmd, oOS
	sCmd = "Select * From Win32_OperatingSystem"
	sDateTime = WmiDate(sDateTime)
	For Each oOS In GetObject("winmgmts:{(Systemtime)}\\" & sComputer & "\root\cimv2").ExecQuery(sCmd)
	    oOS.SetDateTime sDateTime
	Next
End Sub

Function SetObjIE(sUrl, objIE)
	'Oppretter objIE med adressen sUrl dersom det ikke finnes. Kan brukes selv om url omdirigeres.
	'Egenskaper for "InternetExplorer.Application", som f.eks objIE.hWnd, kan benyttes.
	Dim n, found, started
	n = Now + TimeSerial(0, 0, 10)
	found = False
	Do While Now < n And Not found
		If GetObjIE(sUrl, objIE) Then
			objIE.Visible = bDebug = True
			objIE.Silent = bDebug = False
			found = True
		ElseIf Not started Then
			started = True
			With CreateObject("WScript.Shell") 'neste kommando stjeler fokus fordi url er angitt
				.Run "iexplore.exe " & Q(sUrl), 0, False	'0 eller 7 inactive minimized
			End With
			'cmd "start /Min iexplore.exe " & sUrl
			'With CreateObject("Shell.Application")
			'	.ShellExecute "application", "parameters", "dir", "verb", window
			'End With
		End If
		WScript.Sleep 50
	Loop
	If found Then
		SetObjIE = WaitReady(objIE)
	Else
		SetObjIE = False
	End If
End Function

Function GetObjIE(sUrl, objIE)
	Dim oWin, found
	found = False
	With CreateObject("Shell.Application")
		On Error Resume Next 'for win7
		For Each oWin In .Windows
			'we oWin.locationURL
			'If TypeName(oWin) = "IWebBrowser2" And _
			'(LCase(oWin.locationURL) = LCase(sUrl) Or LCase(oWin.locationURL) = LCase(sUrl) & "/") Then
			If InStr(oWin.Parent.Name, "Internet Explorer") Then
				'we oWin.locationURL
				If InStr(oWin.locationURL, sUrl) > 0 Then
					Set objIE = oWin
					found = True
					Exit For
				End If
			End If
			Err.Clear
		Next
	End With
	GetObjIE = found
End Function

Function WaitReady(object)
	WaitReady = WaitReadyState(object, 4)
End Function

Function WaitReadyState(object, state)
	'Venter til ReadyState = state (uninitialized, loading, loaded, interactive, complete)
	'Alle objekter unntatt OBJECT og Google Chrome Frame returnerer ReadyState som streng.
	'OBJECT og Google Chrome Frame returnerer ReadyState som tilsvarende tall fra 0 til 4.
	Dim s, n
	s = "uninitialized,loading,loaded,interactive,complete"
	If IsNumeric(state) Then
		s = Item(s, state + 1) & "," & CStr(state)
	Else
		s = state & "," & CStr(ItemIndex(state, s) - 1)
	End If
	n = Now + TimeSerial(0, 0, IEtimeOut)
	With object
		Do While Now < n And (InStr(s, .ReadyState) = 0) And Not cancel
			WScript.Sleep 100
		Loop
		WaitReadyState = InStr(s, .ReadyState) > 0
	End With
End Function

Function QuitObjIE(objIE)
	On Error Resume Next
	'NavigateReady objIE, "about:blank"
	objIE.Silent = True
	objIE.Quit
	WScript.Sleep 5
	Set objIE = Nothing
	QuitObjIE = Err.Number
End Function

Sub OracleAssemblyShow
	MsgBox Assembly("Oracle.DataAccess", 32)
End Sub

Function Assembly(sName, iBits) 'As Array
	'Returnerer matrise med versjoner for angitte assembly, f.eks: "2.112.1.0" for "Oracle.DataAccess"
	'Undermapper i %WINDIR%\Assembly kan ikke sees i Windows Explorer pga. Assembly cache Viewer (SHFusion.dll)
	Dim aPath(1), f, aSubDirs, i, str, sList
	If iBits <> 32 And iBits <> 64 Then Exit Function
	aPath(0) = EnvVar("%WINDIR%\Assembly\GAC_" & iBits & "\" & sName & "\")
	aPath(1) = EnvVar("%WINDIR%\Microsoft.NET\assembly\GAC_" & iBits & "\" & sName & "\")
	For f = 0 To 1
		If DirExists(aPath(f)) Then
			aSubDirs = Split(SubDirList(aPath(f), 0), vbNewLine)
			For i = 0 To UBound(aSubDirs)
				str = Split(Mid(aSubDirs(i), InStrRev(aSubDirs(i), "\") + 1), "__")(0)
				If InStr(str, "_") > 0 Then str = Split(str, "_")(UBound(Split(str, "_")))
				sList = sList & vbNewLine & str
			Next
		End If
	Next
	If sList <> "" Then Assembly = Split(Mid(sList, 3), vbNewLine)
End Function

Function HideFileExt(sFileName)
	'Fjerner ekstensjon i filnavn dersom "Skjul filetternavn for kjente filtyper" er valgt
	Dim sKey
	sKey = "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced\HideFileExt"
	If CreateObject("WScript.Shell").RegRead(sKey) = 1 Then
		HideFileExt = Left(sFileName, InStrRev(sFileName, ".") - 1)
	Else
		HideFileExt = sFileName
	End If
End Function

Function OracleInstances(sComputer) 'As Array
	'Returnerer instansnavn for Oracle p angitt maskin (f.eks EYEDB11)
	Dim aServices, i
	aServices = ServiceExists("OracleService%", sComputer)
	If UBound(aServices) > -1 Then
		For i = 0 To UBound(aServices)
			aServices(i) = Mid(aServices(i), Len("OracleService") + 1)
		Next
	End If
	OracleInstances = aServices
End Function

Function OracleNetInstance(sSearch)
	'Returnerer matrise med navn p server og instans dersom funnet p nettverket iht. skekriterier.
	Dim aInstances, aComputers, i, sComputer, sMatch
	aInstances = OracleInstances("") 'sk lokal maskin
	If UBound(aInstances) < 0 Then 'sk nettverket
		aComputers = NetComputers
		For i = 0 To UBound(aComputers)
			If InStr(OSName(aComputers(i)), "Server") > 0 Then
				aInstances = Filter(OracleInstances(aComputers(i)), sSearch)
				If UBound(aInstances) >= 0 Then
					sComputer = aComputers(i)
					Exit For
				End If
			End If
		Next
	Else
		sComputer = ComputerName
	End If
	If sComputer <> "" Then
		OracleNetInstance = Array(sComputer, aInstances(0))
	Else
		OracleNetInstance = Array()
	End If
End Function

Function ProductCode(sDisplayName)
	'Returnerer ProductCode for installert program med angitt DisplayName
	Dim aPath(1), p, aKeys, i
	aPath(0) = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
	aPath(1) = "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall"
	For p = 0 To UBound(aPath)
		aKeys = RegSubKeys(aPath(p))
		For i = 0 To UBound(aKeys)
			If InStr(RegKey(aPath(p) & "\" & aKeys(i) & "\DisplayName"), sDisplayName) Then
				ProductCode = aKeys(i)
				Exit For
			End If
		Next
		If ProductCode <> "" Then Exit For
	Next
End Function

Function UninstallStr(sDisplayName)
	'Returnerer UninstallString for installert program med angitt DisplayName
	Dim sKey, aKeys, i
	sKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
	aKeys = RegSubKeys(sKey)
	For i = 0 To UBound(aKeys)
		If RegKey(sKey & "\" & aKeys(i) & "\DisplayName") = sDisplayName Then
			UninstallStr = RegKey(sKey & "\" & aKeys(i) & "\UninstallString")
			Exit For
		End If
	Next
End Function

Sub NetopDescription(sFileName)
	'Legger beskrivelser foran IP-adresser i oppgitt fil.
	'Forutsetter oppfringer med IP-adresse frst adskilt med tabulator.
	Dim sPath, aText, i, sIP, str
	sPath = "\\HYPER-V-SRV\Installers\Netop\PhBook\Servere\"
	aText = Split(TextFile("utf-8", sFileName), vbNewLine)
	For i = 0 To UBound(aText)
		If aText(i) <> "" Then
			sIP = Split(aText(i), vbTab)(0)
			If ValidIP(sIP) Then
				str = NetopPhBookEntry(sPath, sIP, "description")
				If str <> "" Then aText(i) = Left(str, InStr(str, " - ") - 1) & vbTab & aText(i)
			End If
		End If
	Next
	TextToFile Join(aText, vbNewLine), sFileName
End Sub

Function NetopPhBookFileAttrib(sFileName, sAttrib)
	'Returnerer oppgitt attributt for Netop-fil, f.eks "name" (IP-adresse) 
	On Error Resume Next
	With CreateObject("msxml2.DOMDocument.6.0")
		.loadXML TextFile("utf-8", sFileName)
		With .documentElement.selectSingleNode("//netop_phonebookentry/connect")
			NetopPhBookFileAttrib = .getAttribute(sAttrib)
		End With
	End With
End Function

Function NetopPhBookEntry(sPath, sName, sAttrib)
	'Returnerer oppgitt attributt for navn (IP-adresse)
	NetopPhBookEntry = NetopPhBookAttrib(sPath, "name", sName, sAttrib)
End Function

Function NetopPhBookAttrib(sPath, sAttrib, sValue, sOtherAttrib)
	'Returnerer annet attributt for Netop-fil med oppgitt verdi for attributt
	Dim aFiles, oXml, i
	If sPath = "" Then sPath = "\\HYPER-V-SRV\Installers\Netop\PhBook\Servere\"
	If sAttrib = "description" Then
		aFiles = Filter(FilesInDir(sPath & "*.dwc"), sValue)
	Else
		If Right(sPath, 1) <> "\" Then sPath = sPath & "\"
		aFiles = FilesInDir(sPath & "*.dwc")
	End If
	Set oXml = CreateObject("msxml2.DOMDocument.6.0")
	With oXml
		On Error Resume Next
		For i = 0 To UBound(aFiles)
			.loadXML TextFile("utf-8", sPath & aFiles(i))
			With .documentElement.selectSingleNode("//netop_phonebookentry/connect")
				If Err.Number > 0 Then
					Err.Clear
				ElseIf .getAttribute(sAttrib) = sValue Then
					NetopPhBookAttrib = .getAttribute(sOtherAttrib)
					Exit For
				End If
			End With
		Next
	End With
	Set oXml = Nothing
End Function

Sub NetopRestart
	Service "NetOp Host for NT Service", "stop", ""
	Service "NetOp Host for NT Service", "start", ""
End Sub

Function CreateTaskAperturaScript
	Dim startTime, sScript, bRet
	startTime = Replace(FormatDateTime(Time + TimeSerial(0, 5, 0), 4), ".", ":")
	sScript = UNCPath(ScriptPath) & "Apertura.vbs"
	bRet = CreateScript32Task("Apertura\AperturaScript", startTime, "HOURLY", "3", sScript, "")
	SchTaskCmd "Apertura\AperturaScript", "run"
	CreateTaskAperturaScript = bRet
End Function

Function CreateTaskSyncPilotKlient
	Dim startTime, sScript
	startTime = Replace(FormatDateTime(Time + TimeSerial(0, 2, 0), 4), ".", ":")
	sScript = UNCPath(ScriptPath) & AFUNCTIONS
	CreateTaskSyncPilotKlient = CreateScript32Task("", startTime, "MINUTE", "60", sScript, "SyncPilotKlient")
End Function

Function CreateTaskEreseptRestart
	Dim startTime, sScript
	startTime = Replace(FormatDateTime("06:00", 4), ".", ":")
	sScript = UNCPath(ScriptPath) & AFUNCTIONS
	CreateTaskEreseptRestart = CreateScript32Task("", startTime, "DAILY", "1", sScript, "EreseptRestart")
End Function

Function CreateTaskStopStartApServices
	Dim startTime, sScript
	startTime = Replace(FormatDateTime("07:30", 4), ".", ":")
	sScript = UNCPath(ScriptPath) & AFUNCTIONS
	CreateTaskEreseptRestart = CreateScript32Task("", startTime, "DAILY", "1", sScript, "StopStartApServices")
End Function

Function CreateTaskOppdaterTakster
	Dim startTime
	startTime = Replace(FormatDateTime("09:40", 4), ".", ":")
	CreateTaskOppdaterTakster = CreateScript32Task("", startTime, "ONCE", "", "", "OppdaterTakster")
End Function

Function CreateTaskAperturaHelper
	Dim startTime, sScript, bRet
'	startTime = Replace(FormatDateTime(Time + TimeSerial(0, 5, 0), 4), ".", ":")
	sScript = UNCPath(ScriptPath) & "Apertura_helper.vbs"
	bRet = CreateScript32Task("Apertura\AperturaHelper", "", "ONSTART", "", sScript, "")
	bRet = bRet + (SchedTaskBoot("Apertura", "AperturaHelper") *2)
	SchTaskCmd "Apertura\AperturaHelper", "run"
	CreateTaskAperturaHelper = Abs(bRet)
End Function

Function CreateScript32Task(sName, sST, sSC, sMO, sScript, sProc)
	Dim sCmd, str
	'(Dersom skript er oppgitt kjres skriptet som handling - uten bruk av A_FUNCTIONS.vbs\RunScript32)
	'Valid schedule types: MINUTE, HOURLY, DAILY, WEEKLY, MONTHLY, ONCE, ONSTART, ONLOGON, ONIDLE, ONEVENT.
'	sCmd = "RunScript32 \""-""\""\""\""" & sScript & """\""\""\"" ""\""\""\""" & sProc & """\""\""\""\"" 0"
	If sName = "" Then sName = "Apertura\" & sProc
	If sST <> "" Then sST = " /ST " & sST
	If sMO <> "" Then sMO = " /MO " & sMO
	If sScript = "" Then sScript = UNCPath(ScriptPath) & AFUNCTIONS
	sCmd = "RunScript32 '-'''" & sScript & "''' '''" & sProc & "'''' 0"
'	str = EnvVar("%windir%\System32\")
	str = "SchTasks /F /Create /SC " & sSC & sST & sMO & " /RL HIGHEST /NP /TN """"" & sName & """"" /TR """ & sScript & " " & sCmd & """"
'	WEQ str
'	CreateObject("WScript.Shell").Run str
	CreateScript32Task = Left(Cmd(str), 8) = "SUCCESS:"
'	CreateScript32Task = Cmd(str)
End Function

Function SchTaskExists(sTaskName)
	'Returnerer Sann dersom oppgaven finnes, ellers usann
	SchTaskExists = InStr(SchTaskCmd(sTaskName, "Query"), sTaskName) > 0
End Function

Function SchTaskCmd(sTaskName, ByVal sCmd)
	'Utfrer oppgitt kommando for planlagt oppgave: Delete, Query, Run, End, ShowSid eller ENABLE/DISABLE
	'Returnerer Sann (vellykket) eller 1 (vellykket med info, f.eks allerede startet) dersom vellykket, ellers Usann
	'NB: Oppgaver kan aktiveres og deaktiveres mens de kjrer, men ikke kjres dersom de er deaktivert
	If Left(sCmd, 1) = "/" Then sCmd = Mid(sCmd, 2)
	Select Case UCase(sCmd)
		Case "START"	: sCmd = "Run /I" 'synonym, immediately
		Case "STOP"		: sCmd = "End" 'synonym
		Case "DELETE"	: sCmd = "Delete /F" 'force dersom oppgaven kjrer
		Case "ENABLE"	: sCmd = "Change /ENABLE"
		Case "DISABLE"	: sCmd = "Change /DISABLE"
	End Select
	SchTaskCmd = Cmd("schtasks /" & sCmd & " /TN " & Q(sTaskName))
	If InStr(SchTaskCmd, "SUCCESS:") Then
		If InStr(SchTaskCmd, "INFO:") Then
			SchTaskCmd = 1
		Else
			SchTaskCmd = True
		End If
	Else
		SchTaskCmd = False
	End If
End Function

Function SchedTaskBoot(sFolder, sName)
	Dim oService, oFolder, oTask, oSettings, oTaskDefinition, oTriggers, i, oTrigger, sTmp, str
	Const TriggerTypeBoot = 8
'	const createOrUpdateTask = 6
	SchedTaskBoot = False
	Set oService = CreateObject("Schedule.Service")
	oService.Connect
	Set oFolder = oService.GetFolder(sFolder)
	On Error Resume Next
	Set oTask = oFolder.GetTask(sName)
	If Not IsObject(oTask) Then Exit Function 'Set oTask = oFolder.GetTasks(0)
	Set oTaskDefinition = oTask.Definition
	Set oSettings = oTaskDefinition.Settings
	With oSettings
		.ExecutionTimeLimit = "PT0H" 'deaktiver Instilling/Stopp oppgaven hvis den kjrer lenge enn
		.StartWhenAvailable = -1
		.MultipleInstances = 0 '"Execute new task concurrently (default)"
'		.MultipleInstances = 1 '"Execute new task sequentially"
'		.MultipleInstances = 2 '"Do not execute new task"
'		.MultipleInstances = 3 '"Cancel the running task before executing new task"
	End With
	oTaskDefinition.Settings.StartWhenAvailable = True
	Set oTriggers = oTaskDefinition.Triggers
'	we oTriggers.Count
	For i = 0 To oTriggers.Count
		If oTriggers.Item(i).Id = "BootTriggerId" Then
			oTriggers.Remove i
		End If
	Next
	Set oTrigger = oTriggers.Create(TriggerTypeBoot) 'type
	With oTrigger
		.Id = "BootTriggerId"
'		.StartBoundary = DateToISO(Now)
'		.EndBoundary  = DateToISO(DateAdd("yyyy", 10, Now))
'		.ExecutionTimeLimit = "PT5M"    ' Stopp oppgaven hvis den kjrer lengre enn 5 min
		.Delay = "PT2M"                ' Forsink oppgaven i 2 minutter: PT2M / 30 sekunder: PT30S
		.Repetition.Interval = "PT1H"	' Gjenta oppgaven hver time
	End With
	For i = 0 To oTriggers.Count
		If oTriggers.Item(i).Id <> "BootTriggerId" Then
			oTriggers.Remove i
		End If
	Next
	sTmp = TmpFile("")
	TextToFile oTaskDefinition.XmlText, sTmp
	str = "SchTasks /F /Create /TN " & sFolder & "\" & sName & " /XML " & Q(sTmp)
'	SUCCESS: The scheduled task "APERTURA\SyncPilotKlient" has successfully been created.
	SchedTaskBoot = Left(Cmd(str), 8) = "SUCCESS:"
'	SchedTaskBoot = Cmd(str)
'	CreateObject("WScript.Shell").Run str
	DeleteFile sTmp
'	oFolder.RegisterTaskDefinition sName, oTaskDefinition, createOrUpdateTask, "APERTURA\Administrator", "", 5
End Function

Function St_NPRrapport
	TextToFile NPRrapport, ScriptPath & "ScriptTask.txt"
End Function

Function NPRrapport
	'Skal oppdateres hver 4. mnd. Filer i c:\Temp\NPR_2017_DES m lastes ned.
	Dim sShare, sName, sPath, aSQL, sFolder, aNPR, i, c, n, v, str
	If Not IsADM Then
		RunScriptElev32 WScript.ScriptFullName & " NPRrapport", False
		WScript.Quit
	End If
	sName = "NPR_2018_MAY"
	sShare = sSharePath 'ShareProperty("AperturaInstall", "path") & "\"
	sPath = sShare & "Pilot_Klient\" & sName & "\"
'	TextToFile "1" & vbNewLine, ScriptPath & "Info.txt"
	On Error Resume Next
'	If 1 = 2 Then
	If OracleInstalled < 4 Then Exit Function
	If sOracleService = "" Then sOracleService = GetEnvVar("USER", "Oracle_Service")
	If sOracleService = "" Then
		NPRrapport = ExitWithError(True, "NPRrapport: Miljvariabel for Oracle Service er ikke registrert.")
	End If
	If ProcCount("doriscom.exe") > 0 Then
		KillProc "doriscom.exe"
		WScript.Sleep 2000
	End If
	If DirExists(sShare & sName) Then Cmd "del /s /q " & sShare & sName
	ZipExtract sPath & sName & ".zip", sShare
'	End If
	With CreateObject("WScript.Shell")
		'Kjr oppdatering av Oracle dersom mappe inneholder sql-fil.
		aSQL = FilesInFolder(sPath, "sql")
		If UBound(aSQL) > -1 Then
			Msg2  "Apertura", "Oppdaterer database...", "I", 0
			.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & aSQL(0), 4, True '8 = current remains active
			Msg2  "Apertura", "Oppdaterer database...", "I", ""
		End If
		Cmd "del /s /q c:\temp\" & sName & "\"
		Cmd "del /s /q c:\temp\*.xml"
		'korriger config
		NPRConfig sShare & sName & "\Npr2013WpfApplication.exe.config"
		.Run sShare & sName & "\Npr2013WpfApplication.exe", 2, False
'		Cmd "START """" " & Q(sShare & sName & "\Npr2013WpfApplication.exe")
		'Aktivr vindu og klikk Button1 (med tab + space)
		Do While ProcCount("Npr2013WpfApplication.exe") = 0
			WScript.Sleep 1000
		Loop
		WScript.Sleep 3000
		ShowWindow "Npr2013WpfApplication", "Window1"
'		ShowWindow "", "Window1"
'		If .AppActivate(ProcID("Npr2013WpfApplication.exe")(0)) <> 1 Then
'			.AppActivate "Window1"
'		End If
'		n = Now + TimeSerial(0, 0, 6)
'		Do While Not v And Now < n
'			v = .AppActivate(ProcID("Npr2013WpfApplication.exe")(0))
'			WScript.Sleep 1000
'		Loop
		.AppActivate ProcID("Npr2013WpfApplication.exe")(0)
		WScript.Sleep 2000
		.SendKeys "{TAB}"
		WScript.Sleep 2000
		.SendKeys " "
		WScript.Sleep 2000
'		Lukk vindu (henger til det er ferdig)
		.SendKeys "%{F4}"
		Do While ProcCount("Npr2013WpfApplication.exe") > 0
			WScript.Sleep 1000
		Loop
	End With
	'Flytt NPR-XML-filer fra Temp til mappe i Temp
	sFolder = "C:\TEMP\" & sName
	DeleteDir sFolder
	CreateDir sFolder
	aNPR = FilesInFolder("C:\TEMP\", "xml")
	If IsArray(aNPR) Then
		For i = 0 To UBound(aNPR)
			If FileSize(aNPR(i)) > 1 Then
				MoveFile aNPR(i), sFolder & "\"
				c = c + 1
			End If
		Next
		str = c & " av " & UBound(aNPR) + 1 & " filer lagt i " & sFolder & "."
		Msg2  "Apertura - NPR", str, "I", 60
	End If
	If Err.Number > 0 And Err.Number <> 424 Then
		NPRrapport = ExitWithError(True, "NPRrapport: " & Err.Number & " " & Err.Description)
	ElseIf str <> "" Then
		NPRupload sName
		NPRrapport = "Apertura - NPR: " & str & " " & Now
	Else
		NPRrapport = "Apertura - NPR: INGEN RAPPORTER! " & Now
	End If
End Function

Sub NPRConfig(sFileName)
	Dim oXml, sXml, str, elem, aAssembly, oNode
	Set oXml = CreateObject("Msxml2.DOMDocument")
'	Set oXml = CreateObject("Microsoft.XMLDOM")
	With oXml
		.async = False
		.setProperty "SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'"
		.setProperty "SelectionLanguage", "XPath"
		.loadXML TextFromFile(sFileName)
		sXml = .xml
		'DATA SOURCE for EyeDB og Security
		str = "DATA SOURCE=" & sOracleService & ";PERSIST SECURITY INFO=True;USER ID=HL7;Password=HL7"
		With .documentElement.selectSingleNode("//configuration/appSettings")
'			For bruker hos Bislett:
'		    <add key="ONLYONE" value="Yes"/>
'		    <add key="ONLYONEUSER" value="EIKLAND"/>
'		    <add key="ONLYONEPASSWORD" value="EIKXXX"/>
			For Each elem In .getElementsByTagName("add")
				If elem.getAttribute("key") = "ONLYONE" Then
					elem.setAttribute "value", "No"
					Exit For
				End If
			Next
		End With
		With .documentElement.selectSingleNode("//configuration/connectionStrings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "EyeDB" Or elem.attributes.item(0).value = "Security" Then
					elem.setAttribute "connectionString", str
				End If
			Next
		End With
		'ASSEMBLY
		aAssembly = Assembly("Oracle.DataAccess", 64)
		If Not IsArray(aAssembly) Then aAssembly = Array("2.112.1.0")
		On Error Resume Next
		For Each oNode In .documentElement.selectSingleNode("//runtime").ChildNodes(0).ChildNodes
			If oNode.firstChild.getAttribute("name") = "Oracle.DataAccess" Then
				oNode.firstChild.NextSibling.setAttribute "newVersion", aAssembly(0)
			End If
		Next
		'SECURITY MODE
'		With .documentElement.selectSingleNode("//system.serviceModel/bindings/netTcpBinding/binding/security")
'			.setAttribute "mode", "None"
'		End With
		'Lagre dersom endringer
		If .xml <> sXml Then .save sFileName
	End With
End Sub

Function NPRupload(sNPRname)
	Dim ftp, sIP
	If OracleInstalled < 4 Then Exit Function
	Include ScriptPath & "cURLFTP_class.vbs"
	Set ftp = New cURLFTP
	If FileExists(ScriptPath & "curl.exe") Then
		ftp.Path = ScriptPath
	Else
		ftp.Path = sInstallPath
	End If
	If DomainName <> "APERTURA" And ComputerName <> "AUTO-PC" Then
		ftp.proxy = " -x slb.flex-proxy.nhn.no:8080"
		sIP = NHNIP
		If sIP = "" Then sIP = IP
	Else
		sIP = IPByGateway("", "10.10.34.1")
	End If
	ZipAdd "c:\temp\" & sIP & "_" & sNPRname & ".zip", "c:\temp\" & sNPRname, 60
	ftp.Upload "ret/" & sIP & "_" & sNPRname & ".zip", "c:\temp\" & sIP & "_" & sNPRname & ".zip"
	Set ftp = Nothing
	NPRupload = Err.Number = 0
End Function

Function NPRdownload
	Dim sPath, sName, sDir, aCS, ftp, aFiles, i, n, m, s
	sPath = "\\Brexit\AperturaInstall\Scripts\"
	sName = "NPR_2018_MAY"
	sDir = "C:\" & sName & "\"
	DeleteDir sDir
	CreateDir sDir
	aCS = Split(CustomerServers, vbNewLine)
	Include sPath & "cURLFTP_class.vbs"
	Set ftp = New cURLFTP
	ftp.Path = sPath
	aFiles = Split(ftp.Directory("ret/"), vbNewLine)
	For i = 0 To UBound(aFiles) - 1
		n = Mid(aFiles(i), 56)
		If InStr(n, sName) Then
			m = InStr(n, "_")
			s = Split(Filter(aCS, Left(n, m - 1))(0), vbTab)(1)
			s = Left(s, InStrRev(s, "-") - 1) 'Mid(n, m + 1)
			ftp.Download "ret/" & n, sDir & s & ".zip"
			ZipExtract sDir & s & ".zip", sDir & s
			DeleteFile sDir & s & ".zip"
		End If
	Next
	Set ftp = Nothing
	NPRdownload = Err.Number = 0
End Function

Sub MergeHelsePersonell
	Dim sPath, sFileName, sFolder
	On Error Resume Next
	If Not IsADM Then
		RunScriptElev32 WScript.ScriptFullName & " MergeHelsePersonell", False
		WScript.Quit
	End If
	sPath = "\\" & ComputerName & "\AperturaInstall\"
	sFileName = sPath & "Pilot_Klient\MergeHelsePersonell.zip"
	If FileExists(sFileName) Then
		Msg2  "Apertura", "Installerer MergeHelsePersonell...", "I", 0
		'finn verste mappe i zip-fil
		sFolder = Split(ZipContent(sFileName), vbNewLine)(0)
		If  Right(sFolder, 1) = "/" Then
			sFolder = sPath & Split(Mid(sFolder, InStrRev(sFolder, "\") + 1), "/")(0) & "\"
		End If
		DeleteDir sFolder
		ZipExtract sFileName, sPath
		Do While Not FileExists(sFolder & "Apertura.Wpf.Controls.Test.exe.config")
			WScript.Sleep 100
		Loop
		MergeHelsePersonellConfig sFolder & "Apertura.Wpf.Controls.Test.exe.config"
		Msg2  "Apertura", "Installerer MergeHelsePersonell...", "I", ""
		Msg2  "Apertura", "MergeHelsePersonell er installert!", "I", 5
	Else
		Msg2  "Apertura", "MergeHelsePersonell kunne ikke installeres!" & vbNewLine & _
		"Finner ikke filen " & sFileName, "E", 5
	End If
	If Err.Number > 0 Then ExitWithError True, "CreateTestDb: " & Err.Number & " " & Err.Description
End Sub

Sub MergeHelsePersonellConfig(sFileName)
	Dim oXml, elem, str, aStr, aAssembly, oNode, i
	On Error Resume Next
	Msg2 "Apertura", "Konfigurerer MergeHelsePersonell...", "I", 0
	Set oXml = CreateObject("msxml2.DOMDocument.6.0")
	If Not IsObject(oXml) Then Set oXml = CreateObject("Msxml2.DOMDocument")
	If Not IsObject(oXml) Then Set oXml = CreateObject("Microsoft.XMLDOM")
	With oXml
		.async = False
		.setProperty "SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'"
		.setProperty "SelectionLanguage", "XPath"
		.loadXML TextFile("utf-8", sFileName)
'		MsgBox .xml
		'DATA SOURCE for EyeDB og Security
		With .documentElement.selectSingleNode("//configuration/connectionStrings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "EyeDB" Or elem.attributes.item(0).value = "Security" Then
					str = elem.getAttribute("connectionString")
					If str <> "" Then
'						DATA SOURCE=EYEDB11;PERSIST SECURITY INFO=True;USER ID=HL7;Password=HL7
						aStr = Split(str, ";")
						For i = 0 To UBound(aStr)
							If Left(aStr(i), 12) = "DATA SOURCE=" Then
								aStr(i) = "DATA SOURCE=" & sOracleService
								elem.setAttribute "connectionString", Join(aStr, ";")
							End If
						Next
					End If
				End If
			Next
		End With
		'ASSEMBLY
		aAssembly = Assembly("Oracle.DataAccess", 64)
		If Not IsArray(aAssembly) Then aAssembly = Array("2.112.1.0")
		For Each oNode In .documentElement.selectSingleNode("//runtime").ChildNodes(0).ChildNodes
			If oNode.firstChild.getAttribute("name") = "Oracle.DataAccess" Then
				oNode.firstChild.NextSibling.setAttribute "newVersion", aAssembly(0)
			End If
		Next
		'SECURITY MODE
'		With .documentElement.selectSingleNode("//system.serviceModel/bindings/netTcpBinding/binding/security")
'			.setAttribute "mode", "None"
'		End With
		'ENDPOINT ADDRESS
'		With .documentElement.selectSingleNode("//system.serviceModel/client/endpoint")
'			.setAttribute "address", "net.tcp://" & sOracleHost & ":8002/ApServices"
'		End With
		'DNS VALUE
'		With .documentElement.selectSingleNode("//system.serviceModel/client/endpoint/identity/dns")
'			.setAttribute "value", sOracleHost
'		End With
		.save sFileName
		If Err.Number > 0 Then
			'ikke vis feilmelding for Object required (Error 424).
			If Err.Number <> 424 Then ExitWithError False, "MergeHelsePersonellConfig: " & Err.Number & " " & Err.Description
			Err.Clear
		End If
	End With
	Set oXml = Nothing
	Msg2 "Apertura", "Konfigurerer MergeHelsePersonell...", "I", ""
End Sub

Function AperturaCmd(sPlace, sCmd, timeout)
	'Kjrer kommando over ftp som besvares remote av Apertura.vbs
	Include "\\BREXIT\AperturaInstall\Scripts\cURLFTP_class.vbs"
	Dim sIP, sTmp, ftp, n, sRet
	If sPlace = "" Then
		sIP = IP
	ElseIf ValidIP(sPlace) Then
		sIP = sPlace
	Else
		sIP = NetopPhBookAttrib("", "description", sPlace, "name")
	End If
	With New cURLFTP
		.Path = sInstallPath
		.DeleteFile sIP & "_Output.txt"
		sTmp = TmpFile("")
		TextToFile sCmd, sTmp
		.Upload sIP & "_Input.txt", sTmp
		DeleteFile sTmp
		n = Now + TimeSerial(0, 0, timeout)
		Do While Now < n
			sRet = .File(sIP & "_Output.txt")
			If sRet <> "" Then Exit Do
			WScript.Sleep 1000
		Loop
		If Now >= n Then sRet = "[timeout]"
		.DeleteFile sIP & "_Input.txt"
		.DeleteFile sIP & "_Output.txt"
	End With
	AperturaCmd = sRet
End Function

Function OracleInstalled
	'Returnerer 0 eller 4 for server + 0 eller 2 for client64 + 0 eller 1 for client32. 7 vil si alle 3.
	OracleInstalled = (Abs(OracleServer <> "") * 4) + (Abs(OracleClient64 <> "") * 2) + (Abs(OracleClient32 <> "") * 1)
End Function

Function OracleClient32
	'Returnerer ORACLE_HOME for 32-bit Oracle klient
	OracleClient32 = OracleKey("HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\ORACLE\", "KEY_OraClient")
End Function

Function OracleClient64
	'Returnerer ORACLE_HOME for 64-bit Oracle klient
	OracleClient64 = OracleKey("HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\", "KEY_OraClient")
End Function

Function OracleServer
	'Returnerer ORACLE_HOME for Oracle server (64-bit)
	OracleServer = OracleKey("HKEY_LOCAL_MACHINE\SOFTWARE\ORACLE\", "KEY_OraDB")
End Function

Function OracleKey(sPath, strName)
	Dim aKeys
	aKeys = Filter(RegSubKeys64(sPath), strName, True, 1)
	If UBound(aKeys) > -1 Then OracleKey = RegKey64(aKeys(0) & "\ORACLE_HOME")
End Function

Function xCustomerServers
	'Returnerer liste (tabulator/linjeskift) med IP-adresse og navn for servere til alle kunder
	Dim aHosts, aHSkip, sText
	aHosts = FilesInFolder("\\HYPER-V-SRV\Installers\Netop\PhBook\Servere\", "dwc")
	aHSkip = Split(vbNewLine & TextFromFile("\\BREXIT\AperturaInstall\AutoAll_Hosts_Skip.txt"), vbNewLine)
	For i = 0 To UBound(aHosts)
		'sjekk for utelatte servere
		If UBound(Filter(aHSkip, aHosts(i), True, 1)) < 0 Then
			sText = sText & vbNewLine & NetopPhBookFileAttrib(aHosts(i), "name") & vbTab & NetopPhBookFileAttrib(aHosts(i), "description")
		End If
	Next
	'Vika-servere
	sText = sText & vbNewLine & "10.5.97.132" & vbTab & "Bislett - Server (Vika)"
	sText = sText & vbNewLine & "10.5.31.195" & vbTab & "Jrgensen - Ski - OracleServer (Vika)"
	sText = sText & vbNewLine & "172.31.194.71" & vbTab & "Nikolaisen - Velfjord - OracleServer (Vika)"
	sText = sText & vbNewLine & "172.22.232.113" & vbTab & "Apertura - Vika"
	xCustomerServers = Mid(sText, 3)
End Function

Function CustomerServers
	Dim sText
	sText = sText & vbNewLine & "172.31.109.226" & vbTab & "ABC - Larvik - Server NY"
	sText = sText & vbNewLine & "10.5.97.132" & vbTab & "Bislett - Server"
	sText = sText & vbNewLine & "172.31.73.77" & vbTab & "Bolstad - Frde - Server"
	sText = sText & vbNewLine & "172.31.116.198" & vbTab & "Dinparvar - Askim - Server"
'	sText = sText & vbNewLine & "172.31.132.35" & vbTab & "Dueland - Sauda - Server"
	sText = sText & vbNewLine & "172.31.132.36" & vbTab & "Dueland - Sauda - DC02"
	sText = sText & vbNewLine & "172.31.68.234" & vbTab & "Estil - Namsos - Server NY"
	sText = sText & vbNewLine & "172.31.68.229" & vbTab & "Estil - Namsos - Server"
	sText = sText & vbNewLine & "172.31.103.195" & vbTab & "Grdum - Porsgrunn - Server"
	sText = sText & vbNewLine & "172.31.3.88" & vbTab & "Grndahl - Brum - Server"
	sText = sText & vbNewLine & "172.31.95.42" & vbTab & "Gustavsen - Kolbotn - Server"
	sText = sText & vbNewLine & "172.31.85.37" & vbTab & "Hafskolt - Notodden - Server"
	sText = sText & vbNewLine & "172.31.74.195" & vbTab & "Hasan - Namsos - Server"
	sText = sText & vbNewLine & "172.31.89.94" & vbTab & "Hedels - Kristiansund -  Server"
	sText = sText & vbNewLine & "10.5.31.195" & vbTab & "Jrgensen - Ski - OracleServer"
	sText = sText & vbNewLine & "172.31.49.67" & vbTab & "Kratholm - Narvik - Server"
	sText = sText & vbNewLine & "172.31.206.66" & vbTab & "Liavaag - Gol - Server"
	sText = sText & vbNewLine & "172.31.206.34" & vbTab & "Liavaag - Hnefoss - Server"
	sText = sText & vbNewLine & "172.31.129.66" & vbTab & "Mjanger - Knarvik - Server"
	sText = sText & vbNewLine & "172.31.20.237" & vbTab & "Molenda - Sogndal - Server"
	sText = sText & vbNewLine & "172.31.73.3" & vbTab & "Montebello - Molde - Server"
	sText = sText & vbNewLine & "172.31.89.132" & vbTab & "Munkhaug (Steen) - Fauske - Server"
	sText = sText & vbNewLine & "172.31.92.34" & vbTab & "Naboulsi - Flor - Server"
	sText = sText & vbNewLine & "172.31.194.71" & vbTab & "Nikolaisen - Velfjord - OracleServer"
'	sText = sText & vbNewLine & "172.31.194.74" & vbTab & "Nikolaisen - Velfjord - HarmServer"
'	sText = sText & vbNewLine & "172.31.198.30" & vbTab & "Resellmo - Mo I Rana - DC"
	sText = sText & vbNewLine & "172.31.198.4" & vbTab & "Resellmo - Mo I Rana - OracleServer"
	sText = sText & vbNewLine & "172.31.109.101" & vbTab & "Romtveit - Porsgrunn - ServerDB"
	sText = sText & vbNewLine & "172.31.75.79" & vbTab & "Stjrdal - Server03 - Oracle"
	sText = sText & vbNewLine & "172.31.88.239" & vbTab & "Teckle - Sentrum yeklinikk - Server NY"
	sText = sText & vbNewLine & "172.31.240.66" & vbTab & "Trondheim yelegesenter - Server"
	sText = sText & vbNewLine & "172.31.94.37" & vbTab & "Tvenning - Bod - APP01"
'	sText = sText & vbNewLine & "172.31.94.35" & vbTab & "Tvenning - Bod - Server - ikke i bruk!"
'	sText = sText & vbNewLine & "172.31.194.67" & vbTab & "Velfjord - Nikolaisen - Server"
	sText = sText & vbNewLine & "172.31.79.235" & vbTab & "Wankel - Moss - Server"
	sText = sText & vbNewLine & "172.22.232.113" & vbTab & "Apertura - Vika"
	CustomerServers = Mid(sText, 3)
End Function

Function OracleServerInstall(sVersion)
	Dim sFile, sPath, rspName, rspFile, bDomain, sHost, str
	If Not DirExists(sSharePath) Then
		OracleClientInstall = ExitWithError(True, "OracleClientInstall: Finner ikke delt mappe. Avbryter installasjon!")
	End If
	If sVersion = "12.2" Then 
		sFile = "winx64_12201_database.zip"
	ElseIf sVersion = "12.1" Then
		sFile = "winx64_12102_database_1of2.zip"
	End If
	sPath = sSharePath & "Oracle\"
	OracleClientInstall = OracleDownload(sPath, sFile)
	If OracleClientInstall <> True Then Exit Function
	'Rename hostname
	'ORACLE_HOSTNAME=OracleServer.oculi.local
	rspName = "client" & bBits & ".rsp"
	rspFile = sInstallPath & "Oracle\RSP\" & rspName
End Function

Function OracleClientInstall(sOracleServer, bBits)
	Dim sFile, sPath, rspName, rspFile, bDomain, sHost, str
	If Not DirExists(sSharePath) Then
		OracleClientInstall = ExitWithError(True, "OracleClientInstall: Finner ikke delt mappe. Avbryter installasjon!")
	End If
	If bBits = 32 Then 
'		sFile = "winnt_12102_client32.zip"
		sFile = "test2.pdf"
	ElseIf bBits = 64 Then
		sFile = "winx64_12102_client.zip"
	End If
	sPath = sSharePath & "Oracle\"
	OracleClientInstall = OracleDownload(sPath, sFile)
	If OracleClientInstall <> True Then Exit Function
	'Rename hostname
	'ORACLE_HOSTNAME=OracleServer.oculi.local
	rspName = "client" & bBits & ".rsp"
	rspFile = sInstallPath & "Oracle\RSP\" & rspName
	'hva er det her? Dette m angis
	If sOracleServer = "" Then
		sHost = FQDN
	ElseIf Ping(sOracleServer) Then
		sHost = sOracleServer
	Else
		OracleClientInstall = ExitWithError(True, "OracleClientInstall: Finner ikke Oracle-server. Avbryter installasjon!")
	End If
	str = TextFromFile(rspFile)
	str = Join(Replace(str, Filter(Split(str, vbCrLf), "ORACLE_HOSTNAME=")(0), "ORACLE_HOSTNAME=" & sHost), vbCrLf)
	If Not DirExists(sPath) Then CreateDir sPath
	rspFile = sSharePath & "Oracle\" & rspName
	TextToFile str, rspFile
	'Fortsett her: unzip sFile - sjekk mappen client32
	ZipExtract sFileName, sPath
	wq
	With CreateObject("WScript.Shell")
		.Run "%COMSPEC% /c echo exit|C:\Install\winnt_12102_client32\client32>setup -silent -responseFile " & rspFile
	End With
End Function

Function OracleDownload(sPath, sFile)
	Include "\\BREXIT\AperturaInstall\Scripts\cURLFTP_class.vbs"
	Dim sFileL, lSizeL, lSizeR
	sFileL = sPath & sFile
	With New cURLFTP
		.Path = sInstallPath
		If FileExists(sFileL) Then
			OracleDownload = True
		ElseIf FileExists(Q(sFileL & ".")) Then
			lSizeL = FileSizeB(Q(sFileL & "."))
			lSizeR = .FileSize("files/" & sFile)
			WE lSizeL & vbNewLine & lSizeR
			If lSizeR = 0 Then
				OracleDownload = "Error: " & sFile & " p server er 0 bytes!"
			ElseIf lSizeL < lSizeR Then
				OracleDownload = "Laster ned " & sFile
			ElseIf lSizeL > lSizeR Then
				OracleDownload = "Error: " & sFile & " er for stor (" & lSizeL & "/" & lSizeR & ")"
			Else
				RenameFile sFileL & ".", sFileL
				If FileExists(sFileL) Then
					OracleDownload = True
				Else
					OracleDownload = "Error: Feil ved omdping av " & sFile
				End If
			End If
		Else
			If Not DirExists(sSharePath & "Oracle\") Then CreateDir sSharePath & "Oracle\"
			.Download "files/" & sFile, Q(sFileL & ".")
			WE FileExists(Q(sFileL & "."))
		End If
	End With
	WEQ "Nedlasting fullfrt!"
End Function

Function EreseptTest
	Dim sName, sFileName, aUsrPwd, oXml, sXml, elem, oNode, str, aAssembly, n, aFiles
	sName = "ERESEPT_TEST_10_27"
	If sOracleService = "" Then sOracleService = GetEnvVar("USER", "Oracle_Service")
	If sOracleService = "" Then
		EreseptTest = ExitWithError(True, "EreseptTest: Miljvariabel for Oracle Service er ikke registrert.")
	End If
	If Not FileExists(sInstallPath & sName & ".zip") Then
		EreseptTest = ExitWithError(True, "EreseptTest: Finner ikke " & sInstallPath & sName & ".zip. Avbryter!")
	End If
	If DirExists(sSharePath & sName) Then DeleteDir sSharePath & sName
	ZipExtract sInstallPath & sName & ".zip", sSharePath
	sFileName = sSharePath & sName & "\E_REsept_Test.exe"
	If Not FileExists(sFileName & ".config") Then
		EreseptTest = ExitWithError(True, "EreseptTest: Finner ikke " & sFileName & ".config. Avbryter!")
	End If
	aUsrPwd = ApServicesUsrPwd
	If aUsrPwd(0) = "" Or aUsrPwd(1) = "" Then
		Msg2 "Apertura", "Brukernavn eller passord mangler for Eresept Test!", "W", 0
		WScript.Sleep 3000
	End If
	Msg2 "Apertura", "Kjrer Eresept Test...", "I", 0
'	On Error Resume Next
'	Set oXml = CreateObject("msxml2.DOMDocument.6.0")
	Set oXml = CreateObject("Msxml2.DOMDocument")
'	Set oXml = CreateObject("Microsoft.XMLDOM")
	With oXml
		.async = False
		.setProperty "SelectionNamespaces", "xmlns:xsl='http://www.w3.org/1999/XSL/Transform'"
		.setProperty "SelectionLanguage", "XPath"
		.loadXML TextFromFile(sFileName & ".config")
		sXml = .xml
'		MsgBox .xml : WScript.Quit
		'DATABASE
		With .documentElement.selectSingleNode("//configuration/appSettings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "DB_USER" Then
					elem.attributes.item(1).value = aUsrPwd(0)
				ElseIf elem.attributes.item(0).value = "DB_PW" Then
					elem.attributes.item(1).value = aUsrPwd(1)
				ElseIf elem.attributes.item(0).value = "database" Then
					elem.attributes.item(1).value = sOracleService
				End If
			Next
		End With
		'DATA SOURCE for EyeDB og Security
		str = "DATA SOURCE=" & sOracleService & ";PERSIST SECURITY INFO=True;USER ID=HL7;Password=HL7"
		With .documentElement.selectSingleNode("//configuration/connectionStrings")
			For Each elem In .getElementsByTagName("add")
				If elem.attributes.item(0).value = "EyeDB" Or elem.attributes.item(0).value = "Security" Then
					elem.setAttribute "connectionString", str
				End If
			Next
		End With
		'ASSEMBLY
		aAssembly = Assembly("Oracle.DataAccess", 32)
'		If Not IsArray(aAssembly) Then aAssembly = Assembly("Oracle.DataAccess", 64)
		If Not IsArray(aAssembly) Then 'aAssembly = Array("2.112.1.0")
'			Cmd OracleClient32 & "\ODP.NET\bin\2.x\oraprovcfg.exe /action:gac /providerpath:Oracle.DataAccess.dll"
'			aAssembly = Assembly("Oracle.DataAccess", 32)
			If Not IsArray(aAssembly) Then
				'registrer mest vanlige
				aAssembly = Array("2.112.1.0")
			End If
'			EreseptTest = ExitWithError(True, "EreseptTest: Assembly(32) er ikke registrert. Avbryter!")
		End If
'		If Left(aAssembly(0), 1) = "2" Then aAssembly(0) = "4" & Mid(aAssembly(0), 2)	'Tving runtime 4
		For Each oNode In .documentElement.selectSingleNode("//runtime").ChildNodes(0).ChildNodes
			If oNode.firstChild.getAttribute("name") = "Oracle.DataAccess" Then
				oNode.firstChild.NextSibling.setAttribute "newVersion", aAssembly(0)
			End If
		Next
		'SECURITY MODE
		With .documentElement.selectSingleNode("//system.serviceModel/bindings/netTcpBinding/binding/security")
			.setAttribute "mode", "None"
		End With
		'Lagre dersom endringer
		If .xml <> sXml Then .save sFileName & ".config"
	End With
	DeleteDir "C:\Temp\Patient Import"
	CreateDir "C:\Temp\Patient Import"
	Msg2 "Apertura", "Kjrer Eresept Test...", "I", ""
	CreateObject("WScript.Shell").Run sFileName
	Msg2 "Apertura", "Klikk ExportPatientByNameTrue", "I", 30
	n = Now + TimeSerial(0, 30, 0)
	Do While Now < n
		aFiles = FilesInDir("C:\Temp\ExportPatient*.xml")
		If UBound(aFiles) >= 28 Then
			Exit Do
		ElseIf UBound(aFiles) >= 27 Then
			n = Now + TimeSerial(0, 1, 0)
		End If
		WScript.Sleep 1000
	Loop
	aFiles = FilesInDir("C:\Temp\ExportPatient*.xml")
	For n = 0 To UBound(aFiles)
		MoveFile "C:\Temp\" & aFiles(n), "C:\Temp\Patient Import\"
	Next
	KillProc "E_REsept_Test.exe"
	KillProc "FM.Client.App.exe"
	CreateObject("WScript.Shell").Run Q("C:\Temp\Patient Import\")
	WScript.Sleep 1000
	Msg2 "Apertura", "Eresept Test eksporterte " & (UBound(aFiles) + 1) & " filer.", "I", 600
	If Err.Number > 0 Then
		EreseptTest = ExitWithError(False, "EreseptTest: " & Err.Number & " " & Err.Description)
	Else
		CreateObject("WScript.Shell").Run """C:\Program Files (x86)\eResept Forskrivningsmodul\FM.Client.App.exe"" -admin"
		EreseptTest = True
	End If
End Function

Sub TeamViewerHostInstall(sMachine)
	Dim sMSI
'	If sMachine = "" Then Exit Sub 'sMachine = NHNIP
	'Avbryt dersom Teamviewer allerede er installert
'	If FileExists(EnvVar("%ProgramFiles(x86)%\TeamViewer\TeamViewer.exe")) Or _
'	FileExists(EnvVar("%ProgramFiles%\TeamViewer\TeamViewer.exe")) Then Exit Sub
	Cmd "reg.exe ADD HKCU\Software\Sysinternals\PSexec /v EulaAccepted /t REG_DWORD /d 1 /f"
	sMSI = sInstallPath & "Teamviewer\TeamViewer_Host.msi"
	CurDir sInstallPath 'mappe for psexec
	With CreateObject("WScript.Shell")
		If sMachine <> "" Then
			.Run "psexec -accepteula \\" & sMachine & " -s msiexec.exe /i " & sMSI & " /q", 0, True
		Else
			.Run "psexec -s msiexec.exe /i " & sMSI & " /q", 0, True
		End If
	End With
End Sub

Function DuplicateHeridCount
	Dim fn, n, bExp, aData
	If OracleInstalled < 4 Then Exit Function
	fn = "C:\TEMP\Duplikater.log"
	DeleteFile fn
	CurDir sInstallPath & "Oracle\"
	With CreateObject("WScript.Shell")
		.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & sInstallPath & "Oracle\HerDuplikater.sql", 4, True
	End With
	n = Now + TimeSerial(0, 0, 5)
	Do While Now < n
		If FileExists(fn) Then
			bExp = True
			Exit Do
		End If
	Loop
	If Not bExp Then
		DuplicateHeridCount = "Ingen data"
	Else
		aData = Filter(Split(TextFromFile(fn), vbNewLine), String(9, " "))
		aData = Filter(aData, String(12, "-"), 0)
		aData = Filter(aData, "ROLE_ENTITY_ID", 0)
		DuplicateHeridCount = Join(aData, vbNewLine)
	End If
End Function

Function Frikort
	On Error Resume Next
	If OracleInstalled < 4 Then Exit Function
	If sOracleService = "" Then sOracleService = GetEnvVar("USER", "Oracle_Service")
	If sOracleService = "" Then
		Frikort = ExitWithError(True, "Frikort: Miljvariabel for Oracle Service er ikke registrert.")
	End If
	CurDir sInstallPath & "Oracle\"
	Msg2  "Apertura", "Tilbakestiller frikort i database...", "I", 5
	With CreateObject("WScript.Shell")
		.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & sInstallPath & "Oracle\Frikort.sql", 4, True
	End With
	Msg2  "Apertura", "Tilbakestiller frikort i database...", "I", ""
	If Err.Number > 0 Then
		Frikort = ExitWithError(True, "Frikort: " & Err.Number & " " & Err.Description)
	Else
		Frikort = "Frikort ble tilbakestilt i database " & Now
	End If
End Function

Function JsonObj(sData, sKey)
	JsonObj = Mid(sData, InStr(sData, Q(sKey) & ":"))
	JsonObj = Mid(JsonObj, InStr(JsonObj, "{"))
	Do While UBound(Split(JsonObj, "}")) > UBound(Split(JsonObj, "{"))
		JsonObj = Left(JsonObj, Len(JsonObj) - 1)
		JsonObj = Left(JsonObj, InStrRev(JsonObj, "}"))
	Loop
End Function

Function JsonStr(sData, sKey)
	'Adding a ? on a quantifier (?, * or +) makes it non-greedy
	JsonStr = RegEx("\""" & sKey & "\"":? \""(.*?)\""", sData)(0)
	If JsonStr <> "" Then JsonStr = RegEx("\""(.*?)\""", JsonStr)(1)
	If JsonStr <> "" Then JsonStr = Mid(JsonStr, 2, Len(JsonStr) - 2) 'fjern anfrselstegn
End Function

Function JsonNum(sData, sKey) ' as double or empty string
	JsonNum = RegEx("\""" & sKey & "\"":? ([-|\d]+)", sData)(0) '"age": -304
	If JsonNum <> "" Then JsonNum = CDbl(LTrim(Split(JsonNum, ":")(1)))
End Function

Function ApServicesCheck
	'Sjekk apServices - returnerer liste med status for tjenester. Kan sjekkes med InStr(ApServicesCheck, 0)
	Dim aServices, i, aStatus(3)
	aServices = Array("AperturaDiskToMsgQueue", "AperturaMsgQueueToDisk", "AperturaReceiveMessage", "AperturaServices")
	For i = 0 To UBound(aServices)
		If InStr(Service(aServices(i), "", ""), "Running") = 0 Then
			aStatus(i) = Service(aServices(i), "start", "")
		Else
			aStatus(i) = True
		End If
	Next
	ApServicesCheck = Join(aStatus, ",")
End Function

Sub OppdaterTakster
	Dim sPath, sFileName
	sPath = ShareProperty("AperturaInstall", "Path") & "\Pilot_Klient\OppdaterTakster\"
	sFileName = "OppdaterTakster.cmd"
	CurDir sPath
	Msg2  "Apertura", "Oppdaterer takster...", "I", 0
	CreateObject("WScript.Shell").Run sFileName, 5, True
	Msg2  "Apertura", "Oppdaterer takster...", "I", ""
End Sub

Function Postnummer
	Dim sPath, sTmp, aText, sRet
	On Error Resume Next
	If OracleInstalled < 4 Then Exit Function
	If sOracleService = "" Then sOracleService = GetEnvVar("USER", "Oracle_Service")
	If sOracleService = "" Then
		Postnummer = ExitWithError(True, "Postnummer: Miljvariabel for Oracle Service er ikke registrert.")
	End If
	sPath = ShareProperty("AperturaInstall", "Path") & "\Pilot_Klient\Oracle\Postnummer\"
	CurDir sPath
	Msg2  "Apertura", "Oppdaterer Postnummer i database...", "I", 5
	sTmp = TmpFile("")
	With CreateObject("WScript.Shell")
		.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & sPath & "Postnr1.sql>" & sTmp, 4, True
		.Run "%COMSPEC% /c echo exit|sqlldr hl7/HL7@" & sOracleService & " control=" & sPath & "loadPostnr.ctl>" & sTmp, 4, True '"Total logical records read:          4855"
		.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & sPath & "Postnr2.sql>" & sTmp, 4, True
	End With
	Msg2  "Apertura", "Oppdaterer Postnummer i database...", "I", ""
	If Err.Number > 0 Then
		Postnummer = ExitWithError(True, "Postnummer: " & Err.Number & " " & Err.Description)
	Else
		aText = Split(TextFromFile(sTmp), vbNewLine)
		If UBound(Filter(aText, " rows created.")) = 0 Then
			sRet = Filter(aText, " rows created.")(0)
		ElseIf UBound(Filter(aText, " rader opprettet.")) = 0 Then
			sRet = Filter(aText, " rader opprettet.")(0)
		End If
		Postnummer = "Postnummer ble oppdatert i database " & Now & ": " & sRet
	End If
End Function

Function Epostadresser
	Dim sPath, sFile, str, i, m, n, a1, a2, a3
	sPath = ShareProperty("AperturaInstall", "Path") & "\Pilot_Klient\Oracle\"
	sFile = "C:\Temp\Epostadresser.txt"
	CurDir sPath
'	On Error Resume Next
	If OracleInstalled < 4 Then Exit Function
	If sOracleService = "" Then sOracleService = GetEnvVar("USER", "Oracle_Service")
	If sOracleService = "" Then
		Epostadresser = ExitWithError(True, "Epostadresser: Miljvariabel for Oracle Service er ikke registrert.")
	End If
	DeleteFile sFile
	With CreateObject("WScript.Shell")
		.Run "%COMSPEC% /c echo exit|sqlplus hl7/HL7@" & sOracleService & " @" & "Epostadresser.sql", 4, True
	End With
	str = TextFromFile(sFile)
	str = LTrim(CapW(RegExRepl("\s+", str, " ")))
'	str = Mid(str, InStr(str, "]") + 2)
	a1 = Split(str, "@")
	If UBound(a1) > -1 Then
		ReDim a2(UBound(a1))
		For i = 0 To UBound(a1) - 1
			m = InStr(a1(i + 1), " ")
			If m > 0 Then
				a2(i) = a1(i) & "@" & Left(a1(i + 1), m - 1)
				a1(i + 1) = Mid(a1(i + 1), m + 1)
				a3 = Split(a2(i), " ")
				If UBound(a3) > -1 Then
					a1(i) = ""
					For n = 1 To UBound(a3) - 1
						a1(i) = a1(i) & " " & a3(n)
					Next
					a1(i) = LTrim(a1(i)) & " " & Cap(a3(0)) & " <" & LCase(a3(UBound(a3))) & ">"
				End If
			End If
		Next
		str = ""
		For i = 0 To UBound(a1)
			If InStr(a1(i), "@") And Not InStr(str, a1(i)) Then
				str = str & vbNewLine & a1(i)
			End If
		Next
		If Len(str) > 2 Then Epostadresser = Mid(str, 3)
	End If
End Function

Function EreseptRestart
	Dim sServiceName, bRet
	sServiceName = "eResept Forskrivningsmodul Server"
	If UBound(ServiceExists(sServiceName, "")) > - 1 Then
		If Service(sServiceName, "", "") <> "Running" Then
			bRet = Service(sServiceName, "stop", "")
			If bRet = True Then
				bRet = Service(sServiceName, "start", "")
			End If
		Else
			bRet = 1
		End If
		EreseptRestart = bRet
	End If
End Function

Function StopStartApServices
	'Stopper og starter Apertura Services (4 stk)
	With CreateObject("WScript.Shell")
		.Run sInstallPath & "StopStart\StopStartAperturaServices.cmd", 1, True
	End With
End Function

Function MacToFile
	Dim sFile, aCur, aNew, i, str
	sFile = ShareProperty("AperturaInstall", "Path") & "\mac.txt"
'	aCur = Split(TextFromFile(sFile), vbNewLine)
'	aNew = Split(Cmd("arp -a"), vbNewLine)
	str = Cmd("arp -a")
	TextToFile str, sFile
	MacToFile = str
End Function

Function St_NetEyeVersions
	Dim aComputers, sComputer, i, dInstalled, sList
	aComputers = NetComputers
	On Error Resume Next
	For i = 0 To UBound(aComputers)
		sComputer = Split(aComputers(i), vbTab)(0)
		If sComputer <> "" Then
			sList = sList & vbNewLine & sComputer
			dInstalled = InstalledProgs(sComputer, "InstallDate", "EyePrivat")
			If dInstalled <> "" Then
				sList = sList & vbTab & dInstalled
			End If
		End If
	Next
	If sList = "" Then sList = "  {ERROR}"
	TextToFile Mid(sList, 3), ScriptPath & "ScriptTask.txt"
	St_NetEyeVersions = Mid(sList, 3)
End Function

Function ScriptTaskCreate
	Dim sName, sScript, sCmd, str
	sName = "Apertura\ScriptTask"
	sScript = UNCPath(ScriptPath) & AFUNCTIONS
	sCmd = "$(Arg0)"
	str = "SchTasks /F /Create /RL HIGHEST /SC DAILY /MO 365 /TN """"" & sName & """"" /TR """ & sScript & " " & sCmd & """"
	ScriptTaskCreate = Left(Cmd(str), 8) = "SUCCESS:"
'	ScriptTaskCreate = Cmd(str)
'	CreateObject("WScript.Shell").Run str
End Function

Function ScriptTaskRun(sProc, sCmd)
	'$(Arg0)
	Dim schSvr, n
	On Error Resume Next
	DeleteFile ScriptPath & "ScriptTask.txt"
	If Not SchTaskExists("ScriptTask") Then ScriptTaskCreate
	Set schSvr = CreateObject("Schedule.Service")
	With schSvr
		.Connect
		.GetFolder("\Apertura").GetTask("ScriptTask").Run "" & sProc & " """ & sCmd & """"
	End With
	Set schSvr = Nothing
	n = Now + TimeSerial(0, 3, 0)
	Do While Not FileExists(ScriptPath & "ScriptTask.txt") And Now < n
		WScript.Sleep 1000
	Loop
	ScriptTaskRun = TextFromFile(ScriptPath & "ScriptTask.txt")
End Function

Function St_EyeVersions
	Dim aComputers, i, sComputer, sList, dDateMod
	aComputers = Filter(Split(CmdNor("net view"), vbNewLine), "\\")
	On Error Resume Next
	For i = 0 To UBound(aComputers)
		sComputer = Split(aComputers(i), " ")(0)
		If sComputer <> "" Then
			sList = sList & vbNewLine & Mid(sComputer, 3)
			dDateMod = FileModified(sComputer & "\c$\Program Files (x86)\Apertura\EyePrivat\Eye40.exe")
			If dDateMod = "" Then
				dDateMod = FileModified(sComputer & "\c$\Program Files\Apertura\EyePrivat\Eye40.exe")
			End If
			If dDateMod <> "" Then
				sList = sList & vbTab & dDateMod
			End If
		End If
	Next
	If sList <> "" Then sList = Mid(sList, 3)
	TextToFile Mid(sList, 3), ScriptPath & "ScriptTask.txt"
	St_EyeVersions = Mid(sList, 3)
End Function

Sub ShowWindow(appName, titlePattern)
'@description: Bring a window to the front and activate it.
'@author: Jeremy England (SimplyCoded)
  With CreateObject("WScript.Shell")
    .run "powershell -Command ""$type = Add-Type -MemberDefinition '[DllImport(\""user32.dll\"")] " & _ 
     "public static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);[DllImport(\""user32.dll\"")] " & _
     "public static extern int SetForegroundWindow(IntPtr hwnd);' -Name WindowAPI -PassThru;$hwnd = (Get-Process " & _
     appName & " | where MainWindowTitle -match '" & titlePattern & "').MainWindowHandle;" & _
     "&null = $type::ShowWindowAsync($hwnd, 4);$null = $type::SetForegroundWindow($hwnd)""", 0, True
  End With 
End Sub

Function FM_FEST
	Dim sFileName, sSep, objConnection, objRecordSet, sCmd, i, str, sMc
	Const adOpenStatic = 3
	Const adLockOptimistic = 3
	FM_FEST = False
	On Error Resume Next
	Set objConnection = CreateObject("ADODB.Connection")
	Set objRecordSet = CreateObject("ADODB.Recordset")
	objConnection.Open _
	    "Provider=SQLOLEDB;Data Source=LOCALHOST\SQLEXPRESS;Trusted_Connection=Yes;Initial Catalog=FM;User ID=SA;Password=SqlAdminPwd123;"
	If objConnection.State <> 1 Then
		AppendTextToFile "KAN IKKE OPPRETTE FORBINDELSE TIL DATABASE", sFileName
		Exit Function
	End If
	With objRecordSet
		sCmd = "SELECT * FROM dbo.FestUpdateLog"
		.Open sCmd, objConnection, adOpenStatic, adLockOptimistic
		If .RecordCount > 0 Then
			.MoveLast
			For i = .RecordCount To 1 Step -1
				If .Fields("WasUpdateSuccessful").Value = True Then
					FM_FEST = .Fields("FestUpdateTime").Value
					Exit For
				End If
				.MovePrevious
			Next
		End If
		.Close
	End With
	If Err.Number > 0 Then FM_FEST = "ERROR: " & Err.Number & vbTab & Err.Description
End Function

'MsgBox "slutt"
